<#--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<html>
<head>
  <title>Mango, by Serotonin</title>
  
  <!-- Meta -->
  <meta http-equiv="content-type" content="application/xhtml+xml;charset=utf-8"/>
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <meta name="Copyright" content="&copy;2006-2007 Serotonin Software Technologies Inc."/>
  <meta name="DESCRIPTION" content="Mango Serotonin Software"/>
  <meta name="KEYWORDS" content="Mango Serotonin Software"/>
  
  <!-- Style -->
  <link rel="icon" href="images/favicon.ico"/>
  <link rel="shortcut icon" href="images/favicon.ico"/>
  <style type="text/css">
    .bod {
      margin: 10px;
      padding: 5px;
      background-color: #FFFFFF;
    }
    .bod, td, th {
      font-family: Verdana, Arial, Helvetica, sans-serif;
      font-size: 11px;
      color: #000000;
    }
    .pointName {
      color: #804000;
      font-size: 13px;
      font-weight: bold;
    }
    .label {
      font-weight: bold;
      text-align: right;
      padding-right: 10px;
    }
    .stats {
      background-color: #F0F0F0;
      vertical-align: top;
    }
  </style>
</head>

<body>
<div class="bod">
  <table width="100%" cellspacing="0" cellpadding="0" border="0">
    <tr>
      <td>
        <table>
          <tr>
            <td colspan="2"><h1>${instance.name}</h1></td>
          </tr>
          <tr>
            <td class="label">Run time start</td>
            <td>${instance.prettyRunStartTime}</td>
          </tr>
          <tr>
            <td class="label">Run duration</td>
            <td>${instance.prettyRunDuration}</td>
          </tr>
          <tr>
            <td class="label">Date range</td>
            <td>${instance.prettyReportStartTime} to ${instance.prettyReportEndTime}</td>
          </tr>
          <tr>
            <td class="label">Records</td>
            <td>${instance.prettyRecordCount}</td>
          </tr>
        </table>
      </td>
      <td valign="top" align="right"><img src="${inline}images/mangoLogoMed.jpg" alt="Logo"/></td>
    </tr>
  </table>

  <h2>Statistics</h2>
  <table cellspacing="5">
    <#assign col = 2/>
    <#list points as point>
      <#assign col = col + 1/>
      <#if col == 3><#assign col = 0/></#if>
      <#if col == 0><tr></#if>
      
      <td class="stats">
        <table>
          <tr><td colspan="2" class="pointName">${point.name}</td></tr>
          <tr>
            <td class="label">Type</td>
            <td>${point.dataTypeDescription}</td>
          </tr>
          <#if point.startValue??>
            <tr>
              <td class="label">Start value</td>
              <td>${point.startValue}</td>
            </tr>
          </#if>
          <#if point.dataType == NUMERIC>
            <tr>
              <td class="label">Minimum</td>
              <td>${point.analogMinimum} @ ${point.analogMinTime}</td>
            </tr>
            <tr>
              <td class="label">Maximum</td>
              <td>${point.analogMaximum} @ ${point.analogMaxTime}</td>
            </tr>
            <tr>
              <td class="label">Average</td>
              <td>${point.analogAverage}</td>
            </tr>
            <tr>
              <td class="label">Sum</td>
              <td>${point.analogSum}</td>
            </tr>
            <tr>
              <td class="label">Count</td>
              <td>${point.analogCount}</td>
            </tr>
          <#elseif point.dataType == BINARY || point.dataType == MULTISTATE>
            <tr>
              <td colspan="2">
                <table>
                  <tr style="padding-top:15px">
                    <th>Value</th>
                    <th>Starts</th>
                    <th>Runtime</th>
                  </tr>
                  
                  <#list point.startsAndRuntimes as sar>
                    <tr>
                      <td>${sar.value}</td>
                      <td align="right">${sar.starts}</td>
                      <td align="right">${sar.runtime}</td>
                    </tr>
                  </#list>
                </table>
              </td>
            </tr>
          <#elseif point.dataType == ALPHANUMERIC>
            <tr>
              <td class="label">Count</td>
              <td>${point.valueChangeCount}</td>
            </tr>
          </#if>
        </table>
      </td>
      
      <#if col == 2></tr></#if>
    </#list>
    <#if col < 2></tr></#if>
  </table>
  
  <#if chartName??>
    <h2>Chart</h2>
    <img src="${inline}${chartName}"/>
  </#if>
</div>

<table width="100%" cellspacing="0" cellpadding="0" border="0">
  <tr><td colspan="2">&nbsp;</td></tr>
  <tr>
    <td colspan="2" class="footer" align="center">&copy;2006-2007 Serotonin Software Technologies Inc., all rights reserved</td>
  </tr>
</table>

</body>
</html>