<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.Common"%>
<%@page import="com.serotonin.mango.rt.event.AlarmLevels"%>

<mango:header onload="init()">
  <mango:script src='dwr/interface/CompoundEventsDwr.js'/>
  <mango:script>
    <script>
    function init() {
        CompoundEventsDwr.getInitData(initCB);
        dojo.event.topic.subscribe("eventTypeTree/titleClick", new TreeClickHandler(), 'handle');
    }
    
    var editingCompoundEvent;
    function initCB(data) {
        // List the compound events.
        for (var i=0; i<data.compoundEvents.length; i++) {
            appendCompoundEvent(data.compoundEvents[i].id);
            updateCompoundEvent(data.compoundEvents[i]);
        }
        
        // Create the tree of event detectors
        var i, j;
        var dp, et;
        var pointNode;
        
        var pointRoot = dojo.widget.manager.getWidgetById('rootPoint');
        for (i=0; i<data.dataPoints.length; i++) {
            dp = data.dataPoints[i];
            pointNode = dojo.widget.createWidget("TreeNode", {title: "<img src='images/icon_comp.png'/> "+ dp.name});
            pointRoot.addChild(pointNode);
            
            for (j=0; j<dp.eventTypes.length; j++) {
                et = dp.eventTypes[j];
                createEventTypeNode("ped"+ et.typeRef2, et, pointNode);
            }
        }
        pointRoot.expand();
        
        var scheduledRoot = dojo.widget.manager.getWidgetById('rootScheduled');
        for (i=0; i<data.scheduledEvents.length; i++) {
            et = data.scheduledEvents[i];
            createEventTypeNode("sch"+ et.typeRef1, et, scheduledRoot);
        }
        scheduledRoot.expand();
        
        // Default the selection of the parameter was provided.
        <c:if test="${!empty param.cedid}">
          showCompoundEvent(${param.cedid});
        </c:if>
    }
    
    function createEventTypeNode(widgetId, eventType, parent) {
        var node = dojo.widget.createWidget("TreeNode", {
                title: "<img id='"+ widgetId +"Img'/> "+ eventType.description +" ("+ eventType.eventDetectorKey +")",
                widgetId: widgetId,
                object: eventType.eventDetectorKey
        });
        parent.addChild(node);
        setAlarmLevelImg(eventType.alarmLevel, $(widgetId +"Img"));
    }
    
    var TreeClickHandler = function() {
        this.handle = function(message) {
            var widget = message.source;
            var wid = widget.widgetId;
            if (wid.startsWith("ped") || wid.startsWith("sch"))
                insertText(widget.object);
        }
    }
    
    function showCompoundEvent(cedId) {
        if (editingCompoundEvent)
            stopImageFader($("ced"+ editingCompoundEvent.id +"Img"));
        CompoundEventsDwr.getCompoundEvent(cedId, showCompoundEventCB);
        startImageFader($("ced"+ cedId +"Img"));
        
        if (cedId == <%= Common.NEW_ID %>)
            hide($("deleteCompoundEventImg"));
        else
            show($("deleteCompoundEventImg"));
    }
    
    function showCompoundEventCB(ced) {
        if (!editingCompoundEvent) {
            show($("compoundEventDetails"));
            show($("eventTypes"));
        }
        editingCompoundEvent = ced;
        
        $set("name", ced.name);
        $set("alarmLevel", ced.alarmLevel);
        $set("rtn", ced.returnToNormal);
        $set("condition", ced.condition);
        $set("disabled", ced.disabled);
        
        setUserMessage();
    }
    
    function saveCompoundEvent() {
        setUserMessage();
        CompoundEventsDwr.saveCompoundEvent(editingCompoundEvent.id, $get("name"), $get("alarmLevel"), $get("rtn"), 
                $get("condition"), $get("disabled"), saveCompoundEventCB);
    }
    
    function saveCompoundEventCB(result) {
        if (result.errorMessage)
            validateCB(result);
        else {
            if (editingCompoundEvent.id == <%= Common.NEW_ID %>) {
                stopImageFader($("ced"+ editingCompoundEvent.id +"Img"));
                editingCompoundEvent.id = result.cedId;
                appendCompoundEvent(editingCompoundEvent.id);
                startImageFader($("ced"+ editingCompoundEvent.id +"Img"));
                setUserMessage("Compound event detector added");
                show($("deleteCompoundEventImg"));
            }
            else
                setUserMessage("Compound event detector saved");
            
            if (result.warningMessage)
                setUserMessage(result.warningMessage);
                
            CompoundEventsDwr.getCompoundEvent(editingCompoundEvent.id, updateCompoundEvent)
        }
    }
    
    function setUserMessage(message) {
        if (message) {
            show($("userMessage"));
            $("userMessage").innerHTML = message;
        }
        else
            hide($("userMessage"));
    }
    
    function appendCompoundEvent(cedId) {
        createFromTemplate("ced_TEMPLATE_", cedId, "compoundEventsTable");
    }
    
    function updateCompoundEvent(ced) {
        $("ced"+ ced.id +"Name").innerHTML = ced.name;
        setCompoundEventImg(ced.disabled, $("ced"+ ced.id +"Img"));
    }
    
    function deleteCompoundEvent() {
        CompoundEventsDwr.deleteCompoundEvent(editingCompoundEvent.id, deleteCompoundEventCB);
    }
    
    function deleteCompoundEventCB() {
        stopImageFader($("ced"+ editingCompoundEvent.id +"Img"));
        $("compoundEventsTable").removeChild($("ced"+ editingCompoundEvent.id));
        hide($("compoundEventDetails"));
        hide($("eventTypes"));
        editingCompoundEvent = null;
    }
    
    function updateAlarmLevelImage(alarmLevel) {
        setAlarmLevelImg(alarmLevel, $("alarmLevelImg"));
    }
    
    function validate() {
        setUserMessage();
        CompoundEventsDwr.validateCondition($get("condition"), validateCB);
    }
    
    function validateCB(result) {
        if (!result)
            setUserMessage("Condition validated ok");
        else {
            setUserMessage(result.errorMessage);
            if (result.range)
                setSelectionRange($("condition"), result.from, result.to);
        }
    }
    
    function insertText(text) {
        insertIntoTextArea($("condition"), text);
    }
    </script>
  </mango:script>
</mango:header>

<table>
  <tr>
    <td rowspan="2" valign="top">
      <div class="borderDiv">
        <table width="100%">
          <tr>
            <td>
              <span class="smallTitle">Compound event detectors</span>
              <mango:help id="xloTnHGVCn3ed9NqsmU3"/>
            </td>
            <td align="right"><img src="images/multi_bell_add.png" class="ptr" title="Add compound event detector" 
                    onclick="showCompoundEvent(<%= Common.NEW_ID %>)" id="ced<%= Common.NEW_ID %>Img"/></td>
          </tr>
        </table>
        <table id="compoundEventsTable">
          <tbody id="ced_TEMPLATE_" onclick="showCompoundEvent(getMangoId(this))" class="ptr" style="display:none;">
            <tr>
              <td><img id="ced_TEMPLATE_Img" src="images/multi_bell.png" title="Compound event detector"
                      alt="Compound event detector"/></td>
              <td class="link" id="ced_TEMPLATE_Name"></td>
            </tr>
          </tbody>
        </table>
      </div>
    </td>

    <td valign="top" style="display:none;" id="compoundEventDetails">
      <div class="borderDiv">
        <table width="100%">
          <tr>
            <td><span class="smallTitle">Compound event detector details</span></td>
            <td align="right">
              <img src="images/save.png" onclick="saveCompoundEvent();" class="ptr" title="Save"/>
              <img id="deleteCompoundEventImg" src="images/delete.png" onclick="deleteCompoundEvent();" class="ptr" 
                      title="Delete"/>
            </td>
          </tr>
        </table>

        <table>
          <tr>
            <td class="formLabelRequired">Name</td>
            <td class="formField"><input type="text" id="name"/></td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Alarm level</td>
            <td class="formField">
              <select id="alarmLevel" onchange="updateAlarmLevelImage(this.value)">
                <option value="<%= AlarmLevels.NONE %>"><%=AlarmLevels.NONE_DESCRIPTION%></option>
                <option value="<%= AlarmLevels.INFORMATION %>"><%=AlarmLevels.INFORMATION_DESCRIPTION%></option>
                <option value="<%= AlarmLevels.URGENT %>"><%=AlarmLevels.URGENT_DESCRIPTION%></option>
                <option value="<%= AlarmLevels.CRITICAL %>"><%=AlarmLevels.CRITICAL_DESCRIPTION%></option>
                <option value="<%= AlarmLevels.LIFE_SAFETY %>"><%=AlarmLevels.LIFE_SAFETY_DESCRIPTION%></option>
              </select>
              <img id="alarmLevelImg" src="images/flag_green.png" alt="None" title="None" style="display:none;"/>
            </td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Return to normal</td>
            <td class="formField"><input type="checkbox" id="rtn"/></td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">
              Condition
              <img src="images/accept.png" onclick="validate();" class="ptr" title="Validate" alt="Validate"/><br/>
              <br/>
              <a href="#" onclick="insertText(' && '); return false;">and</a><br/>
              <a href="#" onclick="insertText(' || '); return false;">or</a><br/>
              <a href="#" onclick="insertText('!'); return false;">not</a><br/>
            </td>
            <td class="formField"><textarea rows="10" cols="60" id="condition"></textarea></td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Disabled</td>
            <td class="formField"><input type="checkbox" id="disabled"/></td>
          </tr>
        </table>
        
        <table>
          <tr>
            <td colspan="2" id="userMessage" class="formError" style="display:none;"></td>
          </tr>
        </table>
      </div>
    </td>
  </tr>
  
  <tr>
    <td valign="top" style="display:none;" id="eventTypes">
      <div class="borderDivPadded">
        <span class="smallTitle">Event types</span>
        <div dojoType="TreeBasicController" widgetId="controller"></div>
        <div id="tree">
          <div dojoType="Tree" widgetId="eventTypeTree" listeners="controller" toggle="wipe">
            <div dojoType="TreeNode" title="Point event detectors" widgetId="rootPoint"></div>
            <div dojoType="TreeNode" title="Scheduled events" widgetId="rootScheduled"></div>
          </div>
        </div>
      </div>
    </td>
  </tr>
</table>

<mango:footer/>