<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.vo.UserComment"%>
<%@page import="com.serotonin.mango.Common"%>
<mango:header onload="init()">
  <mango:script src='dwr/interface/DataPointDetailsDwr.js'/>
  <mango:script src='resources/view.js'/>
  <mango:script>
    <script>
    function init() {
        getHistoryTableData();
        mango.view.startPointDetails(2000);
        <c:if test="${!empty periodType}">
          getImageChart();
        </c:if>
        getStatsChart();
    }
    
    //
    // History
    //
    function getHistoryTableData() {
        var limit = parseInt($get("historyLimit"));
        if (isNaN(limit))
            alert("Record count must be a number");
        else {
            DataPointDetailsDwr.getHistoryTableData(limit, getHistoryTableDataCB);
            startImageFader($("historyLimitImg"));
        }
    }
    
    function getHistoryTableDataCB(data) {
        dwr.util.removeAllRows("historyTableData");
        if (!data || data.length == 0)
            dwr.util.addRows("historyTableData", ["(no data)"], [function(data) { return data; }]);
        else {
            dwr.util.addRows("historyTableData", data,
                [
                    function(data) { return data.value; },
                    function(data) { return data.time; },
                    function(data) { return data.annotation; }
                ],
                {
                    rowCreator:function(options) {
                        var tr = document.createElement("tr");
                        tr.className = "row"+ (options.rowIndex % 2 == 0 ? "" : "Alt");
                        return tr;
                    }
                });
        }
        stopImageFader($("historyLimitImg"));
    }
    
    //
    // Image chart
    //
    function getImageChart() {
        var period = parseInt($get("imageChartDuration"));
        var periodType = parseInt($get("imageChartDurationType"));
        var width = dojo.html.getContentBox($("imageChartDiv")).width - 20;
        
        if (isNaN(period))
            alert("Time period must be a number");
        else {
            DataPointDetailsDwr.getImageChartData(periodType, period, width, 200, getImageChartCB);
            startImageFader($("imageChartImg"));
        }
    }
    
    function getImageChartCB(data) {
        $("imageChartDiv").innerHTML = data;
        stopImageFader($("imageChartImg"));
    }
    
    //
    // Stats chart
    //
    function getStatsChart() {
        var period = parseInt($get("statsChartDuration"));
        var periodType = parseInt($get("statsChartDurationType"));
        
        if (isNaN(period))
            alert("Time period must be a number");
        else {
            DataPointDetailsDwr.getStatsChartData(periodType, period, true, getStatsChartCB);
            startImageFader($("statsChartImg"));
        }
    }
    
    function getStatsChartCB(data) {
        $("statsChartData").innerHTML = data;
        stopImageFader($("statsChartImg"));
    }
    
    
    function togglePanel(img, panelId) {
        if (!img.minimized) {
            img.src = "images/arrow_out.png";
            img.title = "Maximize";
            dojo.html.hide(panelId);
            img.minimized = true;
        }
        else {
            img.src = "images/arrow_in.png";
            img.title = "Minimize";
            dojo.html.show(panelId);
            img.minimized = false;
        }
    }
    </script>
  </mango:script>
</mango:header>

<table width="100%" cellspacing="0" cellpadding="0">
  <tr>
    <td valign="top">
      <div class="borderDiv marB marR">
        <table>
          <tr><td class="smallTitle" colspan="2">
            <img src="images/icon_comp.png" alt="Point" title="Point"/>
            ${point.name}
            <c:if test="${pointEditor}">
              <a href="data_point_edit.shtm?dpid=${point.id}"><img src="images/icon_comp_edit.png" border="0"
                      title="Edit data point" alt=""/></a>
              <a href="data_source_edit.shtm?dsid=${point.dataSourceId}&pid=${point.id}"><img 
                      src="images/icon_ds_edit.png" border="0" title="Edit data source" alt=""/></a>
            </c:if>
          </td></tr>
          <tr>
            <td class="formLabelRequired">Value</td>
            <td id="pointValue" colspan="2" class="formField"></td>
          </tr>
          <tr>
            <td class="formLabelRequired">Time</td>
            <td id="pointValueTime" colspan="2" class="formField"></td>
          </tr>
          <tr id="pointChangeNode" style="display:none">
            <td class="formLabelRequired">
              <img id="pointChanging" src="images/icon_edit.png" title="Set point"/> Set
            </td>
            <td id="pointChange" colspan="2" class="formField"></td>
          </tr>
          <tr id="pointDisabled" style="display:none">
            <td colspan="2">
              <img src="images/warn.png" alt="Warning" title="Warning"/>
              The point or its data source may be disabled.
            </td>
          </tr>
        </table>
      </div>
      
      <div class="borderDiv marB marR">
        <table width="100%">
          <tr>
            <td class="smallTitle">Statistics</td>
            <td align="right">
              Time period:
              <input id="statsChartDuration" style="text-align:right;" type="text" class="formVeryShort"
                      value='${empty periodCount ? "1" : periodCount}'/>
              <sst:select id="statsChartDurationType" value="${periodType}">
                <sst:option value="<%= Integer.toString(Common.TimePeriods.MINUTES) %>">Minute(s)</sst:option>
                <sst:option value="<%= Integer.toString(Common.TimePeriods.HOURS) %>">Hour(s)</sst:option>
                <sst:option value="<%= Integer.toString(Common.TimePeriods.DAYS) %>">Day(s)</sst:option>
                <sst:option value="<%= Integer.toString(Common.TimePeriods.WEEKS) %>">Week(s)</sst:option>
                <sst:option value="<%= Integer.toString(Common.TimePeriods.MONTHS) %>">Month(s)</sst:option>
              </sst:select>
              <img id="statsChartImg" src="images/control_play_blue.png" title="Get statistics" alt="" class="ptr" 
                      onclick="getStatsChart()"/>
            </td>
          </tr>
        </table>
        <div id="statsChartData" style="padding:0px 0px 5px 5px;"></div>
      </div>
    </td>
    
    <td valign="top">
      <div class="borderDiv marB marR">
        <table width="100%">
          <tr>
            <td class="smallTitle">History</td>
            <td align="right">
              Show 
              <input id="historyLimit" type="text" style="text-align:right;" value="${historyLimit}"
                      class="formVeryShort"/>
              most recent records
              <img id="historyLimitImg" src="images/control_play_blue.png" title="Get data" alt="" class="ptr" 
                      onclick="getHistoryTableData()"/>
            </td>
          </tr>
        </table>
        <table cellspacing="1">
          <tr class="rowHeader">
            <td>Value</td>
            <td>Time</td>
            <td>Annotation</td>
          </tr>
          <tbody id="historyTableData"></tbody>
        </table>
      </div>
    </td>
    
    <td valign="top">
      <div class="borderDiv marB">
        <table width="100%">
          <tr>
            <td class="smallTitle">User notes</td>
            <td align="right">
              <img src="images/comment_add.png" alt="" title="Add comment" class="ptr"
                      onclick="openCommentDialog(<%= UserComment.TYPE_POINT %>, ${point.id})"/>
            </td>
          </tr>
        </table>
        <table id="pointComments${point.id}">
          <c:forEach items="${point.comments}" var="comment">
            <tr>
              <td valign="top" width="16"><img src="images/comment.png" title="Comment" alt="Comment"/></td>
              <td valign="top">
                <span class="copyTitle">${comment.prettyTime} by ${comment.username}</span><br/>
                ${comment.comment}
              </td>
            </tr>
          </c:forEach>
        </table>
      </div>
    </td>
  </tr>
  
  <c:if test="${!empty periodType}">
    <tr>
      <td colspan="3">
        <!--  chart with editable properties and annotations -->
        <div class="borderDiv marB">
          <table width="100%">
            <tr>
              <td class="smallTitle">Chart</td>
              <td align="right">
                Time period:
                <input id="imageChartDuration" style="text-align:right;" type="text" value="${periodCount}"
                        class="formVeryShort"/>
                <sst:select id="imageChartDurationType" value="${periodType}">
                  <sst:option value="<%= Integer.toString(Common.TimePeriods.MINUTES) %>">Minute(s)</sst:option>
                  <sst:option value="<%= Integer.toString(Common.TimePeriods.HOURS) %>">Hour(s)</sst:option>
                  <sst:option value="<%= Integer.toString(Common.TimePeriods.DAYS) %>">Day(s)</sst:option>
                  <sst:option value="<%= Integer.toString(Common.TimePeriods.WEEKS) %>">Week(s)</sst:option>
                  <sst:option value="<%= Integer.toString(Common.TimePeriods.MONTHS) %>">Month(s)</sst:option>
                </sst:select>
                <img id="imageChartImg" src="images/control_play_blue.png" title="Get chart" alt="" class="ptr" 
                        onclick="getImageChart()"/>
              </td>
            </tr>
            <tr><td colspan="2" id="imageChartDiv"></td></tr>
          </table>
        </div>
      </td>
    </tr>
  </c:if>

  <tr>
    <td colspan="3">
      <div class="borderDiv marB">
        <table width="100%">
          <tr>
            <td class="smallTitle">Events</td>
            <td align="right">
              <img src="images/arrow_in.png" title="Minimize" class="ptr" onclick="togglePanel(this, 'eventsTable');"/>
              <a href=""><img src="images/control_repeat_blue.png" border="0" title="Refresh" alt=""/></a>
            </td>
          </tr>
        </table>
        <table id="eventsTable" cellspacing="1" cellpadding="0" width="100%">
          <tr class="rowHeader">
            <td>Id</td>
            <td>Alarm level</td>
            <td>Active time</td>
            <td>Message</td>
            <td>Status</td>
          </tr>
          
          <c:forEach items="${events}" var="event" varStatus="status" end="19">
            <tr class="row${status.index % 2 == 0 ? "" : "Alt"}">
              <td align="center">${event.id}</td>
              <td align="center"><%@ include file="/WEB-INF/snippet/eventIcon.jsp" %></td>
              <td>${sst:time(event.activeTimestamp)}</td>
              <td>
                <table cellspacing="0" cellpadding="0" width="100%">
                  <tr>
                    <td><b>${event.message}</b></td>
                    <td align="right"><img src="images/comment_add.png" title="Add comment" alt="Add comment"
                            onclick="openCommentDialog(<%= UserComment.TYPE_EVENT %>, ${event.id})" class="ptr"/></td>
                  </tr>
                </table>
                <table cellspacing="0" cellpadding="0" id="eventComments${event.id}">
                  <c:forEach items="${event.eventComments}" var="comment">
                    <tr>
                      <td valign="top" width="16"><img src="images/comment.png" title="Comment" alt="Comment"/></td>
                      <td valign="top">
                        <span class="copyTitle">${comment.prettyTime} by ${comment.username}</span><br/>
                        ${comment.comment}
                      </td>
                    </tr>
                  </c:forEach>
                </table>
              </td>
              <td>
                <c:choose>
                  <c:when test="${event.active}">
                    Active
                    <a href="events.shtm"><img src="images/flag_white.png" title="active" alt="active" border="0"/></a>
                  </c:when>
                  <c:otherwise>
                    ${sst:time(event.inactiveTimestamp)} - ${event.inactiveDescription}
                  </c:otherwise>
                </c:choose>
              </td>
            </tr>
          </c:forEach>
          <c:if test="${sst:size(events) > 20}">
            <tr class="row"><td align="center" colspan="5">Maximum 20 events displayed of ${sst:size(events)}</td></tr>
          </c:if>
          <c:if test="${empty events}">
            <tr class="row"><td colspan="5">No events to list</td></tr>
          </c:if>
        </table>
      </div>
    </td>
  </tr>
  
  <tr>
    <td valign="top">
      <div class="borderDiv marR">
        <span class="smallTitle" style="margin:3px;">Views</span>
        <table width="100%" cellspacing="1">
          <tr class="rowHeader">
            <td>Name</td>
            <td></td>
          </tr>
          <c:forEach items="${views}" var="view" varStatus="status">
            <tr class="row${status.index % 2 == 0 ? "" : "Alt"}">
              <td>${view.name}</td>
              <td align="center"><a href="views.shtm?viewId=${view.id}"><img src="images/icon_view.png" 
                      alt="Go to view" title="To to view" border="0"/></a></td>
            </tr>
          </c:forEach>
          <c:if test="${empty views}">
            <tr class="row"><td colspan="2">Point is not used in any of your graphical views</td></tr>
          </c:if>
        </table>
      </div>
    </td>
      
    <td colspan="2" valign="top">
      <div class="borderDiv">
        <span class="smallTitle" style="margin:3px;">User access</span>
        <table width="100%" cellspacing="1">
          <tr class="rowHeader">
            <td width="16"></td>
            <td>Username</td>
            <td>Access type</td>
          </tr>
          <c:forEach items="${users}" var="userData" varStatus="status">
            <tr class="row${status.index % 2 == 0 ? "" : "Alt"}">
              <c:set var="user" value="${userData.user}"/>
              <td><%@ include file="/WEB-INF/snippet/userIcon.jsp" %></td>
              <td>${user.username}</td>
              <td>
                <c:choose>
                  <c:when test="${userData.accessType == applicationScope['constants.Permissions.DataPointAccessTypes.READ']}">read</c:when>
                  <c:when test="${userData.accessType == applicationScope['constants.Permissions.DataPointAccessTypes.SET']}">set</c:when>
                  <c:when test="${userData.accessType == applicationScope['constants.Permissions.DataPointAccessTypes.DATA_SOURCE']}">data source</c:when>
                  <c:when test="${userData.accessType == applicationScope['constants.Permissions.DataPointAccessTypes.ADMIN']}">admin</c:when>
                  <c:otherwise>unknown (${userData.accessType})</c:otherwise>
                </c:choose>
              </td>
            </tr>
          </c:forEach>
        </table>
      </div>
    </td>
  </tr>
</table>

<%@ include file="/WEB-INF/jsp/include/userComment.jsp" %>

<mango:footer/>