<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.Common"%>

<mango:header>
  <mango:script src='dwr/interface/DataSourceEditDwr.js'/>
</mango:header>

<script type="text/javascript">
  var currentPoint;
  var pointListColumnFunctions = new Array();
  var pointListOptions;
  
  function init() {
      var pointListColumnHeaders = new Array();
      
      pointListColumnHeaders[pointListColumnHeaders.length] = "Name";
      pointListColumnFunctions[pointListColumnFunctions.length] = function(p) { return "<b>"+ p.name +"</b>"; };
      
      pointListColumnHeaders[pointListColumnHeaders.length] = "Data type";
      pointListColumnFunctions[pointListColumnFunctions.length] = function(p) { return p.dataTypeDescription; };
      
      pointListColumnHeaders[pointListColumnHeaders.length] = "Status";
      pointListColumnFunctions[pointListColumnFunctions.length] = function(p) {
              var id = "toggleImg"+ p.id;
              var onclick = "togglePoint("+ p.id +")";
              if (p.enabled)
                  return writeImage(id, null, "brick_go", "Enabled - click to disable", onclick);
              return writeImage(id, null, "brick_stop", "Disabled - click to enable", onclick);
      };
      
      if (typeof appendPointListColumnFunctions == 'function')
          appendPointListColumnFunctions(pointListColumnHeaders, pointListColumnFunctions);
      
      pointListColumnHeaders[pointListColumnHeaders.length] = "";
      pointListColumnFunctions[pointListColumnFunctions.length] = function(p) {
              return writeImage("editImg"+ p.id, null, "icon_comp_edit", "Edit point", "editPoint("+ p.id +")");
      };
      
      var headers = $("pointListHeaders");
      var td;
      for (var i=0; i<pointListColumnHeaders.length; i++) {
          td = document.createElement("td");
          if (typeof(pointListColumnHeaders[i]) == "string")
              td.innerHTML = pointListColumnHeaders[i];
          else
              pointListColumnHeaders[i](td);
          headers.appendChild(td);
      }
      
      pointListOptions = {
              rowCreator: function(options) {
                  var tr = document.createElement("tr");
                  tr.mangoId = "p"+ options.rowData.id;
                  tr.className = "row"+ (options.rowIndex % 2 == 0 ? "" : "Alt");
                  return tr;
              },
              cellCreator: function(options) {
                  var td = document.createElement("td");
                  if (options.cellNum == 2)
                      td.align = "center";
                  return td;
              }
      };
      
      var dsStatus = $("dsStatusImg");
      setDataSourceStatusImg(${dataSource.enabled}, dsStatus);
      hide(dsStatus);
      
      if (typeof initImpl == 'function') initImpl();
      
      DataSourceEditDwr.editInit(initCB);
      showMessage("dataSourceMessage");
      showMessage("pointMessage");
  }
  dojo.addOnLoad(init);
  
  function initCB(response) {
      writePointList(response.data.points);
      writeAlarms(response.data.alarms);
      
      // Default the selection if the parameter was provided.
      <c:if test="${!empty param.pid}">
        editPoint(${param.pid});
      </c:if>
  }
  
  function saveDataSource() {
      startImageFader("dsSaveImg", true);
      hideContextualMessages($("dataSourceProperties"));
      saveDataSourceImpl();
  }
  
  function saveDataSourceCB(response) {
      stopImageFader("dsSaveImg");
      if (response.hasMessages)
          showDwrMessages(response.messages, "dataSourceGenericMessages");
      else {
          showMessage("dataSourceMessage", "Data source has been saved");
          DataSourceEditDwr.getPoints(writePointList);
      }
      getAlarms();
  }
  
  function toggleDataSource() {
      var imgNode = $("dsStatusImg");
      if (!hasImageFader(imgNode)) {
          DataSourceEditDwr.toggleEditDataSource(toggleDataSourceCB);
          startImageFader(imgNode);
      }
  }
  
  function toggleDataSourceCB(result) {
      var imgNode = $("dsStatusImg");
      stopImageFader(imgNode);
      setDataSourceStatusImg(result.enabled, imgNode);
      getAlarms();
  }
  
  function togglePoint(pointId) {
      DataSourceEditDwr.togglePoint(pointId, togglePointCB);
      startImageFader("toggleImg"+ pointId, true);
  }
  
  function togglePointCB(response) {
      stopImageFader("toggleImg"+ response.data.id);
      writePointList(response.data.points);
  }
  
  function deletePoint() {
      if (confirm("Are you sure you wish to delete this point?")) {
          DataSourceEditDwr.deletePoint(currentPoint.id, deletePointCB);
          startImageFader("pointDeleteImg", true);
      }
  }
  
  function deletePointCB(points) {
      stopImageFader("pointDeleteImg");
      hide("pointDetails");
      currentPoint = null;
      writePointList(points);
  }
  
  function writePointList(points) {
      if (typeof writePointListImpl == 'function') writePointListImpl(points);
      
      if (!points)
          return;
      show("pointProperties");
      show("alarmsTable");
      show("dsStatusImg");
  
      if (currentPoint)
          stopImageFader("editImg"+ currentPoint.id);
      dwr.util.removeAllRows("pointsList");
      dwr.util.addRows("pointsList", points, pointListColumnFunctions, pointListOptions);
  }
  
  function addPoint(ref) {
      if (!dojo.html.isShowing("pointProperties")) {
          alert("Save the data source before adding points");
          return;
      }
      
      if (currentPoint)
          stopImageFader("editImg"+ currentPoint.id);
      
      startImageFader("editImg"+ <%= Common.NEW_ID %>);
      hideContextualMessages("pointProperties");
      
      addPointImpl(ref);
  }
  
  function editPoint(pointId) {
      if (currentPoint)
          stopImageFader("editImg"+ currentPoint.id);
      DataSourceEditDwr.getPoint(pointId, editPointCB);
      hideContextualMessages("pointProperties");
  }
  
  function editPointCB(point) {
      currentPoint = point;
      display("pointDeleteImg", point.id != <%= Common.NEW_ID %>);
      var locator = currentPoint.pointLocator;
      
      $set("name", currentPoint.name);
      var cancel;
      if (typeof editPointCBImpl == 'function') cancel = editPointCBImpl(locator);
      if (!cancel) {
          startImageFader("editImg"+ point.id);
          show("pointDetails");
      }
  }
  
  function cancelEditPoint() {
      if (currentPoint) {
          stopImageFader("editImg"+ currentPoint.id);
          currentPoint = null;
          hide("pointDetails");
      }
  }
  
  function savePoint() {
      startImageFader("pointSaveImg", true);
      hideContextualMessages("pointProperties");
      var locator = currentPoint.pointLocator;
      
      // Prevents DWR warnings
      delete locator.configurationDescription;
      delete locator.dataTypeDescription;
      
      savePointImpl(locator);
  }
  
  function savePointCB(response) {
      stopImageFader("pointSaveImg");
      if (response.hasMessages)
          showDwrMessages(response.messages);
      else {
          writePointList(response.data.points);
          editPoint(response.data.id);
          showMessage("pointMessage", "Point details saved");
      }
  }
  
  function getAlarms() {
      DataSourceEditDwr.getAlarms(writeAlarms);
  }
  
  function writeAlarms(alarms) {
      dwr.util.removeAllRows("alarmsList");
      if (alarms.length == 0) {
          show("noAlarmsMsg");
          hide("alarmsList");
      }
      else {
          hide("noAlarmsMsg");
          show("alarmsList");
          dwr.util.addRows("alarmsList", alarms, [
                  function(alarm) {
                      var div = document.createElement("div");
                      var img = document.createElement("img");
                      setAlarmLevelImg(alarm.alarmLevel, img);
                      div.appendChild(img);
                      
                      var span = document.createElement("span");
                      span.innerHTML = alarm.prettyActiveTimestamp +": "+ alarm.message;
                      div.appendChild(span);
                      
                      return div; 
                  }],
                  {
                      cellCreator: function(options) {
                          var td = document.createElement("td");
                          td.className = "formError";
                          return td;
                      }
                  });
      }
  }
</script>

<table class="borderDiv marB" cellpadding="0" cellspacing="0" id="alarmsTable" style="display:none;"><tr><td>
  <table width="100%">
    <tr>
      <td class="smallTitle">Current alarms</td>
      <td align="right"><mango:img png="control_repeat_blue" title="Refresh" onclick="getAlarms()"/></td>
    </tr>
  </table>
  <table>
    <tr id="noAlarmsMsg"><td><b>No active alarms for this data source</b></td></tr>
    <tbody id="alarmsList"></tbody>
  </table>
</td></tr></table>

<c:choose>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.VIRTUAL']}">
    <jsp:include page="dataSourceEdit/editVirtual.jsp"/>
  </c:when>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.MODBUS_SERIAL']}">
    <jsp:include page="dataSourceEdit/editModbus.jsp"/>
  </c:when>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.MODBUS_IP']}">
    <jsp:include page="dataSourceEdit/editModbus.jsp"/>
  </c:when>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.SPINWAVE']}">
    <jsp:include page="dataSourceEdit/editSpinwave.jsp"/>
  </c:when>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.SNMP']}">
    <jsp:include page="dataSourceEdit/editSnmp.jsp"/>
  </c:when>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.SQL']}">
    <jsp:include page="dataSourceEdit/editSql.jsp"/>
  </c:when>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.HTTP_RECEIVER']}">
    <jsp:include page="dataSourceEdit/editHttpReceiver.jsp"/>
  </c:when>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.ONE_WIRE']}">
    <jsp:include page="dataSourceEdit/editOneWire.jsp"/>
  </c:when>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.META']}">
    <jsp:include page="dataSourceEdit/bookmark.jsp"/>
  </c:when>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.BACNET']}">
    <jsp:include page="dataSourceEdit/bookmark.jsp"/>
  </c:when>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.HTTP_RETRIEVER']}">
    <jsp:include page="dataSourceEdit/editHttpRetriever.jsp"/>
  </c:when>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.POP3']}">
    <jsp:include page="dataSourceEdit/bookmark.jsp"/>
  </c:when>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.NMEA']}">
    <jsp:include page="dataSourceEdit/bookmark.jsp"/>
  </c:when>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.GALIL']}">
    <jsp:include page="dataSourceEdit/bookmark.jsp"/>
  </c:when>
</c:choose>

<mango:footer/>