<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.DataTypes"%>

<script type="text/javascript">
  var ipWhiteList = new Array();
  var deviceIdWhiteList = new Array();
  
  function initImpl() {
      <c:forEach items="${dataSource.ipWhiteList}" var="ip">
        ipWhiteList[ipWhiteList.length] = "${ip}";
      </c:forEach>
      ipWhiteList.sort();
      refreshIpWhiteList();
      
      <c:forEach items="${dataSource.deviceIdWhiteList}" var="deviceId">
        deviceIdWhiteList[deviceIdWhiteList.length] = "${deviceId}";
      </c:forEach>
      deviceIdWhiteList.sort();
      refreshDeviceIdWhiteList();
  }
  
  function addIpMask() {
      var ipMask = $get("ipMask");
      
      for (var i=0; i<ipWhiteList.length; i++) {
          if (ipWhiteList[i] == ipMask) {
              alert("List already contains the ip mask "+ ipMask);
              return;
          }
      }
      
      DataSourceEditDwr.validateIpMask(ipMask, addIpMaskCB);
  }
  
  function addIpMaskCB(error) {
      if (error)
          alert(error);
      else {
          ipWhiteList[ipWhiteList.length] = $get("ipMask");
          ipWhiteList.sort();
          refreshIpWhiteList();
      }
  }
  
  function addDeviceIdMask() {
      var deviceIdMask = $get("deviceIdMask");
      
      for (var i=0; i<deviceIdWhiteList.length; i++) {
          if (deviceIdWhiteList[i] == deviceIdMask) {
              alert("List already contains the device id mask "+ deviceIdMask);
              return;
          }
      }
      
      deviceIdWhiteList[deviceIdWhiteList.length] = deviceIdMask;
      deviceIdWhiteList.sort();
      refreshDeviceIdWhiteList();
  }
  
  function removeIpMask(ipMask) {
      for (var i=ipWhiteList.length-1; i>=0; i--) {
          if (ipWhiteList[i] == ipMask)
              ipWhiteList.splice(i, 1);
      }
      refreshIpWhiteList();
  }
  
  function removeDeviceIdMask(deviceIdMask) {
      for (var i=deviceIdWhiteList.length-1; i>=0; i--) {
          if (deviceIdWhiteList[i] == deviceIdMask)
              deviceIdWhiteList.splice(i, 1);
      }
      refreshDeviceIdWhiteList();
  }
  
  function refreshIpWhiteList() {
      dwr.util.removeAllRows("ipWhiteList");
      if (ipWhiteList.length == 0)
          show("noAddressesMessage");
      else {
          hide("noAddressesMessage");
          dwr.util.addRows("ipWhiteList", ipWhiteList, [
                  function(data) { return ""; },
                  function(data) {
                      return data +" <img src='images/bullet_delete.png' onclick='removeIpMask(\""+ data + "\");' "+
                              "class='ptr' alt='Remove IP mask from list' title='Remove IP mask from list'/>";
                  }
                  ], null);
      }
  }
  
  function refreshDeviceIdWhiteList() {
      dwr.util.removeAllRows("deviceIdWhiteList");
      if (deviceIdWhiteList.length == 0)
          show("noDevicesMessage");
      else {
          hide("noDevicesMessage");
          dwr.util.addRows("deviceIdWhiteList", deviceIdWhiteList, [
                  function(data) { return ""; },
                  function(data) {
                      return data +" <img src='images/bullet_delete.png' onclick='removeDeviceIdMask(\""+ data 
                              +"\");' class='ptr' alt='Remove device ID mask from list' "+
                              "title='Remove device ID mask from list'/>";
                  }
                  ], null);
      }
  }
  
  function saveDataSourceImpl() {
      httpListenCancel();
      DataSourceEditDwr.saveHttpReceiverDataSource($get("dataSourceName"), ipWhiteList, deviceIdWhiteList,
              saveDataSourceCB);
  }
  
  function httpListen() {
      $set("httpListenMessage", "Listening...");
      $set("httpListenData");
      httpListenButtons(true);
      DataSourceEditDwr.httpReceiverListenForData(ipWhiteList, deviceIdWhiteList, httpListenCB);
  }
  
  function httpListenButtons(listening) {
      setDisabled("httpListenBtn", listening);
      setDisabled("httpListenCancelBtn", !listening);
  }
  
  function httpListenCB() {
      setTimeout(httpListenUpdate, 2000);
  }
  
  function httpListenUpdate() {
      DataSourceEditDwr.httpReceiverListenerUpdate(httpListenUpdateCB);
  }
  
  function httpListenUpdateCB(result) {
      if (result) {
          $set("httpListenMessage", result.message);
          if (result.remoteIp) {
              var data = "<b>Source: "+ result.remoteIp +"</b><br/>";
              if (result.deviceId)
                  data += "<b>Device ID: "+ result.deviceId +"</b><br/>";
              else
                  data += "<b>Device ID: (none)</b><br/>";
              data += "<b>Time: "+ result.time +"</b><br/>";
              for (prop in result.data)
                  data += prop.replace(/</, "&lt;") +"="+ result.data[prop].replace(/</, "&lt;") +"<br/>";
              $set("httpListenData", data);
          }
          httpListenCB();
      }
  }
  
  function httpListenCancel() {
      DataSourceEditDwr.cancelTestingUtility(httpListenCancelCB);
  }
  
  function httpListenCancelCB() {
      httpListenButtons(false);
      $set("httpListenMessage", "Cancelled");
  }
  
  function appendPointListColumnFunctions(pointListColumnHeaders, pointListColumnFunctions) {
      pointListColumnHeaders[pointListColumnHeaders.length] = "Parameter";
      pointListColumnFunctions[pointListColumnFunctions.length] = function(p) { return p.pointLocator.parameterName; };
  }
  
  function editPointCBImpl(locator) {
      $set("parameterName", locator.parameterName);
      $set("dataTypeId", locator.dataTypeId);
      $set("binary0Value", locator.binary0Value);
      changeDataTypeId();
  }
  
  function savePointImpl(locator) {
      delete locator.settable;
      
      locator.parameterName = $get("parameterName");
      locator.dataTypeId = $get("dataTypeId");
      locator.binary0Value = $get("binary0Value");
      
      DataSourceEditDwr.saveHttpReceiverPointLocator(currentPoint.id, $get("name"), locator, savePointCB);
  }
  
  function changeDataTypeId() {
      var dataTypeId = $get("dataTypeId");
      if (dataTypeId == <%= DataTypes.BINARY %>)
          setDisabled($("binary0Value"), false);
      else
          setDisabled($("binary0Value"), true);
  }
</script>

<c:set var="dsDesc" value="HTTP receiver properties"/>
<c:set var="dsHelpId" value="F9BFBv8A965YbXXv7j5q"/>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/dsHead.jspf" %>
        <tr>
          <td class="formLabelRequired">Remote IP white list</td>
          <td class="formField">
            <table cellpadding="0" cellspacing="0">
              <tr>
                <td><input id="ipMask" type="text"/></td>
                <td width="10"></td>
                <td><img src="images/add.png" onclick="addIpMask()" class="ptr" alt="Add ip address mask" 
                        title="Add ip address mask"/></td>
              </tr>
            </table>
          </td>
        </tr>

        <tr id="noAddressesMessage" style="display:none;">
          <td></td>
          <td>No ip addresses defined</td>
        </tr>
        <tbody id="ipWhiteList"></tbody>

        <tr>
          <td class="formLabelRequired">Device ID white list</td>
          <td class="formField">
            <table cellpadding="0" cellspacing="0">
              <tr>
                <td><input id="deviceIdMask" type="text"/></td>
                <td width="10"></td>
                <td><img src="images/add.png" onclick="addDeviceIdMask()" class="ptr" alt="Add device ID mask" 
                        title="Add device ID mask"/></td>
              </tr>
            </table>
          </td>
        </tr>

        <tr id="noDevicesMessage" style="display:none;">
          <td></td>
          <td>No device IDs defined</td>
        </tr>
        <tbody id="deviceIdWhiteList"></tbody>
      </table>
    </div>
  </td>
  
  <td valign="top">
    <div class="borderDiv marB">
      <table>
        <tr><td class="smallTitle">HTTP receiver listener</td></tr>
        <tr>
          <td align="center">
            <input id="httpListenBtn" type="submit" value="Listen for HTTP data"
                    onclick="httpListen(); return false;"/>
            <input id="httpListenCancelBtn" type="submit" value="Cancel" onclick="httpListenCancel(); return false;"/>
          </td>
        </tr>
        <tr><td id="httpListenMessage" class="formError"></td></tr>
        <tr><td class="formField" id="httpListenData"></td></tr>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/dsFoot.jspf" %>

<c:set var="pointHelpId" value="zmydKbsmWZTiSrv3EI7v"/>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/pointsHead.jspf" %>
  <tr>
    <td class="formLabelRequired">HTTP parameter name</td>
    <td class="formField"><input type="text" id="parameterName"/></td>
  </tr>
  
  <tr>
    <td class="formLabelRequired">Data type</td>
    <td class="formField">
      <select id="dataTypeId" onchange="changeDataTypeId();">
        <c:forEach items="${dataTypes}" var="type"><option value="${type.key}">${type.value}</option></c:forEach>
      </select>
    </td>
  </tr>
  
  <tr>
    <td class="formLabelRequired">Binary 0 value</td>
    <td class="formField"><input id="binary0Value" type="text"/></td>
  </tr>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/pointsFoot.jspf" %>