<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.modbus4j.code.RegisterRange"%>
<%@page import="com.serotonin.modbus4j.code.DataType"%>

<script type="text/javascript">
  function initImpl() {
      scanButtons(false);
  }
  
  function scan() {
      $set("scanMessage", "Starting scan...");
      dwr.util.removeAllOptions("scanNodes");
      scanButtons(true);
      scanImpl();
  }
  
  function scanCB(msg) {
      if (msg)
          alert(msg);
      else
          setTimeout(scanUpdate, 1000);
  }

  function scanUpdate() {
      DataSourceEditDwr.modbusScanUpdate(scanUpdateCB);
  }
  
  function scanUpdateCB(result) {
      if (result) {
          $set("scanMessage", result.message);
          dwr.util.removeAllOptions("scanNodes");
          dwr.util.addOptions("scanNodes", result.nodes);
          if (!result.finished)
              scanCB();
          else
              scanButtons(false);
      }
  }
  
  function scanCancel() {
      DataSourceEditDwr.cancelTestingUtility(scanButtons);
  }
  
  function scanButtons(scanning) {
      setDisabled("scanBtn", scanning);
      setDisabled("scanCancelBtn", !scanning);
  }
  
  function appendPointListColumnFunctions(pointListColumnHeaders, pointListColumnFunctions) {
      pointListColumnHeaders[pointListColumnHeaders.length] = "Slave";
      pointListColumnFunctions[pointListColumnFunctions.length] = function(p) { return p.pointLocator.slaveId; };
      
      pointListColumnHeaders[pointListColumnHeaders.length] = "Range";
      pointListColumnFunctions[pointListColumnFunctions.length] = function(p) { return p.pointLocator.rangeDescription; };
      
      pointListColumnHeaders[pointListColumnHeaders.length] = "Offset";
      pointListColumnFunctions[pointListColumnFunctions.length] = function(p) { return p.pointLocator.offset; };
  }
  
  function editPointCBImpl(locator) {
      $set("slaveId", locator.slaveId);
      $set("range", locator.range);
      $set("modbusDataType", locator.modbusDataType);
      $set("offset", locator.offset);
      $set("bit", locator.bit);
      $set("multiplier", locator.multiplier);
      $set("additive", locator.additive);
      changeRange();
  }
  
  function savePointImpl(locator) {
      delete locator.settable;
      delete locator.rangeDescription;
      delete locator.modbusDataTypeDescription;
      delete locator.dataTypeId;
      
      locator.slaveId = $get("slaveId");
      locator.range = $get("range");
      locator.modbusDataType = $get("modbusDataType");
      locator.offset = $get("offset");
      locator.bit = $get("bit");
      locator.multiplier = $get("multiplier");
      locator.additive = $get("additive");
      
      DataSourceEditDwr.saveModbusPointLocator(currentPoint.id, $get("name"), locator, savePointCB);
  }
  
  function changeRange() {
      var rangeId = $get("range");
      if (rangeId == "<%= RegisterRange.COIL_STATUS %>" || rangeId == "<%= RegisterRange.INPUT_STATUS %>") {
          $set("modbusDataType", "<%= DataType.BINARY %>");
          setDisabled("modbusDataType", true);
          setDisabled("bit", true);
      }
      else {
          setDisabled("modbusDataType", false);
          changeDataType();
      }
  }
  
  function isBinary() {
      return $get("modbusDataType") == "<%= DataType.BINARY %>";
  }
  
  function changeDataType() {
      setDisabled("bit", !isBinary());
  }
</script>

<c:choose>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.MODBUS_SERIAL']}">
    <c:set var="dsDesc" value="Modbus serial properties"/>
    <c:set var="dsHelpId" value="A0gyk9ztauGTglVlyHlP"/>
  </c:when>
  <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.MODBUS_IP']}">
    <c:set var="dsDesc" value="Modbus IP properties"/>
    <c:set var="dsHelpId" value="UfF7xMRpOj9M6UnNHMVT"/>
  </c:when>
</c:choose>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/dsHead.jspf" %>
  <tr>
    <td class="formLabelRequired">Update period</td>
    <td class="formField">
      <input type="text" id="updatePeriods" value="${dataSource.updatePeriods}" class="formShort"/>
      <sst:select id="updatePeriodType" value="${dataSource.updatePeriodType}">
        <sst:option value="<%= Integer.toString(Common.TimePeriods.SECONDS) %>">second(s)</sst:option>
        <sst:option value="<%= Integer.toString(Common.TimePeriods.MINUTES) %>">minute(s)</sst:option>
        <sst:option value="<%= Integer.toString(Common.TimePeriods.HOURS) %>">hour(s)</sst:option>
      </sst:select>
    </td>
  </tr>
        
  <tr>
    <td class="formLabelRequired">Timeout (ms)</td>
    <td class="formField"><input type="text" id="timeout" value="${dataSource.timeout}"/></td>
  </tr>
        
  <tr>
    <td class="formLabelRequired">Retries</td>
    <td class="formField"><input type="text" id="retries" value="${dataSource.retries}"/></td>
  </tr>
        
  <c:choose>
    <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.MODBUS_SERIAL']}">
      <%@ include file="/WEB-INF/jsp/dataSourceEdit/editModbusSerial.jsp" %>
    </c:when>
    <c:when test="${dataSource.typeId == applicationScope['constants.DataSourceVO.Types.MODBUS_IP']}">
      <%@ include file="/WEB-INF/jsp/dataSourceEdit/editModbusIp.jsp" %>
    </c:when>
  </c:choose>
      </table>
    </div>
  </td>
  
  <td valign="top">
    <div class="borderDiv marB">
      <table>
        <tr><td colspan="2" class="smallTitle">Modbus node scan</td></tr>
        
        <tr>
          <td colspan="2" align="center">
            <input id="scanBtn" type="submit" value="Scan for nodes" onclick="scan(); return false;"/>
            <input id="scanCancelBtn" type="submit" value="Cancel" onclick="scanCancel(); return false;"/>
          </td>
        </tr>
        
        <tr><td colspan="2" id="scanMessage" class="formError"></td></tr>
        
        <tr>
          <td class="formLabel">Nodes found</td>
          <td class="formField"><select id="scanNodes" size="8"></select></td>
        </tr>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/dsFoot.jspf" %>

<c:set var="pointHelpId" value="7F9eS47OCUctj6Wg6kys"/>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/pointsHead.jspf" %>
  <tr>
    <td class="formLabelRequired">Slave id</td>
    <td class="formField"><input type="text" id="slaveId"/></td>
  </tr>
  
  <tr>
    <td class="formLabelRequired">Register range</td>
    <td class="formField">
      <select id="range" onchange="changeRange()">
        <option value="<%= RegisterRange.COIL_STATUS %>">Coil status</option>
        <option value="<%= RegisterRange.INPUT_STATUS %>">Input status</option>
        <option value="<%= RegisterRange.HOLDING_REGISTER %>">Holding register</option>
        <option value="<%= RegisterRange.INPUT_REGISTER %>">Input register</option>
      </select>
    </td>
  </tr>
  
  <tr>
    <td class="formLabelRequired">Modbus data type</td>
    <td class="formField">
      <select id="modbusDataType" onchange="changeDataType()">
        <option value="<%= DataType.BINARY %>">Binary</option>
        <option value="<%= DataType.TWO_BYTE_INT_UNSIGNED %>">2 byte unsigned integer</option>
        <option value="<%= DataType.TWO_BYTE_INT_SIGNED %>">2 byte signed integer</option>
        <option value="<%= DataType.TWO_BYTE_BCD %>">2 byte BCD</option>
        <option value="<%= DataType.FOUR_BYTE_INT_UNSIGNED %>">4 byte unsigned integer</option>
        <option value="<%= DataType.FOUR_BYTE_INT_SIGNED %>">4 byte signed integer</option>
        <option value="<%= DataType.FOUR_BYTE_INT_UNSIGNED_SWAPPED %>">4 byte unsigned integer swapped</option>
        <option value="<%= DataType.FOUR_BYTE_INT_SIGNED_SWAPPED %>">4 byte signed integer swapped</option>
        <option value="<%= DataType.FOUR_BYTE_FLOAT %>">4 byte float</option>
        <option value="<%= DataType.FOUR_BYTE_FLOAT_SWAPPED %>">4 byte float swapped</option>
        <option value="<%= DataType.FOUR_BYTE_BCD %>">4 byte BCD</option>
        <option value="<%= DataType.EIGHT_BYTE_INT_UNSIGNED %>">8 byte unsigned integer</option>
        <option value="<%= DataType.EIGHT_BYTE_INT_SIGNED %>">8 byte signed integer</option>
        <option value="<%= DataType.EIGHT_BYTE_INT_UNSIGNED_SWAPPED %>">8 byte unsigned integer swapped</option>
        <option value="<%= DataType.EIGHT_BYTE_INT_SIGNED_SWAPPED %>">8 byte signed integer swapped</option>
        <option value="<%= DataType.EIGHT_BYTE_FLOAT %>">8 byte float</option>
        <option value="<%= DataType.EIGHT_BYTE_FLOAT_SWAPPED %>">8 byte float swapped</option>
      </select>
    </td>
  </tr>
  
  <tr>
    <td class="formLabelRequired">Offset (0-based)</td>
    <td class="formField"><input type="text" id="offset"/></td>
  </tr>
  
  <tr>
    <td class="formLabelRequired">Bit</td>
    <td class="formField"><input id="bit" type="text"/></td>
  </tr>
  
  <tr>
    <td class="formLabel">Multiplier</td>
    <td class="formField"><input type="text" id="multiplier"/></td>
  </tr>
  
  <tr>
    <td class="formLabel">Additive</td>
    <td class="formField"><input type="text" id="additive"/></td>
  </tr>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/pointsFoot.jspf" %>  