<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.vo.dataSource.modbus.ModbusSerialDataSourceVO"%>

<script type="text/javascript">
  function scanImpl() {
      DataSourceEditDwr.modbusSerialScan($get("timeout"), $get("retries"), $get("commPortId"), $get("baudRate"),
              $get("flowControlIn"), $get("flowControlOut"), $get("dataBits"), $get("stopBits"), $get("parity"), 
              $get("encoding"), scanCB);
  }
  
  function saveDataSourceImpl() {
      DataSourceEditDwr.saveModbusSerialDataSource($get("dataSourceName"), $get("updatePeriods"), 
              $get("updatePeriodType"), $get("timeout"), $get("retries"), $get("commPortId"), $get("baudRate"),
              $get("flowControlIn"), $get("flowControlOut"), $get("dataBits"), $get("stopBits"), $get("parity"), 
              $get("encoding"), $get("echo"), saveDataSourceCB);
  }
</script>

<tr>
  <td class="formLabelRequired">Port</td>
  <td class="formField">
    <c:choose>
      <c:when test="${!empty commPortError}">
        <input id="commPortId" type="hidden" value=""/>
        <span class="formError">${commPortError}</span>
      </c:when>
      <c:otherwise>
        <sst:select id="commPortId" value="${dataSource.commPortId}">
          <c:forEach items="${commPorts}" var="port">
            <sst:option value="${port.name}">${port.name}</sst:option>
          </c:forEach>
        </sst:select>
      </c:otherwise>
    </c:choose>
  </td>
</tr>

<tr>
  <td class="formLabelRequired">Baud rate</td>
  <td class="formField">
    <sst:select id="baudRate" value="${dataSource.baudRate}">
      <sst:option>110</sst:option>
      <sst:option>300</sst:option>
      <sst:option>1200</sst:option>
      <sst:option>2400</sst:option>
      <sst:option>4800</sst:option>
      <sst:option>9600</sst:option>
      <sst:option>19200</sst:option>
      <sst:option>38400</sst:option>
      <sst:option>57600</sst:option>
      <sst:option>115200</sst:option>
      <sst:option>230400</sst:option>
      <sst:option>460800</sst:option>
      <sst:option>921600</sst:option>
    </sst:select>
  </td>
</tr>

<tr>
  <td class="formLabelRequired">Flow control in</td>
  <td class="formField">
    <sst:select id="flowControlIn" value="${dataSource.flowControlIn}">
      <sst:option value="0">None</sst:option>
      <sst:option value="1">RTS/CTS</sst:option>
      <sst:option value="4">Xon/Xoff</sst:option>
    </sst:select>
  </td>
</tr>

<tr>
  <td class="formLabelRequired">Flow control out</td>
  <td class="formField">
    <sst:select id="flowControlOut" value="${dataSource.flowControlOut}">
      <sst:option value="0">None</sst:option>
      <sst:option value="2">RTS/CTS</sst:option>
      <sst:option value="8">Xon/Xoff</sst:option>
    </sst:select>
  </td>
</tr>

<tr>
  <td class="formLabelRequired">Data bits</td>
  <td class="formField">
    <sst:select id="dataBits" value="${dataSource.dataBits}">
      <sst:option value="5">5</sst:option>
      <sst:option value="6">6</sst:option>
      <sst:option value="7">7</sst:option>
      <sst:option value="8">8</sst:option>
    </sst:select>
  </td>
</tr>

<tr>
  <td class="formLabelRequired">Stop bits</td>
  <td class="formField">
    <sst:select id="stopBits" value="${dataSource.stopBits}">
      <sst:option value="1">1</sst:option>
      <sst:option value="3">1.5</sst:option>
      <sst:option value="2">2</sst:option>
    </sst:select>
  </td>
</tr>

<tr>
  <td class="formLabelRequired">Parity</td>
  <td class="formField">
    <sst:select id="parity" value="${dataSource.parity}">
      <sst:option value="0">None</sst:option>
      <sst:option value="1">Odd</sst:option>
      <sst:option value="2">Even</sst:option>
      <sst:option value="3">Mark</sst:option>
      <sst:option value="4">Space</sst:option>
    </sst:select>
  </td>
</tr>

<tr>
  <td class="formLabelRequired">Encoding</td>
  <td class="formField">
    <sst:select id="encoding" value="${dataSource.encoding}">
      <sst:option value="<%= ModbusSerialDataSourceVO.EncodingType.RTU.toString() %>">
              <%= ModbusSerialDataSourceVO.EncodingType.RTU.getPrettyName() %></sst:option>
      <sst:option value="<%= ModbusSerialDataSourceVO.EncodingType.RTU_REVERSE_CRC.toString() %>">
              <%= ModbusSerialDataSourceVO.EncodingType.RTU_REVERSE_CRC.getPrettyName() %></sst:option>
      <sst:option value="<%= ModbusSerialDataSourceVO.EncodingType.ASCII.toString() %>">
              <%= ModbusSerialDataSourceVO.EncodingType.ASCII.getPrettyName() %></sst:option>
    </sst:select>
  </td>
</tr>

<tr>
  <td class="formLabelRequired">Echo</td>
  <td class="formField">
    <sst:select id="echo" value="${dataSource.echo}">
      <sst:option value="false">Off</sst:option>
      <sst:option value="true">On</sst:option>
    </sst:select>
  </td>
</tr>