<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.Common"%>
<%@page import="com.serotonin.mango.vo.dataSource.onewire.OneWirePointLocatorVO"%>
<%@page import="com.serotonin.mango.vo.dataSource.onewire.OneWireDataSourceVO"%>

<script type="text/javascript">
  var networkInfo;
  var deviceInfo;
  
  function initImpl() {
      // Disable adding generic points.
      hide("editImg<%= + Common.NEW_ID %>");
      rescanChanged();
      getNetworkInfo();
  }
  
  function getNetworkInfo() {
      setDisabled("scanBtn", true);
      showMessage("scanMessage", "Scanning, please wait...");
      hide("scanResults");
      DataSourceEditDwr.readOneWireNetwork($get("commPortId"), getNetworkInfoCB);
  }
  
  function getNetworkInfoCB(result) {
      networkInfo = null;
      setDisabled("scanBtn", false);
      if (result.hasMessages) {
          showMessage("scanMessage", result.messages[0].genericMessage);
          hide("scanDevicesNoneFound");
          hide("scanResults");
      }
      else {
          // Show the results of the scan
          showMessage("scanMessage", "Scan complete.");
          networkInfo = result.data.devices;
          
          dwr.util.removeAllRows("scanDevices");
          dwr.util.addRows("scanDevices", networkInfo, [
                      function(device) { return device.addressString; },
                      function(device) { return device.description; },
                      function(device) {
                          return writeImage("scanDeviceImg"+ device.addressString, null, "icon_comp_add", "Add point",
                                  "addPoint('"+ device.addressString +"')");
                          }
                  ],
                  {
                      rowCreator: function(options) {
                          var tr = document.createElement("tr");
                          tr.className = "row"+ (options.rowIndex % 2 == 0 ? "" : "Alt");
                          return tr;
                      }
                  });
          
          show("scanResults");
          display("scanDevicesNoneFound", networkInfo.length == 0);
          
          dwr.util.removeAllOptions("address");
          dwr.util.addOptions("address", networkInfo, "addressString");
          
          if (currentPoint)
              $set("address", currentPoint.pointLocator.address);
      }
      cancelEditPoint();
  }

  function saveDataSourceImpl() {
      DataSourceEditDwr.saveOneWireDataSource($get("dataSourceName"), $get("commPortId"), $get("updatePeriodType"),
              $get("updatePeriods"), $get("rescanPeriodType"), $get("rescanPeriods"), saveDataSourceCB);
  }
  
  function appendPointListColumnFunctions(pointListColumnHeaders, pointListColumnFunctions) {
      pointListColumnHeaders[pointListColumnHeaders.length] = "Address";
      pointListColumnFunctions[pointListColumnFunctions.length] = function(p) { return p.pointLocator.address; };
      
      pointListColumnHeaders[pointListColumnHeaders.length] = "Attribute";
      pointListColumnFunctions[pointListColumnFunctions.length] = 
              function(p) { return p.pointLocator.attributeIndexDescription; };
  }
  
  function addPointImpl(address) {
      DataSourceEditDwr.addOneWirePoint(address, editPointCB);
  }
  
  function editPointCBImpl(locator) {
      if (!networkInfo) {
          alert("Scan your network before editing points");
          return true;
      }
      
      deviceInfo = getElement(networkInfo, locator.address, "addressString");
      if (deviceInfo) {
          // Found the device in the current network information.
          $set("address", locator.address);
          addressChanged();
          $set("attributeId", locator.attributeId);
          attributeIdChanged();
          $set("index", locator.index);
          
          show("editableAttributes");
          hide("readonlyAttributes");
          show("pointSaveImg");
      }
      else {
          // Didn't find the device.
          hide("pointSaveImg");
          hide("editableAttributes");
          hide("indexRow");
          
          $set("roAddress", locator.address);
          $set("roAttributeDescription", locator.attributeDescription);
          $set("roIndex", locator.index);
          
          show("readonlyAttributes");
      }
  }
  
  function savePointImpl(locator) {
      delete locator.settable;
      delete locator.attributeIndexDescription;
      delete locator.attributeDescription;
      delete locator.dataTypeId;
      
      locator.address = $get("address");
      locator.attributeId = $get("attributeId");
      locator.index = $get("index");
      
      DataSourceEditDwr.saveOneWirePointLocator(currentPoint.id, $get("name"), locator, savePointCB);
  }
  
  function addressChanged() {
      deviceInfo = getElement(networkInfo, $get("address"), "addressString");
      
      $set("deviceType", deviceInfo.description);
      
      dwr.util.removeAllOptions("attributeId");
      dwr.util.addOptions("attributeId", deviceInfo.attributes, "id", "description");
      attributeIdChanged();
  }
  
  function attributeIdChanged() {
      var attributeId = $get("attributeId")
      var indices = getElement(deviceInfo.attributes, attributeId).indices;
      dwr.util.removeAllOptions("index");
      if (indices == 0)
          hide("indexRow");
      else {
          if (attributeId == <%= OneWirePointLocatorVO.AttributeTypes.AD_VOLTAGE %>)
              $set("indexLabel", "AD channel");
          else if (attributeId == <%= OneWirePointLocatorVO.AttributeTypes.LATCH_STATE %>)
              $set("indexLabel", "Channel");
          else if (attributeId == <%= OneWirePointLocatorVO.AttributeTypes.WIPER_POSITION %>)
              $set("indexLabel", "Potentiometer");
          
          var indexSel = $("index");
          for (var i=0; i<indices; i++)
              indexSel.options[indexSel.options.length] = new Option(i);
          show("indexRow");
      }
  }
  
  function rescanChanged() {
      var type = $get("rescanPeriodType");
      if (type == <%= OneWireDataSourceVO.RESCAN_NONE %>)
          setDisabled("rescanPeriods", true);
      else
          setDisabled("rescanPeriods", false);
  }
</script>

<c:set var="dsDesc" value="1-Wire properties"/>
<c:set var="dsHelpId" value="Rx0yZO2iO3Zm3LSyQnAo"/>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/dsHead.jspf" %>
        <tr>
          <td class="formLabelRequired">Port</td>
          <td class="formField">
            <c:choose>
              <c:when test="${!empty commPortError}">
                <input id="commPortId" type="hidden" value=""/>
                <span class="formError">${commPortError}</span>
              </c:when>
              <c:otherwise>
                <sst:select id="commPortId" value="${dataSource.commPortId}">
                  <c:forEach items="${commPorts}" var="port">
                    <sst:option value="${port.name}">${port.name}</sst:option>
                  </c:forEach>
                </sst:select>
              </c:otherwise>
            </c:choose>
          </td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Update period</td>
          <td class="formField">
            <input type="text" id="updatePeriods" value="${dataSource.updatePeriods}" class="formShort"/>
            <sst:select id="updatePeriodType" value="${dataSource.updatePeriodType}">
              <sst:option value="<%= Integer.toString(Common.TimePeriods.SECONDS) %>">second(s)</sst:option>
              <sst:option value="<%= Integer.toString(Common.TimePeriods.MINUTES) %>">minute(s)</sst:option>
              <sst:option value="<%= Integer.toString(Common.TimePeriods.HOURS) %>">hour(s)</sst:option>
            </sst:select>
          </td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Scheduled rescan</td>
          <td class="formField">
            <input type="text" id="rescanPeriods" value="${dataSource.rescanPeriods}" class="formShort"/>
            <sst:select id="rescanPeriodType" value="${dataSource.rescanPeriodType}" onchange="rescanChanged()">
              <sst:option value="<%= Integer.toString(OneWireDataSourceVO.RESCAN_NONE) %>">None</sst:option>
              <sst:option value="<%= Integer.toString(Common.TimePeriods.MINUTES) %>">minute(s)</sst:option>
              <sst:option value="<%= Integer.toString(Common.TimePeriods.HOURS) %>">hour(s)</sst:option>
              <sst:option value="<%= Integer.toString(Common.TimePeriods.DAYS) %>">day(s)</sst:option>
              <sst:option value="<%= Integer.toString(Common.TimePeriods.WEEKS) %>">week(s)</sst:option>
            </sst:select>
          </td>
        </tr>
      </table>
    </div>
  </td>
  
  <td valign="top">
    <div class="borderDiv marB">
      <table>
        <tr><td class="smallTitle">1-wire Network Scan</td></tr>
        
        <tr>
          <td align="center">
            <input id="scanBtn" type="submit" value="Run scan" onclick="getNetworkInfo(); return false;"/>
          </td>
        </tr>
        
        <tr><td id="scanMessage" style="display:none;" class="formError"></td></tr>
        <tbody id="scanResults" style="display:none;"><tr><td><table cellspacing="1">
          <tr class="rowHeader">
            <td>Address</td>
            <td>Description</td>
            <td></td>
          </tr>
          <tbody id="scanDevicesNoneFound"><td colspan="3">No devices found</td></tbody>
          <tbody id="scanDevices"></tbody>
        </table></td></tr></tbody>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/dsFoot.jspf" %>

<c:set var="pointHelpId" value="KYZnhNuMwZKIzscaJsXM"/>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/pointsHead.jspf" %>
  <tbody id="editableAttributes">
    <tr>
      <td class="formLabelRequired">Address</td>
      <td class="formField"><select id="address" onchange="addressChanged()"></select></td>
    </tr>
    
    <tr>
      <td class="formLabelRequired">Device type</td>
      <td class="formField"><input type="text" id="deviceType" disabled="disabled" class="formLong"/></td>
    </tr>
    
    <tr>
      <td class="formLabelRequired">Attribute</td>
      <td class="formField"><select id="attributeId" onchange="attributeIdChanged()"></select></td>
    </tr>
  </tbody>
  
  <tbody id="indexRow" style="display:none">
    <tr>
      <td id="indexLabel" class="formLabelRequired"></td>
      <td class="formField"><select id="index"></select></td>
    </tr>
  </tbody>
  
  <tbody id="readonlyAttributes">
    <tr>
      <td class="formLabelRequired">Address</td>
      <td class="formField"><input type="text" id="roAddress" disabled="disabled"/></td>
    </tr>
    
    <tr>
      <td class="formLabelRequired">Attribute</td>
      <td class="formField"><input type="text" id="roAttributeDescription" disabled="disabled"/></td>
    </tr>
    
    <tr>
      <td class="formLabelRequired">Index</td>
      <td class="formField"><input type="text" id="roIndex" disabled="disabled"/></td>
    </tr>
    
    <tr><td colspan="2" class="formError">Device info not available</td></tr>
  </tbody>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/pointsFoot.jspf" %>