<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.Common"%>
<%@page import="org.snmp4j.mp.SnmpConstants"%>
<%@page import="com.serotonin.mango.vo.dataSource.snmp.SnmpDataSourceVO"%>
<%@page import="com.serotonin.mango.vo.dataSource.snmp.SnmpPointLocatorVO"%>
<%@page import="com.serotonin.mango.DataTypes"%>

<script type="text/javascript">
  function versionChange() {
      var version = $get("snmpVersion");
      if (version == <%= SnmpConstants.version3 %>) {
          show("version3Fields");
          hide("version12Fields");
      }
      else {
          hide("version3Fields");
          show("version12Fields");
      }
  }
  
  function snmpTest() {
      $set("snmpTestMessage", "Getting value...");
      snmpTestButton(true);
      DataSourceEditDwr.snmpGetOid($get("snmpTestOid"), $get("host"), $get("port"), $get("snmpVersion"), 
              $get("community"), $get("securityName"), $get("authProtocol"), $get("authPassphrase"), 
              $get("privProtocol"), $get("privPassphrase"), $get("engineId"), $get("contextEngineId"), 
              $get("contextName"), $get("retries"), $get("timeout"), snmpTestCB);
  }
  
  function snmpTestCB() {
      setTimeout(snmpTestUpdate, 1000);
  }
  
  function snmpTestUpdate() {
      DataSourceEditDwr.snmpGetOidUpdate(snmpTestUpdateCB);
  }
  
  function snmpTestUpdateCB(result) {
      if (result) {
          $set("snmpTestMessage", result);
          snmpTestButton(false);
      }
      else
          snmpTestCB();
  }
  
  function snmpTestButton(testing) {
      setDisabled($("snmpTestBtn"), testing);
  }

  function initImpl() {
      versionChange();
      snmpTestButton(false);
  }
  
  function saveDataSourceImpl() {
      DataSourceEditDwr.saveSnmpDataSource($get("dataSourceName"), $get("updatePeriods"), $get("updatePeriodType"), 
              $get("host"), $get("port"), $get("snmpVersion"), $get("community"), $get("securityName"), 
              $get("authProtocol"), $get("authPassphrase"), $get("privProtocol"), $get("privPassphrase"), 
              $get("engineId"), $get("contextEngineId"), $get("contextName"), $get("retries"), $get("timeout"),
              $get("trapPort"), $get("localAddress"), saveDataSourceCB);
  }
  
  function appendPointListColumnFunctions(pointListColumnHeaders, pointListColumnFunctions) {
      pointListColumnHeaders[pointListColumnHeaders.length] = "OID";
      pointListColumnFunctions[pointListColumnFunctions.length] = function(p) { return p.pointLocator.oid; };
  }
  
  function editPointCBImpl(locator) {
      $set("oid", locator.oid);
      $set("dataTypeId", locator.dataTypeId);
      $set("binary0Value", locator.binary0Value);
      $set("setType", locator.setType);
      $set("trapOnly", locator.trapOnly ? "true" : "false");
      dataTypeChanged();
  }
  
  function savePointImpl(locator) {
      delete locator.settable;
      
      locator.oid = $get("oid");
      locator.dataTypeId = $get("dataTypeId");
      locator.binary0Value = $get("binary0Value");
      locator.setType = $get("setType");
      locator.trapOnly = $get("trapOnly") == "true";
      
      DataSourceEditDwr.saveSnmpPointLocator(currentPoint.id, $get("name"), locator, savePointCB);
  }
  
  function dataTypeChanged() {
      display("binary0ValueRow", $get("dataTypeId") == <%= DataTypes.BINARY %>);
  }
</script>

<c:set var="dsDesc" value="SNMP properties"/>
<c:set var="dsHelpId" value="zF1PKG603EFsUIvtVhew"/>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/dsHead.jspf" %>
        <tr>
          <td class="formLabelRequired">Update period</td>
          <td class="formField">
            <input type="text" id="updatePeriods" value="${dataSource.updatePeriods}" class="formShort"/>
            <sst:select id="updatePeriodType" value="${dataSource.updatePeriodType}">
              <sst:option value="<%= Integer.toString(Common.TimePeriods.SECONDS) %>">second(s)</sst:option>
              <sst:option value="<%= Integer.toString(Common.TimePeriods.MINUTES) %>">minute(s)</sst:option>
              <sst:option value="<%= Integer.toString(Common.TimePeriods.HOURS) %>">hour(s)</sst:option>
            </sst:select>
          </td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Host</td>
          <td class="formField"><input id="host" type="text" value="${dataSource.host}"/></td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Port</td>
          <td class="formField"><input id="port" type="text" value="${dataSource.port}"/></td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">SNMP Version</td>
          <td class="formField">
            <sst:select id="snmpVersion" value="${dataSource.snmpVersion}" onchange="versionChange()">
              <sst:option value="<%= Integer.toString(SnmpConstants.version1) %>">1</sst:option>
              <sst:option value="<%= Integer.toString(SnmpConstants.version2c) %>">2c</sst:option>
              <sst:option value="<%= Integer.toString(SnmpConstants.version3) %>">3</sst:option>
            </sst:select>
          </td>
        </tr>
        
        <tbody id="version12Fields" style="display:none;">
          <tr>
            <td class="formLabelRequired">Community</td>
            <td class="formField"><input id="community" type="text" value="${dataSource.community}"/></td>
          </tr>
        </tbody>
        
        <tbody id="version3Fields" style="display:none;">
          <tr>
            <td class="formLabelRequired">Security name</td>
            <td class="formField"><input id="securityName" type="text" value="${dataSource.securityName}"/></td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Auth protocol</td>
            <td class="formField">
              <sst:select id="authProtocol" value="${dataSource.authProtocol}">
                <sst:option value="<%= SnmpDataSourceVO.AuthProtocols.NONE %>">(none)</sst:option>
                <sst:option value="<%= SnmpDataSourceVO.AuthProtocols.MD5 %>">MD5</sst:option>
                <sst:option value="<%= SnmpDataSourceVO.AuthProtocols.SHA %>">SHA</sst:option>
              </sst:select>
            </td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Auth passphrase</td>
            <td class="formField"><input id="authPassphrase" type="text" value="${dataSource.authPassphrase}"/></td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Priv protocol</td>
            <td class="formField">
              <sst:select id="privProtocol" value="${dataSource.privProtocol}">
                <sst:option value="<%= SnmpDataSourceVO.PrivProtocols.NONE %>">(none)</sst:option>
                <sst:option value="<%= SnmpDataSourceVO.PrivProtocols.DES %>">DES</sst:option>
                <sst:option value="<%= SnmpDataSourceVO.PrivProtocols.AES128 %>">AES128</sst:option>
                <sst:option value="<%= SnmpDataSourceVO.PrivProtocols.AES192 %>">AES192</sst:option>
                <sst:option value="<%= SnmpDataSourceVO.PrivProtocols.AES256 %>">AES256</sst:option>
              </sst:select>
            </td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Priv passphrase</td>
            <td class="formField"><input id="privPassphrase" type="text" value="${dataSource.privPassphrase}"/></td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Engine ID</td>
            <td class="formField"><input id="engineId" type="text" value="${dataSource.engineId}"/></td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Context engine ID</td>
            <td class="formField"><input id="contextEngineId" type="text" value="${dataSource.contextEngineId}"/></td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Context name</td>
            <td class="formField"><input id="contextName" type="text" value="${dataSource.contextName}"/></td>
          </tr>
        </tbody>
        
        <tr>
          <td class="formLabelRequired">Retries</td>
          <td class="formField"><input id="retries" type="text" value="${dataSource.retries}"/></td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Timeout (ms)</td>
          <td class="formField"><input id="timeout" type="text" value="${dataSource.timeout}"/></td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Trap port</td>
          <td class="formField"><input id="trapPort" type="text" value="${dataSource.trapPort}"/></td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Local address</td>
          <td class="formField"><input id="localAddress" type="text" value="${dataSource.localAddress}"/></td>
        </tr>
      </table>
    </div>
  </td>
  
  <td valign="top">
    <div class="borderDiv marB">
      <table>
        <tr><td colspan="2" class="smallTitle">SNMP host testing</td></tr>
        
        <tr>
          <td class="formLabel">OID</td>
          <td class="formField"><input type="text" id="snmpTestOid"/></td>
        </tr>
        
        <tr>
          <td colspan="2" align="center">
            <input id="snmpTestBtn" type="submit" value="Get OID value" onclick="snmpTest(); return false;"/>
          </td>
        </tr>
        
        <tr><td colspan="2" id="snmpTestMessage" class="formError"></td></tr>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/dsFoot.jspf" %>

<c:set var="pointHelpId" value="s0bvYf8YeNfa78kZiUSq"/>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/pointsHead.jspf" %>
  <tr>
    <td class="formLabelRequired">OID</td>
    <td class="formField"><input type="text" id="oid"/></td>
  </tr>
  
  <tr>
    <td class="formLabelRequired">Data type</td>
    <td class="formField">
      <select id="dataTypeId" onchange="dataTypeChanged()">
        <c:forEach items="${dataTypes}" var="type">
          <option value="${type.key}">${type.value}</option>
        </c:forEach>
      </select>
    </td>
  </tr>
  
  <tr id="binary0ValueRow">
    <td class="formLabelRequired">Binary 0 value</td>
    <td class="formField"><input type="text" id="binary0Value"/></td>
  </tr>
  
  <tr>
    <td class="formLabelRequired">Set type</td>
    <td class="formField">
      <select id="setType">
        <option value="<%= Integer.toString(SnmpPointLocatorVO.SetTypes.NONE) %>">(not settable)</option>
        <option value="<%= Integer.toString(SnmpPointLocatorVO.SetTypes.INTEGER_32) %>">Integer 32</option>
        <option value="<%= Integer.toString(SnmpPointLocatorVO.SetTypes.OCTET_STRING) %>">Octet string</option>
        <option value="<%= Integer.toString(SnmpPointLocatorVO.SetTypes.OID) %>">Object indentifier</option>
        <option value="<%= Integer.toString(SnmpPointLocatorVO.SetTypes.IP_ADDRESS) %>">IP address</option>
        <option value="<%= Integer.toString(SnmpPointLocatorVO.SetTypes.COUNTER_32) %>">Counter 32</option>
        <option value="<%= Integer.toString(SnmpPointLocatorVO.SetTypes.GAUGE_32) %>">Gauge 32</option>
        <option value="<%= Integer.toString(SnmpPointLocatorVO.SetTypes.TIME_TICKS) %>">Time ticks</option>
        <option value="<%= Integer.toString(SnmpPointLocatorVO.SetTypes.OPAQUE) %>">Opaque</option>
        <option value="<%= Integer.toString(SnmpPointLocatorVO.SetTypes.COUNTER_64) %>">Counter 64</option>
      </select>
    </td>
  </tr>
  
  <tr>
    <td class="formLabelRequired">Polling</td>
    <td class="formField">
      <select id="trapOnly">
        <option value="false">Poll and trap</option>
        <option value="true">Trap only</option>
      </select>
    </td>
  </tr>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/pointsFoot.jspf" %>