<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.spinwave.SpinwaveReceiver"%>
<%@page import="com.serotonin.mango.vo.dataSource.spinwave.SpinwaveV1PointLocatorVO"%>
<%@page import="com.serotonin.mango.vo.dataSource.spinwave.SpinwaveV2PointLocatorVO"%>
<%@page import="com.serotonin.spinwave.v2.SensorValue"%>

<script type="text/javascript">
  var sensorAddresses = new Array();
  var usedSensorAddresses = new Array();
  var v1Attrs = new Array();
  var v2Attrs = new Array();
  
  function initImpl() {
      <c:forEach items="${dataSource.sensorAddresses}" var="addr">
        sensorAddresses[sensorAddresses.length] = ${addr};
      </c:forEach>
      sortSensorAddresses();
      refreshSensorAddressList();
      swListenButtons(false);
      
      // Version 1 attributes
      v1Attrs[v1Attrs.length] = {id: <%= SpinwaveV1PointLocatorVO.AttributeTypes.TEMPURATURE %>, name: "Temperature"};
      v1Attrs[v1Attrs.length] = {id: <%= SpinwaveV1PointLocatorVO.AttributeTypes.SET_POINT %>, name: "Set point"};
      v1Attrs[v1Attrs.length] = {id: <%= SpinwaveV1PointLocatorVO.AttributeTypes.BATTERY %>, name: "Battery"};
      v1Attrs[v1Attrs.length] = {id: <%= SpinwaveV1PointLocatorVO.AttributeTypes.OVERRIDE %>, name: "Override"};
      
      // Version 2 attributes
      <c:forEach items="<%= SpinwaveV2PointLocatorVO.attributeTypes %>" var="attr">
        v2Attrs[v2Attrs.length] = {id: ${attr.key}, name: "${attr.value}"};
      </c:forEach>
      
      messageVersionChange();
  }
  
  function addAddress(addr) {
      if (!addr)
          addr = $get("sensorAddressText");
      addr = parseInt(addr);
      
      if (isNaN(addr)) {
          alert("Error parsing sensor address");
          return;
      }
      
      for (var i=sensorAddresses.length-1; i>=0; i--) {
          if (sensorAddresses[i] == addr) {
              alert("List already contains the address "+ addr);
              return;
          }
      }
      
      sensorAddresses[sensorAddresses.length] = addr;
      sortSensorAddresses();
      refreshSensorAddressList();
      $set("sensorAddressText", addr+1);
  }
  
  function removeAddress(addr) {
      if (contains(usedSensorAddresses, addr)) {
          alert("Address is in use by one or more points. Cannot delete");
          return;
      }
  
      for (var i=sensorAddresses.length-1; i>=0; i--) {
          if (sensorAddresses[i] == addr)
              sensorAddresses.splice(i, 1);
      }
      refreshSensorAddressList();
  }
  
  function sortSensorAddresses() {
      sensorAddresses.sort( function(a,b) { return a-b; } );
  }
  
  function refreshSensorAddressList() {
      dwr.util.removeAllRows("sensorAddressList");
      if (sensorAddresses.length == 0)
          show("noAddressesMessage");
      else {
          hide("noAddressesMessage");
          dwr.util.addRows("sensorAddressList", sensorAddresses, [
                  function(data) { return ""; },
                  function(data) {
                      return data +" <img src='images/bullet_delete.png' onclick='removeAddress("+ data + ");' "+
                              "class='ptr' alt='Remove address from list' title='Remove address from list'/>";
                  }
                  ], null);
      }
      
      var addrSelect = $("sensorAddress");
      var oldValue = addrSelect.value;
      dwr.util.removeAllOptions(addrSelect);
      dwr.util.addOptions(addrSelect, sensorAddresses);
      addrSelect.value = oldValue;
  }
  
  function saveDataSourceImpl() {
      swListenCancel();
      DataSourceEditDwr.saveSpinwaveDataSource($get("dataSourceName"), $get("commPortId"), sensorAddresses, 
              $get("messageVersion"), $get("heartbeatTimeout"), saveDataSourceCB);
  }
  
  function swListen() {
      $set("swListenMessage", "Listening...");
      dwr.util.removeAllOptions("swListenSensors");
      swListenButtons(true);
      DataSourceEditDwr.spinwaveListenForSensors($get("commPortId"), $get("messageVersion"), swListenCB);
  }
  
  function swListenCB(msg) {
      setTimeout(swListenUpdate, 2000);
  }
  
  function swListenButtons(listening) {
      setDisabled("swListenBtn", listening);
      setDisabled("swListenCancelBtn", !listening);
  }
  
  function swListenUpdate() {
      DataSourceEditDwr.spinwaveListenerUpdate(swListenUpdateCB);
  }
  
  function swListenUpdateCB(result) {
      if (result) {
          $set("swListenMessage", result.message);
          dwr.util.removeAllOptions("swListenSensors");
          dwr.util.addOptions("swListenSensors", result.nodes);
          swListenCB();
      }
  }
  
  function swListenCancel() {
      DataSourceEditDwr.cancelTestingUtility(swListenCancelCB);
  }
  
  function swListenCancelCB() {
      swListenButtons(false);
      $("swListenMessage").innerHTML = "Cancelled";
  }
  
  function swAddSensorsToList() {
      var sensors = $("swListenSensors").options;
      for (var i=0; i<sensors.length; i++)
          addAddress(sensors[i].value);
  }
  
  function writePointListImpl(points) {
      var msgVersion = $("messageVersion");
      if (!points || points.length == 0) {
          setDisabled(msgVersion, false);
          hide("messageVersionWarning");
      }
      else {
          setDisabled(msgVersion, true);
          show("messageVersionWarning");
      }
      
      updateUsedSensorAddresses(points);
  }
  
  function appendPointListColumnFunctions(pointListColumnHeaders, pointListColumnFunctions) {
      pointListColumnHeaders[pointListColumnHeaders.length] = "Address";
      pointListColumnFunctions[pointListColumnFunctions.length] = function(p) { return p.pointLocator.sensorAddress; };
      
      pointListColumnHeaders[pointListColumnHeaders.length] = "Attribute";
      pointListColumnFunctions[pointListColumnFunctions.length] = function(p) { return p.pointLocator.attributeDescription; };
  }
  
  function updateUsedSensorAddresses(points) {
      usedSensorAddresses.length = 0;
      if (points) {
          for (var i=0; i<points.length; i++) {
              if (!contains(usedSensorAddresses, points[i].sensorAddress))
                  usedSensorAddresses[usedSensorAddresses.length] = points[i].pointLocator.sensorAddress;
          }
      }
  }
  
  function editPointCBImpl(locator) {
      $set("sensorAddress", locator.sensorAddress);
      $set("attributeId", locator.attributeId);
      $set("convertToCelsius", locator.convertToCelsius);
      changeAttributeId();
  }
  
  function savePointImpl(locator) {
      delete locator.attributeDescription;
      delete locator.attributeTypes;
      delete locator.settable;
      delete locator.dataTypeId;
      
      locator.sensorAddress = $get("sensorAddress");
      locator.attributeId = $get("attributeId");
      locator.convertToCelsius = $get("convertToCelsius");
      
      if ($get("messageVersion") == <%= SpinwaveReceiver.VERSION_1 %>)
          DataSourceEditDwr.saveSpinwaveV1PointLocator(currentPoint.id, $get("name"), locator, savePointCB);
      else
          DataSourceEditDwr.saveSpinwaveV2PointLocator(currentPoint.id, $get("name"), locator, savePointCB);
  }
  
  function messageVersionChange() {
      dwr.util.removeAllOptions("attributeId");
      var opts;
      if ($get("messageVersion") == <%= SpinwaveReceiver.VERSION_1 %>)
          opts = v1Attrs;
      else
          opts = v2Attrs;
      dwr.util.addOptions("attributeId", opts, "id", "name");
  }
  
  function changeAttributeId() {
      var attributeId = $get("attributeId");
      var disable;
      if ($get("messageVersion") == <%= SpinwaveReceiver.VERSION_1 %>)
          disable = !(attributeId == <%= SpinwaveV1PointLocatorVO.AttributeTypes.TEMPURATURE %> ||
                attributeId == <%= SpinwaveV1PointLocatorVO.AttributeTypes.SET_POINT %>);
      else
          disable = !(attributeId == <%= SensorValue.TYPE_TEMPERATURE %>);
      setDisabled("convertToCelsius", disable);
  }
</script>

<c:set var="dsDesc" value="Spinwave receiver properties"/>
<c:set var="dsHelpId" value="zLhPmZ0IIB0rZsKOp4oX"/>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/dsHead.jspf" %>
        <tr>
          <td class="formLabelRequired">Port</td>
          <td class="formField">
            <c:choose>
              <c:when test="${!empty commPortError}">
                <input id="commPortId" type="hidden" value=""/>
                <span class="formError">${commPortError}</span>
              </c:when>
              <c:otherwise>
                <sst:select id="commPortId" value="${dataSource.commPortId}">
                  <c:forEach items="${commPorts}" var="port">
                    <sst:option value="${port.name}">${port.name}</sst:option>
                  </c:forEach>
                </sst:select>
              </c:otherwise>
            </c:choose>
          </td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Heartbeat timeout (s)</td>
          <td class="formField"><input id="heartbeatTimeout" type="text" value="${dataSource.heartbeatTimeout}"/></td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Message version</td>
          <td class="formField">
            <sst:select id="messageVersion" value="${dataSource.messageVersion}" onchange="messageVersionChange()">
              <sst:option><%= SpinwaveReceiver.VERSION_1 %></sst:option>
              <sst:option><%= SpinwaveReceiver.VERSION_2 %></sst:option>
            </sst:select>
            <span id="messageVersionWarning" style="display:none"><img src="images/warn.png" 
                    title="Delete points to change message version"/></span>
          </td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Sensor addresses</td>
          <td class="formField">
            <table cellpadding="0" cellspacing="0">
              <tr>
                <td><input id="sensorAddressText" type="text"/></td>
                <td width="10"></td>
                <td><mango:img png="add" onclick="addAddress()" title="Add sensor address"/></td>
              </tr>
            </table>
          </td>
        </tr>
        <tr id="noAddressesMessage" style="display:none;">
          <td></td>
          <td>No sensor addresses defined</td>
        </tr>
        <tbody id="sensorAddressList"></tbody>
      </table>
    </div>
  </td>
  
  <td valign="top">
    <div class="borderDiv marB">
      <table>
        <tr><td colspan="2" class="smallTitle">Spinwave sensor listener</td></tr>
        
        <tr>
          <td colspan="2" align="center">
            <input id="swListenBtn" type="submit" value="Listen for sensors" onclick="swListen(); return false;"/>
            <input id="swListenCancelBtn" type="submit" value="Cancel" onclick="swListenCancel(); return false;"/>
          </td>
        </tr>
        
        <tr><td colspan="2" id="swListenMessage" class="formError"></td></tr>
        
        <tr>
          <td class="formLabel">Sensors found</td>
          <td class="formField"><select id="swListenSensors" size="8"></select></td>
        </tr>
        
        <tr>
          <td colspan="2" align="center">
            <input type="submit" value="Add found sensors to list" onclick="swAddSensorsToList(); return false;"/>
          </td>
        </tr>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/dsFoot.jspf" %>

<c:set var="pointHelpId" value="EKqNBP7h3TafIMNLxm1S"/>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/pointsHead.jspf" %>
  <tr>
    <td class="formLabelRequired">Sensor address</td>
    <td class="formField"><select id="sensorAddress"></select></td>
  </tr>
  
  <tr>
    <td class="formLabelRequired">Attribute</td>
    <td class="formField"><select id="attributeId" onchange="changeAttributeId()"></select></td>
  </tr>
  
  <tr>
    <td class="formLabelRequired">Convert to Celsius</td>
    <td class="formField"><input type="checkbox" id="convertToCelsius"/></td>
  </tr>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/pointsFoot.jspf" %>