<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.Common"%>

<script type="text/javascript">
  function initImpl() {
      sqlTestButton(false);
      rowBasedQueryChange();
  }
  
  function sqlTest() {
      $set("sqlTestError", "Executing select statement...");
      show("sqlTestError");
      sqlTestButton(true);
      hide("sqlTestResults");
      dwr.util.removeAllRows("sqlTestResults");
      DataSourceEditDwr.sqlTestStatement($get("driverClassname"), $get("connectionUrl"), $get("username"), 
              $get("password"), $get("selectStatement"), $get("rowBasedQuery"), sqlTestCB);
  }
  
  function sqlTestCB() {
      setTimeout(sqlTestUpdate, 1000);
  }
  
  function sqlTestUpdate() {
      DataSourceEditDwr.sqlTestStatementUpdate(sqlTestUpdateCB);
  }
  
  function sqlTestUpdateCB(result) {
      if (result) {
          if (result.error)
              $set("sqlTestError", result.error);
          else {
              hide("sqlTestError");
              var tbody, td, tr, r, c;
              tbody = $("sqlTestResults");
              tr = document.createElement("tr");
              tr.className = "smRowHeader";
              tbody.appendChild(tr);
              for (c=0; c<result.resultTable[0].length; c++) {
                  td = document.createElement("td");
                  $set(td, result.resultTable[0][c]);
                  tr.appendChild(td);
              }
              
              for (r=1; r<result.resultTable.length; r++) {
                  tr = document.createElement("tr");
                  tr.className = "smRow"+ (r % 2 == 0 ? "" : "Alt");
                  tbody.appendChild(tr);
                  for (c=0; c<result.resultTable[r].length; c++) {
                      td = document.createElement("td");
                      $set(td, result.resultTable[r][c]);
                      tr.appendChild(td);
                  }
              }
              
              show(tbody);
          }
          sqlTestButton(false);
      }
      else
          sqlTestCB();
  }
  
  function sqlTestButton(testing) {
      setDisabled($("sqlTestBtn"), testing);
  }

  function saveDataSourceImpl() {
      DataSourceEditDwr.saveSqlDataSource($get("dataSourceName"), $get("updatePeriods"), $get("updatePeriodType"), 
              $get("driverClassname"), $get("connectionUrl"), $get("username"), $get("password"),
              $get("selectStatement"), $get("rowBasedQuery"), saveDataSourceCB);
  }
  
  function writePointListImpl(points) {
      var rowBasedQuery = $("rowBasedQuery");
      if (!points || points.length == 0) {
          setDisabled(rowBasedQuery, false);
          hide("rowBasedQueryWarning");
      }
      else {
          setDisabled(rowBasedQuery, true);
          show("rowBasedQueryWarning");
      }
  }
  
  function appendPointListColumnFunctions(pointListColumnHeaders, pointListColumnFunctions) {
      pointListColumnHeaders[pointListColumnHeaders.length] = function(td) { td.id = "fieldNameTitle"; };
      pointListColumnFunctions[pointListColumnFunctions.length] = function(p) { return p.pointLocator.fieldName; };
  }
  
  function editPointCBImpl(locator) {
      $set("fieldName", locator.fieldName);
      $set("timeOverrideName", locator.timeOverrideName);
      $set("updateStatement", locator.updateStatement);
      $set("dataTypeId", locator.dataTypeId);
  }
  
  function savePointImpl(locator) {
      delete locator.settable;
      
      locator.fieldName = $get("fieldName");
      locator.timeOverrideName = $get("timeOverrideName");
      locator.updateStatement = $get("updateStatement");
      locator.dataTypeId = $get("dataTypeId");
      
      DataSourceEditDwr.saveSqlPointLocator(currentPoint.id, $get("name"), locator, savePointCB);
  }
  
  function rowBasedQueryChange() {
      if ($get("rowBasedQuery")) {
          $set("fieldNameLabel", "Row identifier");
          $set("fieldNameTitle", "Row identifier");
          hide("columnBasedProperties");
      }
      else {
          $set("fieldNameLabel", "Column name");
          $set("fieldNameTitle", "Column name");
          show("columnBasedProperties");
      }
  }
</script>

<c:set var="dsDesc" value="SQL properties"/>
<c:set var="dsHelpId" value="sXBcwQ3UegJ2nuOdlKku"/>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/dsHead.jspf" %>
        <tr>
          <td class="formLabelRequired">Update period</td>
          <td class="formField">
            <input type="text" id="updatePeriods" value="${dataSource.updatePeriods}" class="formShort"/>
            <sst:select id="updatePeriodType" value="${dataSource.updatePeriodType}">
              <sst:option value="<%= Integer.toString(Common.TimePeriods.SECONDS) %>">second(s)</sst:option>
              <sst:option value="<%= Integer.toString(Common.TimePeriods.MINUTES) %>">minute(s)</sst:option>
              <sst:option value="<%= Integer.toString(Common.TimePeriods.HOURS) %>">hour(s)</sst:option>
            </sst:select>
          </td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Driver class name</td>
          <td class="formField"><input id="driverClassname" type="text" value="${dataSource.driverClassname}"/></td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Connection string</td>
          <td class="formField"><input id="connectionUrl" type="text" value="${dataSource.connectionUrl}"
                  class="formLong"/></td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Username</td>
          <td class="formField"><input id="username" type="text" value="${dataSource.username}"/></td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Password</td>
          <td class="formField"><input id="password" type="text" value="${dataSource.password}"/></td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Select statement</td>
          <td class="formField">
            <textarea id="selectStatement" rows="10" cols="45">${dataSource.selectStatement}</textarea>
          </td>
        </tr>
        
        <tr>
          <td class="formLabelRequired">Row-based query</td>
          <td class="formField">
            <sst:checkbox id="rowBasedQuery" selectedValue="${dataSource.rowBasedQuery}"
                    onclick="rowBasedQueryChange()"/>
            <span id="rowBasedQueryWarning" style="display:none"><img src="images/warn.png" 
                    title="Delete points to change this value"/></span>
          </td>
        </tr>
      </table>
    </div>
  </td>
  
  <td valign="top">
    <div class="borderDiv marB">
      <table cellspacing="1">
        <tr><td class="smallTitle">Statement test</td></tr>
        
        <tr>
          <td align="center">
            <input id="sqlTestBtn" type="submit" value="Execute" onclick="sqlTest(); return false;"/>
          </td>
        </tr>
        
        <tr><td id="sqlTestError"></td></tr>
        <tbody id="sqlTestResults"></tbody>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/dsFoot.jspf" %>

<c:set var="pointHelpId" value="gvV03AiVbVC4j03cCNiV"/>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/pointsHead.jspf" %>
  <tr>
    <td class="formLabelRequired">Data type</td>
    <td class="formField">
      <select name="dataTypeId">
        <c:forEach items="${dataTypes}" var="type">
          <option value="${type.key}">${type.value}</option>
        </c:forEach>
      </select>
    </td>
  </tr>
  
  <tr>
    <td id="fieldNameLabel" class="formLabelRequired"></td>
    <td class="formField"><input type="text" id="fieldName"/></td>
  </tr>
  
  <tbody id="columnBasedProperties">
    <tr>
      <td class="formLabel">Time override column</td>
      <td class="formField"><input type="text" id="timeOverrideName"/></td>
    </tr>
  </tbody>
  
  <tr>
    <td class="formLabel">Update statement</td>
    <td class="formField"><textarea cols="35" rows="4" name="updateStatement"></textarea></td>
  </tr>
<%@ include file="/WEB-INF/jsp/dataSourceEdit/pointsFoot.jspf" %>