<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<mango:header>
  <mango:script src='dwr/interface/DataSourceListDwr.js'/>
  <mango:script>
    <script>
    function init() {
        DataSourceListDwr.init(initCB);
    }
    dojo.addOnLoad(init);
    
    function initCB(response) {
        dwr.util.addOptions("dataSourceTypes", response.data.types, "key", "value");
    }
    
    function toggleDataSource(dataSourceId) {
        var imgNode = $("dsImg"+ dataSourceId);
        if (!hasImageFader(imgNode)) {
            DataSourceListDwr.toggleDataSource(dataSourceId, toggleDataSourceCB);
            startImageFader(imgNode);
        }
    }
    
    function toggleDataSourceCB(result) {
        updateStatusImg($("dsImg"+ result.id), result.enabled, true);
    }
    
    function toggleDataPoint(dataPointId) {
        var imgNode = $("dpImg"+ dataPointId);
        if (!hasImageFader(imgNode)) {
            DataSourceListDwr.toggleDataPoint(dataPointId, toggleDataPointCB);
            startImageFader(imgNode);
        }
    }
    
    function toggleDataPointCB(result) {
        updateStatusImg($("dpImg"+ result.data.id), result.data.enabled, false);
    }
    
    function updateStatusImg(imgNode, enabled, ds) {
        stopImageFader(imgNode);
        if (ds)
            setDataSourceStatusImg(enabled, imgNode);
        else
            setDataPointStatusImg(enabled, imgNode);
    }
    
    function deleteDataSource(dataSourceId) {
        if (confirm("Are you sure you wish to delete this data source?")) {
            startImageFader("deleteDataSourceImg"+ dataSourceId);
            DataSourceListDwr.deleteDataSource(dataSourceId, deleteDataSourceCB);
        }
    }
    
    function deleteDataSourceCB(dataSourceId) {
        stopImageFader("deleteDataSourceImg"+ dataSourceId);
        // Delete the data source row
        var row = $("dataSourceRow"+ dataSourceId);
        row.parentNode.removeChild(row);
        // Delete the points section.
        row = $("points"+ dataSourceId);
        row.parentNode.removeChild(row);
    }
    
    function deleteDataPoint(pointId) {
        if (confirm("Are you sure you wish to delete this point?"))
            DataSourceListDwr.deleteDataPoint(pointId, deleteDataPointCB);
    }
    
    function deleteDataPointCB(pointId) {
        var row = $("pointRow"+ pointId);
        row.parentNode.removeChild(row);
    }
    
    function addDataSource() {
        window.location = "data_source_edit.shtm?typeId="+ $get("dataSourceTypes");
    }
    </script>
  </mango:script>
</mango:header>

<table cellspacing="0" cellpadding="0">
  <tr>
    <td>
      <img src="images/icon_ds.png" alt="Data sources" title="Data sources"/>
      <span class="smallTitle">Data sources</span>
      <mango:help id="W0Jp5gjC7aHdCeZmm0lb"/>
    </td>
    <td align="right">
      <select id="dataSourceTypes"></select>
      <mango:img png="icon_ds_add" title="New data source" onclick="addDataSource()"/>
    </td>
  </tr>
  
  <tr>
    <td colspan="2">
      <table cellspacing="0" cellpadding="0" border="0">
        <tr>
          <td colspan="2">
            <table cellspacing="1" cellpadding="0" border="0">
              <tr class="rowHeader">
                <td><sst:listSort label="Name" field="name" paging="${paging}"/></td>
                <td><sst:listSort label="Type" field="type" paging="${paging}"/></td>
                <td><sst:listSort label="Connection" field="conn" paging="${paging}"/></td>
                <td><sst:listSort label="Status" field="enabled" paging="${paging}"/></td>
                <td></td>
              </tr>
              <c:forEach items="${paging.data}" var="listParent" begin="${paging.offset}" end="${paging.endIndex}">
                <tr class="row" id="dataSourceRow${listParent.parent.id}">
                  <td><b>${listParent.parent.name}</b></td>
                  <td>${listParent.parent.typeDescription}</td>
                  <td>${listParent.parent.connectionDescription}</td>
                  <td align="center">
                    <c:choose>
                      <c:when test="${listParent.parent.enabled}">
                        <img src="images/database_go.png" alt="Enabled - click to disable" class="ptr"
                                title="Enabled - click to disable" onclick="toggleDataSource(${listParent.parent.id})"
                                id="dsImg${listParent.parent.id}"/>
                      </c:when>
                      <c:otherwise>
                        <img src="images/database_stop.png" alt="Disabled - click to enable" class="ptr"
                                title="Disabled - click to enable" onclick="toggleDataSource(${listParent.parent.id})"
                                id="dsImg${listParent.parent.id}"/>
                      </c:otherwise>
                    </c:choose>
                  </td>
                  <td>
                    <a href="data_source_edit.shtm?dsid=${listParent.parent.id}"><img src="images/icon_ds_edit.png"
                            border="0" alt="Edit" title="Edit"/></a>
                    <img src="images/arrow_out.png" alt="Show points" title="Show points" class="ptr"
                            onclick="togglePanelVisibility2(this, 'points${listParent.parent.id}', 'Hide points', 'Show points');"/>
                    <img src="images/icon_ds_delete.png" alt="Delete data source" title="Delete data source"
                            id="deleteDataSourceImg${listParent.parent.id}" class="ptr" 
                            onclick="deleteDataSource(${listParent.parent.id})"/>
                  </td>
                </tr>
                
                <tr id="points${listParent.parent.id}" class="rowAlt2" style="display:none">
                  <td colspan="5" style="padding:0px 0px 0px 30px;background-color:#FFFFFF;">
                    <table cellspacing="1" cellpadding="0" border="0">
                      <tr class="rowHeader">
                        <td>Point name</td>
                        <td>Description</td>
                        <td>Status</td>
                      </tr>
                      <c:forEach items="${listParent.list}" var="point">
                        <tr id="pointRow${point.id}">
                          <td>${point.name}</td>
                          <td>${point.dataTypeDescription} / ${point.configurationDescription}</td>
                          <td align="center">
                            <c:choose>
                              <c:when test="${point.enabled}">
                                <img src="images/brick_go.png" alt="Enabled - click to disable" class="ptr"
                                        title="Enabled - click to disable" onclick="toggleDataPoint(${point.id})"
                                        id="dpImg${point.id}"/>
                              </c:when>
                              <c:otherwise>
                                <img src="images/brick_stop.png" alt="Disabled - click to enable" class="ptr"
                                        title="Disabled - click to enable" onclick="toggleDataPoint(${point.id})"
                                        id="dpImg${point.id}"/>
                              </c:otherwise>
                            </c:choose>
                          </td>
                        </tr>
                      </c:forEach>
                    </table>
                  </td>
                </tr>
              </c:forEach>
            </table>
          </td>
        </tr>
        <tr>
          <td><sst:pageNumber paging="${paging}"/></td>
          <td align="right"><sst:pagination paging="${paging}"/></td>
        </tr>
      </table>  
    </td>
  </tr>
</table>

<mango:footer/>