<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.Common"%>
<%@page import="com.serotonin.mango.vo.event.EventHandlerVO"%>
<%@page import="com.serotonin.mango.DataTypes"%>
<mango:header onload="init()">
  <mango:script src='dwr/interface/EventHandlersDwr.js'/>
  <mango:script src='resources/emailRecipients.js'/>
  <mango:script>
    <script>
    function init() {
        EventHandlersDwr.getInitData(initCB);
        var tree = dojo.widget.manager.getWidgetById('eventTypeTree');
        dojo.event.topic.subscribe("eventTypeTree/titleClick", new TreeClickHandler(), 'handle');
    }
    
    var allPoints;
    var defaultHandlerId;
    var emailRecipients;
    var escalRecipients;
    
    function initCB(data) {
        <c:if test="${!empty param.ehid}">
          defaultHandlerId = ${param.ehid};
        </c:if>
    
        var i, j, k;
        var dp, ds, p, et;
        var pointNode, dataSourceNode, publisherNode, etNode, wid;
        
        allPoints = data.allPoints;
        
        emailRecipients = new mango.erecip.EmailRecipients("emailRecipients",
                "This message was sent as a test of an event handler's email recipient list",
                data.mailingLists, data.users);
        emailRecipients.write("emailRecipients", "emailRecipients", null, "Email recipients");
        
        escalRecipients = new mango.erecip.EmailRecipients("escalRecipients",
                "This message was sent as a test of an event handler's escalation list",
                data.mailingLists, data.users);
        escalRecipients.write("escalRecipients", "escalRecipients", "escalationAddresses2", "Escalation recipients");
        
        var pointRoot = dojo.widget.manager.getWidgetById('rootPoint');
        for (i=0; i<data.dataPoints.length; i++) {
            dp = data.dataPoints[i];
            pointNode = dojo.widget.createWidget("TreeNode", {
                    title: "<img src='images/icon_comp.png'/> "+ dp.name,
                    object: dp
            });
            pointRoot.addChild(pointNode);
            
            for (j=0; j<dp.eventTypes.length; j++) {
                et = dp.eventTypes[j];
                createEventTypeNode("ped"+ et.typeRef2, et, pointNode);
            }
        }
        pointRoot.expand();
        
        var scheduledRoot = dojo.widget.manager.getWidgetById('rootScheduled');
        for (i=0; i<data.scheduledEvents.length; i++) {
            et = data.scheduledEvents[i];
            createEventTypeNode("sch"+ et.typeRef1, et, scheduledRoot);
        }
        scheduledRoot.expand();
        
        var compoundRoot = dojo.widget.manager.getWidgetById('rootCompound');
        for (i=0; i<data.compoundEvents.length; i++) {
            et = data.compoundEvents[i];
            createEventTypeNode("ced"+ et.typeRef1, et, compoundRoot);
        }
        compoundRoot.expand();
        
        var dataSourceRoot = dojo.widget.manager.getWidgetById('rootDataSource');
        for (i=0; i<data.dataSources.length; i++) {
            ds = data.dataSources[i];
            dataSourceNode = dojo.widget.createWidget("TreeNode", {
                    title: "<img src='images/icon_ds.png'/> "+ ds.name,
                    object: ds
            });
            dataSourceRoot.addChild(dataSourceNode);
            
            for (j=0; j<ds.eventTypes.length; j++) {
                et = ds.eventTypes[j];
                createEventTypeNode("dse"+ et.typeRef1 +"/"+ et.typeRef2, et, dataSourceNode);
            }
        }
        
        if (data.publishers) {
            var publisherRoot = dojo.widget.manager.getWidgetById('rootPublisher');
            for (i=0; i<data.publishers.length; i++) {
                p = data.publishers[i];
                publisherNode = dojo.widget.createWidget("TreeNode", {
                        title: "<img src='images/transmit.png'/> "+ p.name,
                        object: p
                });
                publisherRoot.addChild(publisherNode);
                
                for (j=0; j<p.eventTypes.length; j++) {
                    et = p.eventTypes[j];
                    createEventTypeNode("pube"+ et.typeRef1 +"/"+ et.typeRef2, et, publisherNode);
                }
            }
        }
        
        if (data.systemEvents) {
            var systemRoot = dojo.widget.manager.getWidgetById('rootSystem');
            for (i=0; i<data.systemEvents.length; i++) {
                et = data.systemEvents[i];
                createEventTypeNode("sys"+ et.typeRef1, et, systemRoot);
            }
        }
        
        dojo.html.hide("loadingImg");
        dojo.html.show("tree");
        
        // Default the selection of the parameter was provided.
        if (selectedHandlerNode) {
            selectedHandlerNode.onTitleClick();
            var parent = selectedHandlerNode.parent;
            while (parent && parent.expand) {
                parent.expand();
                parent = parent.parent;
            }
        }
        defaultHandlerId = null;
    }
    
    function createEventTypeNode(widgetId, eventType, parent) {
        var node = dojo.widget.createWidget("TreeNode", {
                title: "<img id='"+ widgetId +"Img'/> "+ eventType.description,
                widgetId: widgetId,
                object: eventType
        });
        parent.addChild(node);
        setAlarmLevelImg(eventType.alarmLevel, $(widgetId +"Img"));
        addHandlerNodes(eventType.handlers, node);
    }
    
    function addHandlerNodes(handlers, parent) {
        for (var i=0; i<handlers.length; i++)
            parent.addChild(createHandlerNode(handlers[i]));
    }
    
    function createHandlerNode(handler) {
        var img = "images/cog_wrench.png";
        if (handler.handlerType == <%= EventHandlerVO.TYPE_EMAIL %>)
            img = "images/cog_email.png";
        var node = dojo.widget.createWidget("TreeNode", {
                title: "<img src='"+ img +"'/> "+ handler.description,
                widgetId: "h"+ handler.id,
                object: handler
        });
        
        if (handler.id == defaultHandlerId)
            selectedHandlerNode = node;
        
        return node;
    }
    
    var selectedEventTypeNode;
    var selectedHandlerNode;
    
    var TreeClickHandler = function() {
        this.handle = function(message) {
            var widget = message.source;
            var wid = widget.widgetId;
            if (wid.startsWith("ped") || wid.startsWith("sch") || wid.startsWith("ced") || 
                    wid.startsWith("dse") || wid.startsWith("pube") || wid.startsWith("sys")) {
                selectedEventTypeNode = widget;
                selectedHandlerNode = null;
                showHandlerEdit();
            }
            else if (wid.startsWith("h")) {
                selectedHandlerNode = widget;
                selectedEventTypeNode = selectedHandlerNode.parent;
                showHandlerEdit();
            }
            else
                dojo.html.hide("handlerEditDiv");
        }
    }
    
    function showHandlerEdit() {
        dojo.html.show("handlerEditDiv");
        setUserMessage("");
        
        // Set the target points.
        var pointSelect = $("targetPointSelect");
        dwr.util.removeAllOptions(pointSelect);
        for (var i=0; i<allPoints.length; i++) {
            dp = allPoints[i];
            if (dp.settable)
                pointSelect.options[pointSelect.options.length] = new Option(dp.name, dp.id);
        }
        
        if (selectedHandlerNode) {
            $("saveImg").src = "images/save.png";
            dojo.html.show("deleteImg");
            
            // Put values from the handler object into the input controls.
            var handler = selectedHandlerNode.object;
            $set("handlerTypeSelect", handler.handlerType);
            $("handlerTypeSelect").disabled = true;
            if (handler.handlerType == <%= EventHandlerVO.TYPE_SET_POINT %>) {
                $set("targetPointSelect", handler.targetPointId);
                $set("activeAction", handler.activeAction);
                $set("inactiveAction", handler.inactiveAction);
            }
            else {
                emailRecipients.updateRecipientList(handler.activeRecipients);
                $set("sendEscalation", handler.sendEscalation);
                $set("escalationDelayType", handler.escalationDelayType);
                $set("escalationDelay", handler.escalationDelay);
                escalRecipients.updateRecipientList(handler.escalationRecipients);
                $set("sendInactive", handler.sendInactive);
            }
        }
        else {
            $("saveImg").src = "images/save_add.png";
            dojo.html.hide("deleteImg");
            $("handlerTypeSelect").disabled = false;
            
            // Clear values that may be left over from another handler.
            $set("activeAction", <%= EventHandlerVO.SET_ACTION_NONE %>);
            $set("inactiveAction", <%= EventHandlerVO.SET_ACTION_NONE %>);
            $set("sendEscalation", false);
            $set("escalationDelayType", <%= Common.TimePeriods.HOURS %>);
            $set("escalationDelay", 1);
            $set("sendInactive", false);
            
            // Clear the recipient lists.
            emailRecipients.updateRecipientList();
            escalRecipients.updateRecipientList();
        }
        
        // Set the use source value checkbox.
        handlerTypeChanged();
        activeActionChanged();
        inactiveActionChanged();
        targetPointSelectChanged();
        sendEscalationChanged();
    }
    
    var currentHandlerEditor;
    function handlerTypeChanged() {
        setUserMessage();
        var handlerId = $get("handlerTypeSelect");
        if (currentHandlerEditor) {
            dojo.html.hide(currentHandlerEditor);
            dojo.html.hide($(currentHandlerEditor.id +"Img"));
        }
        currentHandlerEditor = $("handler"+ handlerId);
        dojo.html.show(currentHandlerEditor);
        dojo.html.show($(currentHandlerEditor.id +"Img"));
    }
    
    function targetPointSelectChanged() {
        var selectControl = $("targetPointSelect");
        
        // Make sure there are points in the list.
        if (selectControl.options.length == 0)
            return;
        
        // Get the content for the value to set section.
        var targetPointId = selectControl.value;
        var activeValueStr = "";
        var inactiveValueStr = "";
        if (selectedHandlerNode) {
            activeValueStr = selectedHandlerNode.object.activeValueToSet;
            inactiveValueStr = selectedHandlerNode.object.inactiveValueToSet;
        }
        EventHandlersDwr.createSetValueContent(targetPointId, activeValueStr, "Active",
                function(content) { $("activeValueToSetContent").innerHTML = content; });
        EventHandlersDwr.createSetValueContent(targetPointId, inactiveValueStr, "Inactive",
                function(content) { $("inactiveValueToSetContent").innerHTML = content; });
        
        // Update the source point lists.
        var targetDataTypeId = getPoint(targetPointId).dataType;
        var activeSourceSelect = $("activePointId");
        dwr.util.removeAllOptions(activeSourceSelect);
        var inactiveSourceSelect = $("inactivePointId");
        dwr.util.removeAllOptions(inactiveSourceSelect);
        for (var i=0; i<allPoints.length; i++) {
            dp = allPoints[i];
            if (dp.id != targetPointId && dp.dataType == targetDataTypeId) {
                activeSourceSelect.options[activeSourceSelect.options.length] = new Option(dp.name, dp.id);
                inactiveSourceSelect.options[activeSourceSelect.options.length] = new Option(dp.name, dp.id);
            }
        }
        if (selectedHandlerNode) {
            $set(activeSourceSelect, selectedHandlerNode.object.activePointId);
            $set(inactiveSourceSelect, selectedHandlerNode.object.inactivePointId);
        }
    }
    
    function activeActionChanged() {
        var action = $get("activeAction");
        if (action == <%= EventHandlerVO.SET_ACTION_POINT_VALUE %>) {
            dojo.html.show("activePointIdRow");
            dojo.html.hide("activeValueToSetRow");
        }
        else if (action == <%= EventHandlerVO.SET_ACTION_STATIC_VALUE %>) {
            dojo.html.hide("activePointIdRow");
            dojo.html.show("activeValueToSetRow");
        }
        else {
            dojo.html.hide("activePointIdRow");
            dojo.html.hide("activeValueToSetRow");
        }
    }
    
    function inactiveActionChanged() {
        var action = $get("inactiveAction");
        if (action == <%= EventHandlerVO.SET_ACTION_POINT_VALUE %>) {
            dojo.html.show("inactivePointIdRow");
            dojo.html.hide("inactiveValueToSetRow");
        }
        else if (action == <%= EventHandlerVO.SET_ACTION_STATIC_VALUE %>) {
            dojo.html.hide("inactivePointIdRow");
            dojo.html.show("inactiveValueToSetRow");
        }
        else {
            dojo.html.hide("inactivePointIdRow");
            dojo.html.hide("inactiveValueToSetRow");
        }
    }
    
    function sendEscalationChanged() {
        if ($get("sendEscalation")) {
            dojo.html.show("escalationAddresses1");
            dojo.html.show("escalationAddresses2");
        }
        else {
            dojo.html.hide("escalationAddresses1");
            dojo.html.hide("escalationAddresses2");
        }
    }
    
    function getPoint(id) {
        return getElement(allPoints, id);
    }
    
    function saveHandler() {
        var handlerId = <%= Common.NEW_ID %>;
        if (selectedHandlerNode)
            handlerId = selectedHandlerNode.object.id;
        
        // Do some validation.
        var handlerType = $get("handlerTypeSelect");
        if (handlerType == <%= EventHandlerVO.TYPE_EMAIL %>) {
            var emailList = emailRecipients.createRecipientArray();
            var escalList = escalRecipients.createRecipientArray();
            var sendEscal = $get("sendEscalation");
            var escalDelay = parseInt($get("escalationDelay"));
            if (isNaN(escalDelay))
                escalDelay = 0;
        
            if (emailList.length == 0)
                setUserMessage("You must add email recipients");
            else if (sendEscal && escalDelay <= 0)
                setUserMessage("Escalation delay must be greater than zero");
            else if (sendEscal && escalList.length == 0)
                setUserMessage("You must add escalation recipients");
            else
                EventHandlersDwr.saveEmailEventHandler(selectedEventTypeNode.object.typeId,
                        selectedEventTypeNode.object.typeRef1, selectedEventTypeNode.object.typeRef2, handlerId,
                        emailList, sendEscal, $get("escalationDelayType"), escalDelay, escalList,
                        $get("sendInactive"), saveEventHandlerCB);
        }
        else if (handlerType == <%= EventHandlerVO.TYPE_SET_POINT %>) {
            var targetPointId = $get("targetPointSelect");
            var targetPoint = getPoint(targetPointId);
            if (targetPoint) {
                var activeAction = $get("activeAction");
                var activeValueStr = $get("setPointValueActive");
                var activePointId = $get("activePointId");
                var inactiveAction = $get("inactiveAction");
                var inactiveValueStr = $get("setPointValueInactive");
                var inactivePointId = $get("inactivePointId");
                
                if (activeAction == <%= EventHandlerVO.SET_ACTION_NONE %> && 
                        inactiveAction == <%= EventHandlerVO.SET_ACTION_NONE %>)
                    setUserMessage("No set point action has been defined");
                if (activeAction == <%= EventHandlerVO.SET_ACTION_STATIC_VALUE %> && 
                        targetPoint.dataType == <%= DataTypes.MULTISTATE %> && isNaN(parseInt(activeValueStr)))
                    setUserMessage("Invalid active value to set");
                else if (activeAction == <%= EventHandlerVO.SET_ACTION_STATIC_VALUE %> &&
                        targetPoint.dataType == <%= DataTypes.NUMERIC %> && isNaN(parseFloat(activeValueStr)))
                    setUserMessage("Invalid active value to set");
                else if (activeAction == <%= EventHandlerVO.SET_ACTION_POINT_VALUE %> && activePointId == 0)
                    setUserMessage("Invalid active source point");
                else if (inactiveAction == <%= EventHandlerVO.SET_ACTION_STATIC_VALUE %> &&
                        targetPoint.dataType == <%= DataTypes.MULTISTATE %> && isNaN(parseInt(inactiveValueStr)))
                    setUserMessage("Invalid inactive value to set");
                else if (inactiveAction == <%= EventHandlerVO.SET_ACTION_STATIC_VALUE %> &&
                        targetPoint.dataType == <%= DataTypes.NUMERIC %> && isNaN(parseFloat(inactiveValueStr)))
                    setUserMessage("Invalid inactive value to set");
                else if (inactiveAction == <%= EventHandlerVO.SET_ACTION_STATIC_VALUE %> &&
                        targetPoint.dataType == <%= DataTypes.NUMERIC %> && isNaN(parseFloat(inactiveValueStr)))
                    setUserMessage("Invalid inactive value to set");
                else if (inactiveAction == <%= EventHandlerVO.SET_ACTION_POINT_VALUE %> && inactivePointId == 0)
                    setUserMessage("Invalid inactive source point");
                else
                    EventHandlersDwr.saveSetPointEventHandler(selectedEventTypeNode.object.typeId,
                            selectedEventTypeNode.object.typeRef1, selectedEventTypeNode.object.typeRef2, handlerId, 
                            targetPointId, activeAction, activeValueStr, activePointId, inactiveAction,
                            inactiveValueStr, inactivePointId, saveEventHandlerCB);
            }
            else
                setUserMessage("No target point selected. You may not have any settable points defined.");
        }
    }
    
    function saveEventHandlerCB(handler) {
        setUserMessage("Event handler has been saved");
        if (!selectedHandlerNode) {
            selectedHandlerNode = createHandlerNode(handler);
            selectedEventTypeNode.addChild(selectedHandlerNode);
            selectedEventTypeNode.expand();
            selectedHandlerNode.onTitleClick();
        }
        
        selectedHandlerNode.object = handler;
        
        // The following code doesn't actually change the titleNode inner html in the tree node.
        //selectedHandlerNode.title = handler.description;
    }
    
    function deleteHandler() {
        EventHandlersDwr.deleteEventHandler(selectedHandlerNode.object.id);
        selectedEventTypeNode.removeNode(selectedHandlerNode);
        dojo.html.hide("handlerEditDiv");
    }
    
    function setUserMessage(msg) {
        showMessage("userMessage", msg);
    }
    </script>
  </mango:script>
</mango:header>

<table class="borderDiv marB"><tr><td>
  <img src="images/cog.png" alt="Event handlers" title="Event handlers"/>
  <span class="smallTitle">Event handlers</span>
  <mango:help id="F5Uro7zKcM9UEbt7YkhI"/>
</td></tr></table>

<table cellpadding="0" cellspacing="0">
  <tr>
    <td valign="top">
      <div class="borderDivPadded marR">
        <span class="smallTitle">Event types</span>
        <div dojoType="TreeBasicController" widgetId="controller"></div>
        <img src="images/hourglass.png" id="loadingImg"/>
        <div id="tree" style="display:none;">
          <div dojoType="Tree" widgetId="eventTypeTree" listeners="controller" toggle="wipe">
            <div dojoType="TreeNode" title="<img src='images/bell.png'/> Point event detectors" widgetId="rootPoint"></div>
            <div dojoType="TreeNode" title="<img src='images/clock.png'/> Scheduled events" widgetId="rootScheduled"></div>
            <div dojoType="TreeNode" title="<img src='images/multi_bell.png'/> Compound event detectors" widgetId="rootCompound"></div>
            <div dojoType="TreeNode" title="Data source events" widgetId="rootDataSource"></div>
            <div dojoType="TreeNode" title="Publisher events" widgetId="rootPublisher"></div>
            <div dojoType="TreeNode" title="System events" widgetId="rootSystem"></div>
          </div>
        </div>
      </div>
    </td>
    
    <td valign="top">
      <div id="handlerEditDiv" class="borderDivPadded" style="display:none;">
        <table width="100%">
          <tr>
            <td class="smallTitle">Event handler</td>
            <td align="right">
              <img id="deleteImg" src="images/delete.png" title="Delete this handler" class="ptr"
                      onclick="deleteHandler();"/>
              <img id="saveImg" src="images/save.png" title="Save this handler" class="ptr"
                      onclick="saveHandler();"/>
            </td>
          </tr>
          <tr><td class="formError" id="userMessage"></td></tr>
        </table>
        
        <table width="100%">
          <tr>
            <td class="formLabelRequired">Type</td>
            <td class="formField">
              <select id="handlerTypeSelect" onchange="handlerTypeChanged()">
                <option value="<%= Integer.toString(EventHandlerVO.TYPE_EMAIL) %>">Email</option>
                <option value="<%= Integer.toString(EventHandlerVO.TYPE_SET_POINT) %>">Set point</option>
              </select>
              <img id="handler1Img" src="images/cog_wrench.png" title="Set point handler" style="display:none;"/>
              <img id="handler2Img" src="images/cog_email.png" title="Email handler" style="display:none;"/>
            </td>
          </tr>
          
          <tr><td class="horzSeparator" colspan="2"></td></tr>
        </table>
        
        <table id="handler<%= Integer.toString(EventHandlerVO.TYPE_SET_POINT) %>" style="display:none" width="100%">
          <tr>
            <td class="formLabelRequired">Target</td>
            <td class="formField">
              <select id="targetPointSelect" onchange="targetPointSelectChanged()"></select>
            </td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Active action</td>
            <td class="formField">
              <select id="activeAction" onchange="activeActionChanged()">
                <option value="<%= EventHandlerVO.SET_ACTION_NONE %>">None</option>
                <option value="<%= EventHandlerVO.SET_ACTION_POINT_VALUE %>">Set to point value</option>
                <option value="<%= EventHandlerVO.SET_ACTION_STATIC_VALUE %>">Set to static value</option>
              </select>
            </td>
          </tr>
        
          <tr id="activePointIdRow">
            <td class="formLabel">Source point</td>
            <td class="formField"><select id="activePointId"></select></td>
          </tr>
        
          <tr id="activeValueToSetRow">
            <td class="formLabel">Value to set</td>
            <td class="formField" id="activeValueToSetContent"></td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Inactive action</td>
            <td class="formField">
              <select id="inactiveAction" onchange="inactiveActionChanged()">
                <option value="<%= EventHandlerVO.SET_ACTION_NONE %>">None</option>
                <option value="<%= EventHandlerVO.SET_ACTION_POINT_VALUE %>">Set to point value</option>
                <option value="<%= EventHandlerVO.SET_ACTION_STATIC_VALUE %>">Set to static value</option>
              </select>
            </td>
          </tr>
        
          <tr id="inactivePointIdRow">
            <td class="formLabel">Source point</td>
            <td class="formField"><select id="inactivePointId"></select></td>
          </tr>
        
          <tr id="inactiveValueToSetRow">
            <td class="formLabel">Value to set</td>
            <td class="formField" id="inactiveValueToSetContent"></td>
          </tr>
        </table>
        
        <table id="handler<%= Integer.toString(EventHandlerVO.TYPE_EMAIL) %>" style="display:none" width="100%">
          <tbody id="emailRecipients"></tbody>
          
          <tr><td class="horzSeparator" colspan="2"></td></tr>
          
          <tr>
            <td class="formLabelRequired">Send escalation</td>
            <td class="formField"><input id="sendEscalation" type="checkbox" onclick="sendEscalationChanged()"/></td>
          </tr>
          
          <tr id="escalationAddresses1">
            <td class="formLabelRequired">Escalate if active for</td>
            <td class="formField">
              <input id="escalationDelay" type="text" class="formShort"/>
              <select id="escalationDelayType">
                <option value="<%= Common.TimePeriods.MINUTES %>">minute(s)</option>
                <option value="<%= Common.TimePeriods.HOURS %>">hour(s)</option>
                <option value="<%= Common.TimePeriods.DAYS %>">days(s)</option>
              </select>
            </td>
          </tr>
            
          <tbody id="escalRecipients"></tbody>
          
          <tr><td class="horzSeparator" colspan="2"></td></tr>
          
          <tr>
            <td class="formLabelRequired">Send inactive notification</td>
            <td class="formField"><input id="sendInactive" type="checkbox"/></td>
          </tr>
        </table>
      </div>
    </td>
  </tr>
</table>

<mango:footer/>