<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.vo.UserComment"%>
<mango:header/>

<%@ include file="/WEB-INF/jsp/include/userComment.jsp" %>

<table cellspacing="0" cellpadding="0" border="0"><tr><td>
  <table width="100%" cellspacing="0" cellpadding="0" border="0">
    <tr>
      <td class="smallTitle">
        <img src="images/flag_white.png" alt="Alarms" title="Alarms"/>
        <c:choose>
          <c:when test="${paging.inactive}">Inactive alarms</c:when>
          <c:otherwise>Active alarms</c:otherwise>
        </c:choose>
      </td>
      <td align="right">
        <c:choose>
          <c:when test="${paging.inactive}">
            <a href="<sst:paginationUrl paging="${paging}" excludeParams="inactive"/>inactive=false">Show active 
                    alarms</a>
          </c:when>
          <c:otherwise>
            <a href="<sst:paginationUrl paging="${paging}" excludeParams="inactive"/>inactive=true">Show inactive 
                    alarms</a>
          </c:otherwise>
        </c:choose>
      </td>
    </tr>
  </table>
  
  <form action="" method="get">
    <table cellspacing="0" cellpadding="0">
      <c:set var="ackShown" value="false"/>
      <tr>
        <td colspan="2">
          <table id="eventsTable" cellspacing="1" cellpadding="0" border="0">
            <tr class="rowHeader">
              <td><sst:listSort label="Id" field="id" paging="${paging}"/></td>
              <td><sst:listSort label="Alarm level" field="alarmLevel" paging="${paging}"/></td>
              <td><sst:listSort label="Time" field="time" paging="${paging}"/></td>
              <td><sst:listSort label="Message" field="msg" paging="${paging}"/></td>
              <c:choose>
                <c:when test="${paging.inactive}"><td><sst:listSort label="Inactive time" field="itime"
                        paging="${paging}"/></td></c:when>
                <c:otherwise><td></td></c:otherwise>
              </c:choose>
            </tr>
            <c:forEach items="${paging.data}" var="event" varStatus="status" begin="${paging.offset}"
                    end="${paging.endIndex}">
              <tr class="row${status.index % 2 == 0 ? "" : "Alt"}">
                <td align="center">${event.id}</td>
                <td align="center"><%@ include file="/WEB-INF/snippet/eventIcon.jsp" %></td>
                <td>${sst:time(event.activeTimestamp)}</td>
                <td>
                  <table cellspacing="0" cellpadding="0" width="100%">
                    <tr>
                      <td colspan="2"><b>${event.message}</b></td>
                      <c:if test="${paging.inactive}">
                        <td align="right">
                          <img src="images/comment_add.png" title="Add comment" alt="Add comment" class="ptr"
                                  onclick="openCommentDialog(<%= UserComment.TYPE_EVENT %>, ${event.id})"/>
                        </td>
                      </c:if>
                    </tr>
                    <tbody id="eventComments${event.id}">
                      <c:forEach items="${event.eventComments}" var="comment">
                        <tr>
                          <td valign="top" width="16"><img src="images/comment.png" title="Comment" alt="Comment"/></td>
                          <td valign="top">
                            <span class="copyTitle">${comment.prettyTime} by ${comment.username}</span><br/>
                            ${comment.comment}
                          </td>
                        </tr>
                      </c:forEach>
                    </tbody>
                  </table>
                </td>
                <c:choose>
                  <c:when test="${paging.inactive}">
                    <td>${sst:time(event.inactiveTimestamp)} - ${event.inactiveDescription}</td>
                  </c:when>
                  <c:otherwise>
                    <td style="white-space:nowrap;">
                      <img src="images/comment_add.png" title="Add comment" alt="Add comment" class="ptr"
                              onclick="openCommentDialog(<%= UserComment.TYPE_EVENT %>, ${event.id})"/>
                      <c:choose>
                        <c:when test="${event.eventType.eventSourceId == applicationScope['constants.EventType.EventSources.DATA_POINT']}">
                          <a href="data_point_details.shtm?dpid=${event.eventType.dataPointId}"><img 
                                  src="images/icon_comp.png" border="0" alt="Point details" title="Point details"/></a>
                        </c:when>
                        <c:when test="${event.eventType.eventSourceId == applicationScope['constants.EventType.EventSources.DATA_SOURCE']}">
                          <a href="data_source_edit.shtm?dsid=${event.eventType.dataSourceId}"><img border="0" 
                                  src="images/icon_ds_edit.png" alt="Edit data source" title="Edit data source"/></a>
                        </c:when>
                        <c:when test="${event.eventType.eventSourceId == applicationScope['constants.EventType.EventSources.SYSTEM']}">
                          <c:choose>
                            <c:when test="${event.eventType.systemEventTypeId == applicationScope['constants.SystemEventType.TYPE_VERSION_CHECK']}">
                              <a href="http://mango.serotoninsoftware.com/download.jsp" target="_blank"><img border="0"
                                      src="images/bullet_down.png" alt="Download the latest Mango release" 
                                      title="Download latest Mango release"/></a>
                            </c:when>
                            <c:when test="${event.eventType.systemEventTypeId == applicationScope['constants.SystemEventType.TYPE_COMPOUND_DETECTOR_FAILURE']}">
                              <a href="compound_events.shtm?cedid=${event.eventType.referenceId2}"><img border="0"
                                      src="images/multi_bell.png" alt="Edit compound event detector" 
                                      title="Edit compound event detector"/></a>
                            </c:when>
                            <c:when test="${event.eventType.systemEventTypeId == applicationScope['constants.SystemEventType.TYPE_SET_POINT_HANDLER_FAILURE']}">
                              <a href="event_handlers.shtm?ehid=${event.eventType.referenceId2}"><img border="0" 
                                      src="images/cog.png" alt="Edit event handler" title="Edit event handler"/></a>
                            </c:when>
                          </c:choose>
                        </c:when>
                        <c:when test="${event.eventType.eventSourceId == applicationScope['constants.EventType.EventSources.COMPOUND']}">
                          <a href="compound_events.shtm?cedid=${event.eventType.compoundEventDetectorId}"><img 
                                  src="images/multi_bell.png" border="0" alt="Edit compound event detector"
                                  title="Edit compound event detector"/></a>
                        </c:when>
                        <c:when test="${event.eventType.eventSourceId == applicationScope['constants.EventType.EventSources.SCHEDULED']}">
                          <a href="scheduled_events.shtm?seid=${event.eventType.scheduleId}"><img src="images/clock.png" 
                                  border="0" alt="Edit scheduled event" title="Edit scheduled event"/></a>
                        </c:when>
                        <c:when test="${event.eventType.eventSourceId == applicationScope['constants.EventType.EventSources.PUBLISHER']}">
                          <a href="publisher_edit.shtm?pid=${event.eventType.publisherId}"><img border="0" 
                                  src="images/transmit_edit.png" alt="Edit publisher" title="Edit publisher"/></a>
                        </c:when>
                        <c:otherwise>(unknown event source id ${event.eventType.eventSourceId})</c:otherwise>
                      </c:choose>
                      
                      <c:if test="${!event.rtnApplicable}">
                        <c:set var="ackShown" value="true"/>
                        <input id="ackId${event.id}" type="checkbox" name="ackIds" value="${event.id}"/><label 
                                for="ackId${event.id}">Ack</label>
                      </c:if>
                    </td>
                  </c:otherwise>
                </c:choose>
              </tr>
            </c:forEach>
          </table>
        </td>
      </tr>
      <tr>
        <td><sst:pageNumber paging="${paging}"/></td>
        <td align="right"><sst:pagination paging="${paging}"/></td>
      </tr>
      <tr>
        <td colspan="2" align="right">
          <br/>
          <c:choose>
            <c:when test='${ackShown == "true"}'>
              <input type="submit" value="Submit acknowledgements"/>
            </c:when>
            <c:otherwise>
              <input type="submit" value="Submit acknowledgements" class="formDisabled" disabled="disabled"/>
            </c:otherwise>
          </c:choose>
        </td>
      </tr>
    </table>
  </form>
</td></tr></table>

<mango:footer/>