<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<html>
<head>
  <title>Mango, by Serotonin</title>
  
  <!-- Meta -->
  <meta http-equiv="content-type" content="application/xhtml+xml;charset=utf-8"/>
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <meta name="Copyright" content="&copy;2006-2007 Serotonin Software Technologies Inc."/>
  <meta name="DESCRIPTION" content="Mango Serotonin Software"/>
  <meta name="KEYWORDS" content="Mango Serotonin Software"/>
  
  <!-- Style -->
  <link rel="icon" href="images/favicon.ico"/>
  <link rel="shortcut icon" href="images/favicon.ico"/>
  <link href="resources/common.css" type="text/css" rel="stylesheet"/>
  <c:forEach items="${styles}" var="style">
    ${style}</c:forEach>
  
  <!-- Scripts -->
  <script type="text/javascript">var djConfig = { isDebug: true };</script>
  <script type="text/javascript" src="resources/dojo/dojo.js"></script>
  <script type="text/javascript" src="dwr/engine.js"></script>
  <script type="text/javascript" src="dwr/util.js"></script>
  <script type="text/javascript" src="dwr/interface/MiscDwr.js"></script>
  <script type="text/javascript" src="resources/soundmanager2-jsmin.js"></script>
  <script type="text/javascript" src="resources/common.js"></script>
  <c:if test="${!simple}">
    <script type="text/javascript" src="resources/header.js"></script>
    <c:forEach items="${scripts}" var="script">
      ${script}</c:forEach>
    <script type="text/javascript">
      function __header__OnLoad() {
          dwr.util.setEscapeHtml(false);
          dwr.engine.setErrorHandler(dwrErrorHandler);
          <c:if test="${!empty sessionUser}">
            if (dojo.render.html.ie)
                __header__evtVisualizer = new IEBlinker($("__header__alarmLevelDiv"), 500, 200);
            else
                __header__evtVisualizer = new ImageFader($("__header__alarmLevelDiv"), 75, .2);
            __header__evtCheck();
          </c:if>
          <c:if test="${!empty onload}">${onload}</c:if>         
      }
      dojo.addOnLoad(__header__OnLoad);
    </script>
  </c:if>
</head>

<body>
<table width="100%" cellspacing="0" cellpadding="0" border="0" id="mainHeader">
  <tr>
    <td><img src="images/mangoLogoMed.jpg" alt="Logo"/></td>
    <c:if test="${!simple}">
      <td align="center" width="99%">
        <a href="events.shtm">
          <span id="__header__alarmLevelDiv" style="display:none;">
            <img id="__header__alarmLevelImg" src="images/spacer.gif" alt="" border="0" title=""/>
            <span id="__header__alarmLevelText"></span>
          </span>
        </a>
      </td>
    </c:if>
  </tr>
</table>

<c:if test="${!simple}">
  <table width="100%" cellspacing="0" cellpadding="0" border="0" id="subHeader">
    <tr>
      <td style="cursor:default" >
        <c:if test="${!empty sessionUser}">
          <a href="watch_list.shtm"><img src="images/eye.png" border="0" alt="Watch list"
                  onmouseover="if (typeof hMD == 'function') hMD('Watch list', this);"
                  onmouseout="if (typeof hMD == 'function') hMD();"/></a>
          <a href="views.shtm"><img src="images/icon_view.png" border="0" alt="Views"
                  onmouseover="if (typeof hMD == 'function') hMD('Graphical views', this);"
                  onmouseout="if (typeof hMD == 'function') hMD();"/></a>
          <a href="events.shtm"><img src="images/flag_white.png" border="0" alt="Alarms"
                  onmouseover="if (typeof hMD == 'function') hMD('Active alarms', this);"
                  onmouseout="if (typeof hMD == 'function') hMD();"/></a>
          <a href="reports.shtm"><img src="images/report.png" border="0" alt="Reports"
                  onmouseover="if (typeof hMD == 'function') hMD('Reports', this);"
                  onmouseout="if (typeof hMD == 'function') hMD();"/></a>
                  
          <c:if test="${sessionUser.dataSourcePermission}">
            <img src="images/menu_separator.png"/>
            
            <a href="event_handlers.shtm"><img src="images/cog.png" border="0" alt="Event handlers"
                    onmouseover="if (typeof hMD == 'function') hMD('Event handlers', this);"
                    onmouseout="if (typeof hMD == 'function') hMD();"/></a>
            <a href="data_sources.shtm"><img src="images/icon_ds.png" border="0" alt="Data sources"
                    onmouseover="if (typeof hMD == 'function') hMD('Data sources', this);"
                    onmouseout="if (typeof hMD == 'function') hMD();"/></a>
            <a href="scheduled_events.shtm"><img src="images/clock.png" border="0" alt="Scheduled events"
                    onmouseover="if (typeof hMD == 'function') hMD('Scheduled events', this);"
                    onmouseout="if (typeof hMD == 'function') hMD();"/></a>
            <a href="compound_events.shtm"><img src="images/multi_bell.png" border="0" alt="Compound events"
                    onmouseover="if (typeof hMD == 'function') hMD('Compound events', this);"
                    onmouseout="if (typeof hMD == 'function') hMD();"/></a>
          </c:if>
          
          <img src="images/menu_separator.png"/>
          
          <a href="users.shtm"><img src="images/user.png" border="0" alt="Users"
                  onmouseover="if (typeof hMD == 'function') hMD('Users', this);"
                  onmouseout="if (typeof hMD == 'function') hMD();"/></a>
          
          <c:if test="${sessionUser.admin}">
            <a href="point_hierarchy.shtm"><img src="images/folder_brick.png" border="0" alt="Point hierarchy"
                    onmouseover="if (typeof hMD == 'function') hMD('Point hierarchy', this);"
                    onmouseout="if (typeof hMD == 'function') hMD();"/></a>
            <a href="mailing_lists.shtm"><img src="images/book.png" border="0" alt="Mailing lists"
                    onmouseover="if (typeof hMD == 'function') hMD('Mailing lists', this);"
                    onmouseout="if (typeof hMD == 'function') hMD();"/></a>
            <a href="publishers.shtm"><img src="images/transmit.png" border="0" alt="Publishers"
                    onmouseover="if (typeof hMD == 'function') hMD('Publishers', this);"
                    onmouseout="if (typeof hMD == 'function') hMD();"/></a>
            <a href="system_settings.shtm"><img src="images/application_form.png" border="0" alt="System settings"
                    onmouseover="if (typeof hMD == 'function') hMD('System settings', this);"
                    onmouseout="if (typeof hMD == 'function') hMD();"/></a>
            <a href="sql.shtm"><img src="images/script.png" border="0" alt="SQL"
                    onmouseover="if (typeof hMD == 'function') hMD('SQL', this);"
                    onmouseout="if (typeof hMD == 'function') hMD();"/></a>
          </c:if>
          <img src="images/menu_separator.png"/>
          
          <a href="logout.htm"><img src="images/control_stop_blue.png" border="0" alt="Logout"
                  onmouseover="if (typeof hMD == 'function') hMD('Logout', this);"
                  onmouseout="if (typeof hMD == 'function') hMD();"/></a>
          <a href="help.shtm"><img src="images/help.png" border="0" alt="Help"
                  onmouseover="if (typeof hMD == 'function') hMD('Help', this);"
                  onmouseout="if (typeof hMD == 'function') hMD();"/></a>
        </c:if>
        <c:if test="${empty sessionUser}">
          <a href="login.htm"><img src="images/control_play_blue.png" border="0" alt="Login"
                  onmouseover="if (typeof hMD == 'function') hMD('Login', this);"
                  onmouseout="if (typeof hMD == 'function') hMD();"/></a>
        </c:if>
        <div id="headerMenuDescription" class="labelDiv" style="position:absolute;display:none;"></div>
      </td>
      
      <td align="right">
        <c:if test="${!empty sessionUser}"><span class="copyTitle">User: <b>${sessionUser.username}</b></span></c:if>
      </td>
    </tr>
  </table>
</c:if>

<div style="padding:5px;">