<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.Common"%>
<c:if test="${!form.new}">
  <div class="borderDiv marB marR">
    <table>
      <tr><td colspan="3">
        <span class="smallTitle">Chart renderer properties</span>
        <mango:help id="6NOx83BZ6ZJ7RZx0PnDD"/>
      </td></tr>
      
      <tr>
        <td class="formLabelRequired">Type</td>
        <td class="formField">
          <sst:select id="chartRendererSelect" onchange="chartRendererEditor.change()"
                  value="${form.chartRenderer.typeName}">
            <c:forEach items="${chartRenderers}" var="crdef">
              <sst:option value="${crdef.name}">${crdef.prettyName}</sst:option>
            </c:forEach>
          </sst:select>
        </td>
      </tr>
      
      <tbody id="chartRendererNone" style="display:none;"></tbody>
      <tbody id="chartRendererTable" style="display:none;">
        <tr>
          <td class="formLabelRequired">Limit</td>
          <td class="formField"><input id="chartRendererTableLimit" type="text" class="formShort"/></td>
        </tr>
      </tbody>
      <tbody id="chartRendererImage" style="display:none;">
        <tr>
          <td class="formLabelRequired">Time period</td>
          <td class="formField">
            <input id="chartRendererImageNumberOfPeriods" type="text" class="formVeryShort"/>
            <select id="chartRendererImageTimePeriod">
              <option value="<%= Common.TimePeriods.MINUTES %>">Minute(s)</option>
              <option value="<%= Common.TimePeriods.HOURS %>">Hour(s)</option>
              <option value="<%= Common.TimePeriods.DAYS %>">Day(s)</option>
              <option value="<%= Common.TimePeriods.WEEKS %>">Week(s)</option>
              <option value="<%= Common.TimePeriods.MONTHS %>">Month(s)</option>
            </select>
          </td>
        </tr>
      </tbody>
      <tbody id="chartRendererStats" style="display:none;">
        <tr>
          <td class="formLabelRequired">Time period</td>
          <td class="formField">
            <input id="chartRendererStatsNumberOfPeriods" type="text" class="formVeryShort"/>
            <select id="chartRendererStatsTimePeriod">
              <option value="<%= Common.TimePeriods.MINUTES %>">Minute(s)</option>
              <option value="<%= Common.TimePeriods.HOURS %>">Hour(s)</option>
              <option value="<%= Common.TimePeriods.DAYS %>">Day(s)</option>
              <option value="<%= Common.TimePeriods.WEEKS %>">Week(s)</option>
              <option value="<%= Common.TimePeriods.MONTHS %>">Month(s)</option>
            </select>
          </td>
        </tr>
        <tr>
          <td class="formLabelRequired">Include sum</td>
          <td class="formField"><input id="chartRendererStatsIncludeSum" type="checkbox"/></td>
        </tr>
      </tbody>
      
      <tr>
        <td colspan="2">Note: data point logging must be active for charting to occur.</td>
      </tr>
    </table>
  </div>
  
  <script type="text/javascript">
    function ChartRendererEditor() {
        var currentChartRenderer;
        
        this.init = function() {
            // Figure out which fields to populate with data.
            
            <c:choose>
              <c:when test='${empty form.chartRenderer}'>
              </c:when>
              <c:when test='${form.chartRenderer.typeName == "chartRendererTable"}'>
                $set("chartRendererTableLimit", "${form.chartRenderer.limit}");
              </c:when>
              <c:when test='${form.chartRenderer.typeName == "chartRendererImage"}'>
                $set("chartRendererImageNumberOfPeriods", "${form.chartRenderer.numberOfPeriods}");
                $set("chartRendererImageTimePeriod", "${form.chartRenderer.timePeriod}");
              </c:when>
              <c:when test='${form.chartRenderer.typeName == "chartRendererStats"}'>
                $set("chartRendererStatsNumberOfPeriods", "${form.chartRenderer.numberOfPeriods}");
                $set("chartRendererStatsTimePeriod", "${form.chartRenderer.timePeriod}");
                $set("chartRendererStatsIncludeSum", ${form.chartRenderer.includeSum});
              </c:when>
              <c:otherwise>
                dojo.debug("Unknown chart renderer: ${form.chartRenderer.typeName}");
              </c:otherwise>
            </c:choose>
            
            chartRendererEditor.change();
        };
    
        this.change = function() {
            if (currentChartRenderer)
                dojo.html.hide($(currentChartRenderer));
            currentChartRenderer = $("chartRendererSelect").value
            dojo.html.show($(currentChartRenderer));
        };
        
        this.save = function(callback) {
            var typeName = $get("chartRendererSelect");
            if (typeName == "chartRendererNone")
                DataPointEditDwr.setNoneChartRenderer(callback);
            else if (typeName == "chartRendererTable") {
                var limit = parseInt($get("chartRendererTableLimit"));
                if (isNaN(limit))
                    alert("Chart renderer: limit must be entered");
                else if (limit < 2 || limit > 50)
                    alert("Chart renderer: limit must be between 2 and 50");
                else
                    DataPointEditDwr.setTableChartRenderer(limit, callback);
            }
            else if (typeName == "chartRendererImage") {
                var numberOfPeriods = parseInt($get("chartRendererImageNumberOfPeriods"));
                if (isNaN(numberOfPeriods))
                    alert("Chart renderer: number of periods must be entered");
                else if (numberOfPeriods < 1)
                    alert("Chart renderer: number of periods must be greater than zero");
                else
                    DataPointEditDwr.setImageChartRenderer($get("chartRendererImageTimePeriod"),
                            numberOfPeriods, callback);
            }
            else if (typeName == "chartRendererStats") {
                var numberOfPeriods = parseInt($get("chartRendererStatsNumberOfPeriods"));
                if (isNaN(numberOfPeriods))
                    alert("Chart renderer: number of periods must be entered");
                else if (numberOfPeriods < 1)
                    alert("Chart renderer: number of periods must be greater than zero");
                else
                    DataPointEditDwr.setStatisticsChartRenderer($get("chartRendererStatsTimePeriod"), 
                            numberOfPeriods, $get("chartRendererStatsIncludeSum"), callback);
            }
        };
    }
    var chartRendererEditor = new ChartRendererEditor();
    dojo.addOnLoad(chartRendererEditor, "init");
  </script>
</c:if>