<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.vo.event.PointEventDetectorVO"%>
<%@page import="com.serotonin.mango.Common"%>
<%@page import="com.serotonin.mango.rt.event.AlarmLevels"%>
<c:if test="${!form.new}">
  <div class="borderDiv">
    <table id="eventDetectorTable">
      <tr><td colspan="2">
        <span class="smallTitle">Event detectors</span>
        <mango:help id="Wj3ugYHdlMCWuNOFHXdM"/>
      </td></tr>
      
      <tr>
        <td class="formLabelRequired">Type</td>
        <td class="formField">
          <select id="eventDetectorSelect">
            <c:forEach items="${eventDetectors}" var="eddef">
              <option value="${eddef.id}">${eddef.prettyName}</option>
            </c:forEach>
          </select>
          <img src="images/bell_add.png" alt="Add new detector" title="Add new detector" class="ptr"
                  onclick="pointEventDetectorEditor.addEventDetector();"/>
        </td>
      </tr>
      
      <tr><td colspan="2">
        <div id="emptyListMessage" style="color:#888888;padding:10px;text-align:center;">
          Click the add icon to create point event detectors.
        </div>
      </td></tr>
    </table>
    
    <table style="display:none;">
      <tbody id="detectorType<%= PointEventDetectorVO.TYPE_ANALOG_HIGH_LIMIT %>">
        <tr><td class="horzSeparator" colspan="2"></td></tr>
        <tr>
          <td class="formLabelRequired">
            <img src="images/bell_delete.png" class="ptr" title="Delete this event detector"
                    alt="Delete this event detector" onclick="pointEventDetectorEditor.deleteDetector(getPedId(this))"/>
            Type
          </td>
          <td class="formField">High limit detector</td>
        </tr>
        <tr>
          <td class="formLabelRequired">Alarm level</td>
          <td class="formField">
            <select id="eventDetector_TEMPLATE_AlarmLevel"
                    onchange="pointEventDetectorEditor.updateAlarmLevelImage(this.value, getPedId(this))">
              <option value="<%= AlarmLevels.NONE %>"><%=AlarmLevels.NONE_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.INFORMATION %>"><%=AlarmLevels.INFORMATION_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.URGENT %>"><%=AlarmLevels.URGENT_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.CRITICAL %>"><%=AlarmLevels.CRITICAL_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.LIFE_SAFETY %>"><%=AlarmLevels.LIFE_SAFETY_DESCRIPTION%></option>
            </select>
            <img id="eventDetector_TEMPLATE_AlarmLevelImg" src="images/flag_green.png" alt="None" title="None"
                    style="display:none;"/>
          </td>
        </tr>
        <tr>
          <td class="formLabelRequired">High limit</td>
          <td class="formField"><input id="eventDetector_TEMPLATE_Limit" type="text" class="formShort"/></td>
        </tr>
        <tr>
          <td class="formLabel">Duration</td>
          <td class="formField">
            <input id="eventDetector_TEMPLATE_Duration" type="text" class="formShort"/>
            <select id="eventDetector_TEMPLATE_DurationType">
              <option value="<%= Common.TimePeriods.SECONDS %>">second(s)</option>
              <option value="<%= Common.TimePeriods.MINUTES %>">minute(s)</option>
              <option value="<%= Common.TimePeriods.HOURS %>">hour(s)</option>
            </select>
          </td>
        </tr>
        <tr><td class="formError" id="eventDetector_TEMPLATE_ErrorMessage" colspan="2"></td></tr>
      </tbody>
      
      <tbody id="detectorType<%= PointEventDetectorVO.TYPE_ANALOG_LOW_LIMIT %>">
        <tr><td class="horzSeparator" colspan="2"></td></tr>
        <tr>
          <td class="formLabelRequired">
            <img src="images/bell_delete.png" class="ptr" title="Delete this event detector"
                    alt="Delete this event detector" onclick="pointEventDetectorEditor.deleteDetector(getPedId(this))"/>
            Type
          </td>
          <td class="formField">Low limit detector</td>
        </tr>
        <tr>
          <td class="formLabelRequired">Alarm level</td>
          <td class="formField">
            <select id="eventDetector_TEMPLATE_AlarmLevel"
                    onchange="pointEventDetectorEditor.updateAlarmLevelImage(this.value, getPedId(this))">
              <option value="<%= AlarmLevels.NONE %>"><%=AlarmLevels.NONE_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.INFORMATION %>"><%=AlarmLevels.INFORMATION_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.URGENT %>"><%=AlarmLevels.URGENT_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.CRITICAL %>"><%=AlarmLevels.CRITICAL_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.LIFE_SAFETY %>"><%=AlarmLevels.LIFE_SAFETY_DESCRIPTION%></option>
            </select>
            <img id="eventDetector_TEMPLATE_AlarmLevelImg" src="images/flag_green.png" alt="None" title="None"
                    style="display:none;"/>
          </td>
        </tr>
        <tr>
          <td class="formLabelRequired">Low limit</td>
          <td class="formField"><input id="eventDetector_TEMPLATE_Limit" type="text" class="formShort"/></td>
        </tr>
        <tr>
          <td class="formLabel">Duration</td>
          <td class="formField">
            <input id="eventDetector_TEMPLATE_Duration" type="text" class="formShort"/>
            <select id="eventDetector_TEMPLATE_DurationType">
              <option value="<%= Common.TimePeriods.SECONDS %>">second(s)</option>
              <option value="<%= Common.TimePeriods.MINUTES %>">minute(s)</option>
              <option value="<%= Common.TimePeriods.HOURS %>">hour(s)</option>
            </select>
          </td>
        </tr>
        <tr><td class="formError" id="eventDetector_TEMPLATE_ErrorMessage" colspan="2"></td></tr>
      </tbody>
      
      <tbody id="detectorType<%= PointEventDetectorVO.TYPE_BINARY_STATE %>">
        <tr><td class="horzSeparator" colspan="2"></td></tr>
        <tr>
          <td class="formLabelRequired">
            <img src="images/bell_delete.png" class="ptr" title="Delete this event detector"
                    alt="Delete this event detector" onclick="pointEventDetectorEditor.deleteDetector(getPedId(this))"/>
            Type
          </td>
          <td class="formField">State detector</td>
        </tr>
        <tr>
          <td class="formLabelRequired">Alarm level</td>
          <td class="formField">
            <select id="eventDetector_TEMPLATE_AlarmLevel"
                    onchange="pointEventDetectorEditor.updateAlarmLevelImage(this.value, getPedId(this))">
              <option value="<%= AlarmLevels.NONE %>"><%=AlarmLevels.NONE_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.INFORMATION %>"><%=AlarmLevels.INFORMATION_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.URGENT %>"><%=AlarmLevels.URGENT_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.CRITICAL %>"><%=AlarmLevels.CRITICAL_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.LIFE_SAFETY %>"><%=AlarmLevels.LIFE_SAFETY_DESCRIPTION%></option>
            </select>
            <img id="eventDetector_TEMPLATE_AlarmLevelImg" src="images/flag_green.png" alt="None" title="None"
                    style="display:none;"/>
          </td>
        </tr>
        <tr>
          <td class="formLabelRequired">State</td>
          <td class="formField">
            <select id="eventDetector_TEMPLATE_State">
              <option value="false">Zero</option>
              <option value="true">One</option>
            </select>
          </td>
        </tr>
        <tr>
          <td class="formLabel">Duration</td>
          <td class="formField">
            <input id="eventDetector_TEMPLATE_Duration" type="text" class="formShort"/>
            <select id="eventDetector_TEMPLATE_DurationType">
              <option value="<%= Common.TimePeriods.SECONDS %>">second(s)</option>
              <option value="<%= Common.TimePeriods.MINUTES %>">minute(s)</option>
              <option value="<%= Common.TimePeriods.HOURS %>">hour(s)</option>
            </select>
          </td>
        </tr>
        <tr><td class="formError" id="eventDetector_TEMPLATE_ErrorMessage" colspan="2"></td></tr>
      </tbody>
      
      <tbody id="detectorType<%= PointEventDetectorVO.TYPE_MULTISTATE_STATE %>">
        <tr><td class="horzSeparator" colspan="2"></td></tr>
        <tr>
          <td class="formLabelRequired">
            <img src="images/bell_delete.png" class="ptr" title="Delete this event detector"
                    alt="Delete this event detector" onclick="pointEventDetectorEditor.deleteDetector(getPedId(this))"/>
            Type
          </td>
          <td class="formField">State detector</td>
        </tr>
        <tr>
          <td class="formLabelRequired">Alarm level</td>
          <td class="formField">
            <select id="eventDetector_TEMPLATE_AlarmLevel"
                    onchange="pointEventDetectorEditor.updateAlarmLevelImage(this.value, getPedId(this))">
              <option value="<%= AlarmLevels.NONE %>"><%=AlarmLevels.NONE_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.INFORMATION %>"><%=AlarmLevels.INFORMATION_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.URGENT %>"><%=AlarmLevels.URGENT_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.CRITICAL %>"><%=AlarmLevels.CRITICAL_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.LIFE_SAFETY %>"><%=AlarmLevels.LIFE_SAFETY_DESCRIPTION%></option>
            </select>
            <img id="eventDetector_TEMPLATE_AlarmLevelImg" src="images/flag_green.png" alt="None" title="None"
                    style="display:none;"/>
          </td>
        </tr>
        <tr>
          <td class="formLabelRequired">State</td>
          <td class="formField"><input id="eventDetector_TEMPLATE_State" type="text" class="formShort"/></td>
        </tr>
        <tr>
          <td class="formLabel">Duration</td>
          <td class="formField">
            <input id="eventDetector_TEMPLATE_Duration" type="text" class="formShort"/>
            <select id="eventDetector_TEMPLATE_DurationType">
              <option value="<%= Common.TimePeriods.SECONDS %>">second(s)</option>
              <option value="<%= Common.TimePeriods.MINUTES %>">minute(s)</option>
              <option value="<%= Common.TimePeriods.HOURS %>">hour(s)</option>
            </select>
          </td>
        </tr>
        <tr><td class="formError" id="eventDetector_TEMPLATE_ErrorMessage" colspan="2"></td></tr>
      </tbody>
      
      <tbody id="detectorType<%= PointEventDetectorVO.TYPE_POINT_CHANGE %>">
        <tr><td class="horzSeparator" colspan="2"></td></tr>
        <tr>
          <td class="formLabelRequired">
            <img src="images/bell_delete.png" class="ptr" title="Delete this event detector"
                    alt="Delete this event detector" onclick="pointEventDetectorEditor.deleteDetector(getPedId(this))"/>
            Type
          </td>
          <td class="formField">Change detector</td>
        </tr>
        <tr>
          <td class="formLabelRequired">Alarm level</td>
          <td class="formField">
            <select id="eventDetector_TEMPLATE_AlarmLevel"
                    onchange="pointEventDetectorEditor.updateAlarmLevelImage(this.value, getPedId(this))">
              <option value="<%= AlarmLevels.NONE %>"><%=AlarmLevels.NONE_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.INFORMATION %>"><%=AlarmLevels.INFORMATION_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.URGENT %>"><%=AlarmLevels.URGENT_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.CRITICAL %>"><%=AlarmLevels.CRITICAL_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.LIFE_SAFETY %>"><%=AlarmLevels.LIFE_SAFETY_DESCRIPTION%></option>
            </select>
            <img id="eventDetector_TEMPLATE_AlarmLevelImg" src="images/flag_green.png" alt="None" title="None"
                    style="display:none;"/>
          </td>
        </tr>
        <tr><td class="formError" id="eventDetector_TEMPLATE_ErrorMessage" colspan="2"></td></tr>
      </tbody>
      
      <tbody id="detectorType<%= PointEventDetectorVO.TYPE_STATE_CHANGE_COUNT %>">
        <tr><td class="horzSeparator" colspan="2"></td></tr>
        <tr>
          <td class="formLabelRequired">
            <img src="images/bell_delete.png" class="ptr" title="Delete this event detector"
                    alt="Delete this event detector" onclick="pointEventDetectorEditor.deleteDetector(getPedId(this))"/>
            Type
          </td>
          <td class="formField">State change counter</td>
        </tr>
        <tr>
          <td class="formLabelRequired">Alarm level</td>
          <td class="formField">
            <select id="eventDetector_TEMPLATE_AlarmLevel"
                    onchange="pointEventDetectorEditor.updateAlarmLevelImage(this.value, getPedId(this))">
              <option value="<%= AlarmLevels.NONE %>"><%=AlarmLevels.NONE_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.INFORMATION %>"><%=AlarmLevels.INFORMATION_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.URGENT %>"><%=AlarmLevels.URGENT_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.CRITICAL %>"><%=AlarmLevels.CRITICAL_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.LIFE_SAFETY %>"><%=AlarmLevels.LIFE_SAFETY_DESCRIPTION%></option>
            </select>
            <img id="eventDetector_TEMPLATE_AlarmLevelImg" src="images/flag_green.png" alt="None" title="None"
                    style="display:none;"/>
          </td>
        </tr>
        <tr>
          <td class="formLabelRequired">Change count</td>
          <td class="formField"><input id="eventDetector_TEMPLATE_ChangeCount" type="text" class="formShort"/></td>
        </tr>
        <tr>
          <td class="formLabelRequired">Duration</td>
          <td class="formField">
            <input id="eventDetector_TEMPLATE_Duration" type="text" class="formShort"/>
            <select id="eventDetector_TEMPLATE_DurationType">
              <option value="<%= Common.TimePeriods.SECONDS %>">second(s)</option>
              <option value="<%= Common.TimePeriods.MINUTES %>">minute(s)</option>
              <option value="<%= Common.TimePeriods.HOURS %>">hour(s)</option>
            </select>
          </td>
        </tr>
        <tr><td class="formError" id="eventDetector_TEMPLATE_ErrorMessage" colspan="2"></td></tr>
      </tbody>
      
      <tbody id="detectorType<%= PointEventDetectorVO.TYPE_NO_CHANGE %>">
        <tr><td class="horzSeparator" colspan="2"></td></tr>
        <tr>
          <td class="formLabelRequired">
            <img src="images/bell_delete.png" class="ptr" title="Delete this event detector"
                    alt="Delete this event detector" onclick="pointEventDetectorEditor.deleteDetector(getPedId(this))"/>
            Type
          </td>
          <td class="formField">No change</td>
        </tr>
        <tr>
          <td class="formLabelRequired">Alarm level</td>
          <td class="formField">
            <select id="eventDetector_TEMPLATE_AlarmLevel"
                    onchange="pointEventDetectorEditor.updateAlarmLevelImage(this.value, getPedId(this))">
              <option value="<%= AlarmLevels.NONE %>"><%=AlarmLevels.NONE_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.INFORMATION %>"><%=AlarmLevels.INFORMATION_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.URGENT %>"><%=AlarmLevels.URGENT_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.CRITICAL %>"><%=AlarmLevels.CRITICAL_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.LIFE_SAFETY %>"><%=AlarmLevels.LIFE_SAFETY_DESCRIPTION%></option>
            </select>
            <img id="eventDetector_TEMPLATE_AlarmLevelImg" src="images/flag_green.png" alt="None" title="None"
                    style="display:none;"/>
          </td>
        </tr>
        <tr>
          <td class="formLabelRequired">Duration</td>
          <td class="formField">
            <input id="eventDetector_TEMPLATE_Duration" type="text" class="formShort"/>
            <select id="eventDetector_TEMPLATE_DurationType">
              <option value="<%= Common.TimePeriods.SECONDS %>">second(s)</option>
              <option value="<%= Common.TimePeriods.MINUTES %>">minute(s)</option>
              <option value="<%= Common.TimePeriods.HOURS %>">hour(s)</option>
            </select>
          </td>
        </tr>
        <tr><td class="formError" id="eventDetector_TEMPLATE_ErrorMessage" colspan="2"></td></tr>
      </tbody>
      
      <tbody id="detectorType<%= PointEventDetectorVO.TYPE_NO_UPDATE %>">
        <tr><td class="horzSeparator" colspan="2"></td></tr>
        <tr>
          <td class="formLabelRequired">
            <img src="images/bell_delete.png" class="ptr" title="Delete this event detector"
                    alt="Delete this event detector" onclick="pointEventDetectorEditor.deleteDetector(getPedId(this))"/>
            Type
          </td>
          <td class="formField">No update</td>
        </tr>
        <tr>
          <td class="formLabelRequired">Alarm level</td>
          <td class="formField">
            <select id="eventDetector_TEMPLATE_AlarmLevel"
                    onchange="pointEventDetectorEditor.updateAlarmLevelImage(this.value, getPedId(this))">
              <option value="<%= AlarmLevels.NONE %>"><%=AlarmLevels.NONE_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.INFORMATION %>"><%=AlarmLevels.INFORMATION_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.URGENT %>"><%=AlarmLevels.URGENT_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.CRITICAL %>"><%=AlarmLevels.CRITICAL_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.LIFE_SAFETY %>"><%=AlarmLevels.LIFE_SAFETY_DESCRIPTION%></option>
            </select>
            <img id="eventDetector_TEMPLATE_AlarmLevelImg" src="images/flag_green.png" alt="None" title="None"
                    style="display:none;"/>
          </td>
        </tr>
        <tr>
          <td class="formLabelRequired">Duration</td>
          <td class="formField">
            <input id="eventDetector_TEMPLATE_Duration" type="text" class="formShort"/>
            <select id="eventDetector_TEMPLATE_DurationType">
              <option value="<%= Common.TimePeriods.SECONDS %>">second(s)</option>
              <option value="<%= Common.TimePeriods.MINUTES %>">minute(s)</option>
              <option value="<%= Common.TimePeriods.HOURS %>">hour(s)</option>
            </select>
          </td>
        </tr>
        <tr><td class="formError" id="eventDetector_TEMPLATE_ErrorMessage" colspan="2"></td></tr>
      </tbody>
      
      <tbody id="detectorType<%= PointEventDetectorVO.TYPE_ALPHANUMERIC_STATE %>">
        <tr><td class="horzSeparator" colspan="2"></td></tr>
        <tr>
          <td class="formLabelRequired">
            <img src="images/bell_delete.png" class="ptr" title="Delete this event detector"
                    alt="Delete this event detector" onclick="pointEventDetectorEditor.deleteDetector(getPedId(this))"/>
            Type
          </td>
          <td class="formField">State detector</td>
        </tr>
        <tr>
          <td class="formLabelRequired">Alarm level</td>
          <td class="formField">
            <select id="eventDetector_TEMPLATE_AlarmLevel"
                    onchange="pointEventDetectorEditor.updateAlarmLevelImage(this.value, getPedId(this))">
              <option value="<%= AlarmLevels.NONE %>"><%=AlarmLevels.NONE_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.INFORMATION %>"><%=AlarmLevels.INFORMATION_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.URGENT %>"><%=AlarmLevels.URGENT_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.CRITICAL %>"><%=AlarmLevels.CRITICAL_DESCRIPTION%></option>
              <option value="<%= AlarmLevels.LIFE_SAFETY %>"><%=AlarmLevels.LIFE_SAFETY_DESCRIPTION%></option>
            </select>
            <img id="eventDetector_TEMPLATE_AlarmLevelImg" src="images/flag_green.png" alt="None" title="None"
                    style="display:none;"/>
          </td>
        </tr>
        <tr>
          <td class="formLabelRequired">State</td>
          <td class="formField"><input id="eventDetector_TEMPLATE_State" type="text" class="formLong"/></td>
        </tr>
        <tr>
          <td class="formLabel">Duration</td>
          <td class="formField">
            <input id="eventDetector_TEMPLATE_Duration" type="text" class="formShort"/>
            <select id="eventDetector_TEMPLATE_DurationType">
              <option value="<%= Common.TimePeriods.SECONDS %>">second(s)</option>
              <option value="<%= Common.TimePeriods.MINUTES %>">minute(s)</option>
              <option value="<%= Common.TimePeriods.HOURS %>">hour(s)</option>
            </select>
          </td>
        </tr>
        <tr><td class="formError" id="eventDetector_TEMPLATE_ErrorMessage" colspan="2"></td></tr>
      </tbody>
    </table>
  </div>
  
  <script type="text/javascript">
    function getPedId(node) {
        while (!(node.pedId))
            node = node.parentNode;
        return node.pedId;
    }
  
    function PointEventDetectorEditor() {
        var detectorCount = 0;
    
        this.init = function() {
            DataPointEditDwr.getEventDetectors(this.initCB);
        }
        
        this.initCB = function(detectorList) {
            for (var i=0; i<detectorList.length; i++)
                pointEventDetectorEditor.addEventDetectorCB(detectorList[i]);
        }
        
        this.addEventDetector = function() {
            DataPointEditDwr.addEventDetector($get("eventDetectorSelect"), this.addEventDetectorCB);
        }
    
        this.addEventDetectorCB = function(detector) {
            detectorCount++;
            dojo.html.hide($("emptyListMessage"));
            
            // Create the appropriate tbody.
            var content = $("detectorType"+ detector.detectorType).cloneNode(true);
            updateTemplateNode(content, detector.id);
            content.id = "eventDetector"+ detector.id;
            content.pedId = detector.id;
            content.pedType = detector.detectorType;
            $("eventDetectorTable").appendChild(content);
            
            // Set the values in the content controls.
            if (detector.detectorType == <%= PointEventDetectorVO.TYPE_ANALOG_HIGH_LIMIT %>) {
                $set("eventDetector"+ detector.id +"Limit", detector.limit);
                $set("eventDetector"+ detector.id +"Duration", detector.duration);
                $set("eventDetector"+ detector.id +"DurationType", detector.durationType);
            }
            else if (detector.detectorType == <%= PointEventDetectorVO.TYPE_ANALOG_LOW_LIMIT %>) {
                $set("eventDetector"+ detector.id +"Limit", detector.limit);
                $set("eventDetector"+ detector.id +"Duration", detector.duration);
                $set("eventDetector"+ detector.id +"DurationType", detector.durationType);
            }
            else if (detector.detectorType == <%= PointEventDetectorVO.TYPE_BINARY_STATE %>) {
                $set("eventDetector"+ detector.id +"State", detector.binaryState ? "true" : "false");
                $set("eventDetector"+ detector.id +"Duration", detector.duration);
                $set("eventDetector"+ detector.id +"DurationType", detector.durationType);
            }
            else if (detector.detectorType == <%= PointEventDetectorVO.TYPE_MULTISTATE_STATE %>) {
                $set("eventDetector"+ detector.id +"State", detector.multistateState);
                $set("eventDetector"+ detector.id +"Duration", detector.duration);
                $set("eventDetector"+ detector.id +"DurationType", detector.durationType);
            }
            else if (detector.detectorType == <%= PointEventDetectorVO.TYPE_POINT_CHANGE %>) {}
            else if (detector.detectorType == <%= PointEventDetectorVO.TYPE_STATE_CHANGE_COUNT %>) {
                $set("eventDetector"+ detector.id +"ChangeCount", detector.changeCount);
                $set("eventDetector"+ detector.id +"Duration", detector.duration);
                $set("eventDetector"+ detector.id +"DurationType", detector.durationType);
            }
            else if (detector.detectorType == <%= PointEventDetectorVO.TYPE_NO_CHANGE %>) {
                $set("eventDetector"+ detector.id +"Duration", detector.duration);
                $set("eventDetector"+ detector.id +"DurationType", detector.durationType);
            }
            else if (detector.detectorType == <%= PointEventDetectorVO.TYPE_NO_UPDATE %>) {
                $set("eventDetector"+ detector.id +"Duration", detector.duration);
                $set("eventDetector"+ detector.id +"DurationType", detector.durationType);
            }
            else if (detector.detectorType == <%= PointEventDetectorVO.TYPE_ALPHANUMERIC_STATE %>) {
                $set("eventDetector"+ detector.id +"State", detector.alphanumericState);
                $set("eventDetector"+ detector.id +"Duration", detector.duration);
                $set("eventDetector"+ detector.id +"DurationType", detector.durationType);
            }
            
            $set("eventDetector"+ detector.id +"AlarmLevel", detector.alarmLevel);
            pointEventDetectorEditor.updateAlarmLevelImage(detector.alarmLevel, detector.id);
        }
        
        this.updateAlarmLevelImage = function(alarmLevel, pedId) {
            setAlarmLevelImg(alarmLevel, $("eventDetector"+ pedId +"AlarmLevelImg"));
        }
        
        this.deleteDetector = function(pedId) {
            DataPointEditDwr.deleteEventDetector(pedId);
            
            detectorCount--;
            if (detectorCount == 0)
                dojo.html.show($("emptyListMessage"));
            
            var content = $("eventDetector"+ pedId);
            $("eventDetectorTable").removeChild(content);
        }
        
        var saveCBCount;
        var saveCallback;
        var runSaveCallback;
        this.save = function(callback) {
            var edTableNodes = $("eventDetectorTable").childNodes;
            saveCBCount = 0;
            saveCallback = callback;
            runSaveCallback = true;
            
            dwr.engine.beginBatch();
            for (var i=0; i<edTableNodes.length; i++) {
                if (!edTableNodes[i].pedId)
                    continue;
                
                // Found a detector row.
                var pedId = edTableNodes[i].pedId;
                var pedType = edTableNodes[i].pedType;
                var errorMessage = null;
                var alarmLevel = parseInt($get("eventDetector"+ pedId +"AlarmLevel"));
                
                if (pedType == <%= PointEventDetectorVO.TYPE_ANALOG_HIGH_LIMIT %>) {
                    var limit = parseFloat($get("eventDetector"+ pedId +"Limit"));
                    var duration = parseInt($get("eventDetector"+ pedId +"Duration"));
                    var durationType = parseInt($get("eventDetector"+ pedId +"DurationType"));
                    
                    if (isNaN(limit))
                        errorMessage = "Error parsing limit value";
                    else if (isNaN(duration))
                        errorMessage = "Error parsing duration value";
                    else if (duration < 0)
                        errorMessage = "Duration cannot be < 0";
                    else {
                        saveCBCount++;
                        DataPointEditDwr.updateHighLimitDetector(pedId, limit, duration, durationType, alarmLevel,
                                saveCB);
                    }
                }
                else if (pedType == <%= PointEventDetectorVO.TYPE_ANALOG_LOW_LIMIT %>) {
                    var limit = parseFloat($get("eventDetector"+ pedId +"Limit"));
                    var duration = parseInt($get("eventDetector"+ pedId +"Duration"));
                    var durationType = parseInt($get("eventDetector"+ pedId +"DurationType"));
                    
                    if (isNaN(limit))
                        errorMessage = "Error parsing limit value";
                    else if (isNaN(duration))
                        errorMessage = "Error parsing duration value";
                    else if (duration < 0)
                        errorMessage = "Duration cannot be < 0";
                    else {
                        saveCBCount++;
                        DataPointEditDwr.updateLowLimitDetector(pedId, limit, duration, durationType, alarmLevel,
                                saveCB);
                    }
                }
                else if (pedType == <%= PointEventDetectorVO.TYPE_BINARY_STATE %>) {
                    var state = $get("eventDetector"+ pedId +"State");
                    var duration = parseInt($get("eventDetector"+ pedId +"Duration"));
                    var durationType = parseInt($get("eventDetector"+ pedId +"DurationType"));
                    
                    if (isNaN(duration))
                        errorMessage = "Error parsing duration value";
                    else if (duration < 0)
                        errorMessage = "Duration cannot be < 0";
                    else {
                        saveCBCount++;
                        DataPointEditDwr.updateBinaryStateDetector(pedId, state, duration, durationType, alarmLevel,
                                saveCB);
                    }
                }
                else if (pedType == <%= PointEventDetectorVO.TYPE_MULTISTATE_STATE %>) {
                    var state = parseInt($get("eventDetector"+ pedId +"State"));
                    var duration = parseInt($get("eventDetector"+ pedId +"Duration"));
                    var durationType = parseInt($get("eventDetector"+ pedId +"DurationType"));
                    
                    if (isNaN(state))
                        errorMessage = "Error parsing state value";
                    else if (isNaN(duration))
                        errorMessage = "Error parsing duration value";
                    else if (duration < 0)
                        errorMessage = "Duration cannot be < 0";
                    else {
                        saveCBCount++;
                        DataPointEditDwr.updateMultistateStateDetector(pedId, state, duration, durationType, alarmLevel,
                                saveCB);
                    }
                }
                else if (pedType == <%= PointEventDetectorVO.TYPE_POINT_CHANGE %>) {
                    saveCBCount++;
                    DataPointEditDwr.updatePointChangeDetector(pedId, alarmLevel, saveCB);
                }
                else if (pedType == <%= PointEventDetectorVO.TYPE_STATE_CHANGE_COUNT %>) {
                    var count = parseInt($get("eventDetector"+ pedId +"ChangeCount"));
                    var duration = parseInt($get("eventDetector"+ pedId +"Duration"));
                    var durationType = parseInt($get("eventDetector"+ pedId +"DurationType"));
                    
                    if (isNaN(count))
                        errorMessage = "Error parsing change count value";
                    else if (count < 2)
                        errorMessage = "Change count cannot be < 2";
                    else if (isNaN(duration))
                        errorMessage = "Error parsing duration value";
                    else if (duration < 1)
                        errorMessage = "Duration cannot be < 1";
                    else {
                        saveCBCount++;
                        DataPointEditDwr.updateStateChangeCountDetector(pedId, count, duration, durationType, 
                                alarmLevel, saveCB);
                    }
                }
                else if (pedType == <%= PointEventDetectorVO.TYPE_NO_CHANGE %>) {
                    var duration = parseInt($get("eventDetector"+ pedId +"Duration"));
                    var durationType = parseInt($get("eventDetector"+ pedId +"DurationType"));
                    
                    if (isNaN(duration))
                        errorMessage = "Error parsing duration value";
                    else if (duration < 1)
                        errorMessage = "Duration cannot be < 1";
                    else {
                        saveCBCount++;
                        DataPointEditDwr.updateNoChangeDetector(pedId, duration, durationType, alarmLevel, saveCB);
                    }
                }
                else if (pedType == <%= PointEventDetectorVO.TYPE_NO_UPDATE %>) {
                    var duration = parseInt($get("eventDetector"+ pedId +"Duration"));
                    var durationType = parseInt($get("eventDetector"+ pedId +"DurationType"));
                    
                    if (isNaN(duration))
                        errorMessage = "Error parsing duration value";
                    else if (duration < 1)
                        errorMessage = "Duration cannot be < 1";
                    else {
                        saveCBCount++;
                        DataPointEditDwr.updateNoUpdateDetector(pedId, duration, durationType, alarmLevel, saveCB);
                    }
                }
                else if (pedType == <%= PointEventDetectorVO.TYPE_ALPHANUMERIC_STATE %>) {
                    var state = $get("eventDetector"+ pedId +"State");
                    var duration = parseInt($get("eventDetector"+ pedId +"Duration"));
                    var durationType = parseInt($get("eventDetector"+ pedId +"DurationType"));
                    
                    if (state && state.length > 128)
                        errorMessage = "State cannot be longer than 128 characters";
                    else if (isNaN(duration))
                        errorMessage = "Error parsing duration value";
                    else if (duration < 0)
                        errorMessage = "Duration cannot be < 0";
                    else {
                        saveCBCount++;
                        DataPointEditDwr.updateAlphanumericStateDetector(pedId, state, duration, durationType, 
                                alarmLevel, saveCB);
                    }
                }
                
                if (errorMessage != null) {
                    runSaveCallback = false;
                    $("eventDetector"+ pedId +"ErrorMessage").innerHTML = errorMessage;
                }
                else
                    $("eventDetector"+ pedId +"ErrorMessage").innerHTML = "";
            }
            dwr.engine.endBatch();
        
            // If no save calls were made, continue by calling the callback.
            if (saveCBCount == 0)
                callback();
        };
        
        function saveCB() {
            if (--saveCBCount == 0) {
                // We're done with the callbacks. If there were no errors, call the callback.
                if (runSaveCallback)
                    saveCallback();
            }
        }
    }
    var pointEventDetectorEditor = new PointEventDetectorEditor();
    dojo.addOnLoad(pointEventDetectorEditor, "init");
    
  </script>
</c:if>