<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.vo.DataPointVO"%>
<%@page import="com.serotonin.mango.DataTypes"%>

<c:choose>
  <c:when test="${!form.new}">
    <script type="text/javascript">
      function changeLoggingType() {
          var loggingType = $get("loggingType");
          var tolerance = $("tolerance");
          var purgePeriod = $("purgePeriod");
          var purgeType = $("purgeType");
          
          if ($("toleranceSection") && loggingType == <%= DataPointVO.LoggingTypes.ON_CHANGE %>)
              // On change logging for a numeric requires a tolerance setting.
              tolerance.disabled = false;
          else
              tolerance.disabled = true;
          
          if (loggingType == 3) {
              purgePeriod.disabled = true;
              purgeType.disabled = true;
          }
          else {
              purgePeriod.disabled = false;
              purgeType.disabled = false;
          }
      }
    </script>
  
    <div class="borderDiv marB marR">
      <table>
        <tr><td colspan="3">
          <span class="smallTitle">Logging properties</span>
          <mango:help id="Tm6WYvvqL2fGTm9PX3GA"/>
        </td></tr>
        
        <spring:bind path="form.loggingType">
          <tr>
            <td class="formLabelRequired">Logging type</td>
            <td class="formField">
              <sst:select id="loggingType" name="loggingType" onchange="changeLoggingType();" value="${status.value}">
                <sst:option value="<%= Integer.toString(DataPointVO.LoggingTypes.ON_CHANGE) %>">When 
                        point value changes</sst:option>
                <sst:option value="<%= Integer.toString(DataPointVO.LoggingTypes.ALL) %>">All data</sst:option>
                <sst:option value="<%= Integer.toString(DataPointVO.LoggingTypes.NONE) %>">Do not log</sst:option>
              </sst:select>
            </td>
            <td class="formError">${status.errorMessage}</td>
          </tr>
        </spring:bind>
        
        <tbody id="toleranceSection" style="display:none;">
          <spring:bind path="form.tolerance">
            <tr>
              <td class="formLabelRequired">Tolerance</td>
              <td class="formField">
                <input id="tolerance" type="text" name="tolerance" value="${status.value}" class="formShort"/>
              </td>
              <td class="formError">${status.errorMessage}</td>
            </tr>
          </spring:bind>
        </tbody>
          
        <tr>
          <td class="formLabelRequired">Purge</td>
          <td class="formField">
            After <input id="purgePeriod" type="text" name="purgePeriod" value="${form.purgePeriod}" class="formShort"/>
            <sst:select id="purgeType" name="purgeType" value="${form.purgeType}">
              <sst:option value="<%= Integer.toString(DataPointVO.PurgeTypes.DAYS) %>">Day(s)</sst:option>
              <sst:option value="<%= Integer.toString(DataPointVO.PurgeTypes.WEEKS) %>">Week(s)</sst:option>
              <sst:option value="<%= Integer.toString(DataPointVO.PurgeTypes.MONTHS) %>">Month(s)</sst:option>
              <sst:option value="<%= Integer.toString(DataPointVO.PurgeTypes.YEARS) %>">Year(s)</sst:option>
            </sst:select>
          </td>
          <td class="formError">
            <spring:bind path="form.purgeType">
              <c:if test="${status.error}">${status.errorMessage}<br/></c:if>
            </spring:bind>
            <spring:bind path="form.purgePeriod">${status.errorMessage}</spring:bind>
          </td>
        </tr>
          
      </table>
    </div>
    
    <script type="text/javascript">
      if (dataTypeId == <%= DataTypes.NUMERIC %>)
          dojo.html.show($("toleranceSection"));
    </script>
  </c:when>
  <c:otherwise>
    <input type="hidden" name="loggingType" value="${form.loggingType}"/>
    <input type="hidden" name="purgeType" value="${form.purgeType}"/>
  </c:otherwise>
</c:choose>