<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.vo.DataPointVO"%>
<%@page import="com.serotonin.mango.Common"%>

<c:if test="${!form.new}">
  <script type="text/javascript">
    function purgeNowAllChanged() {
        var all = $get("purgeNowAll");
        setDisabled("purgeNowPeriod", all);
        setDisabled("purgeNowType", all);
    }
    
    function purgeNow() {
        var all = $get("purgeNowAll");
        if (all && !confirm("Are you sure you want to purge all data for this point?"))
            return;
    
        setDisabled("purgeNowBtn", true);
        show("purgeNowWarn");
        startImageFader("purgeNowImg");
        DataPointEditDwr.purgeNow($get("purgeNowType"), $get("purgeNowPeriod"), all, purgeNowCB);
    }
    
    function purgeNowCB(result) {
        setDisabled("purgeNowBtn", false);
        stopImageFader("purgeNowImg");
        hide("purgeNowWarn");
        alert(""+ result +" point values were purged");
    }
  </script>

  <div class="borderDiv marB marR">
    <table>
      <tr><td colspan="3">
        <span class="smallTitle">Purge now</span>
        <mango:help id="wPOFfeSI53gnkoEDvuR7"/>
      </td></tr>
      
      <tr>
        <td class="formLabelRequired">Purge data older than</td>
        <td class="formField">
          <input id="purgeNowPeriod" type="text" value="${form.purgePeriod}" class="formShort"/>
          <sst:select id="purgeNowType" value="${form.purgeType}">
            <sst:option value="<%= Integer.toString(Common.TimePeriods.MINUTES) %>">Minute(s)</sst:option>
            <sst:option value="<%= Integer.toString(Common.TimePeriods.HOURS) %>">Hour(s)</sst:option>
            <sst:option value="<%= Integer.toString(Common.TimePeriods.DAYS) %>">Day(s)</sst:option>
            <sst:option value="<%= Integer.toString(DataPointVO.PurgeTypes.WEEKS) %>">Week(s)</sst:option>
            <sst:option value="<%= Integer.toString(DataPointVO.PurgeTypes.MONTHS) %>">Month(s)</sst:option>
            <sst:option value="<%= Integer.toString(DataPointVO.PurgeTypes.YEARS) %>">Year(s)</sst:option>
          </sst:select>
        </td>
      </tr>
      
      <tr>
        <td class="formLabelRequired">Purge all data</td>
        <td class="formField">
          <input type="checkbox" id="purgeNowAll" onclick="purgeNowAllChanged()">
          <label for="purgeNowAll">All data</label>
        </td>
      </tr>
      
      <tr>
        <td colspan="2" align="center">
          <input id="purgeNowBtn" type="submit" value="Purge now" onclick="purgeNow(); return false;"/>
        </td>
      </tr>
      
      <tbody id="purgeNowWarn" style="display:none">
        <tr>
          <td colspan="2" align="center" class="formError">
            <img id="purgeNowImg" src="images/warn.png"/>
            Purging data, please wait...
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</c:if>