<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.Common"%>
<mango:header onload="init()">
  <mango:script src='dwr/interface/PointHierarchyDwr.js'/>
  <mango:script>
    <script>
    var selectedFolderNode;
    
    function init() {
        PointHierarchyDwr.getPointHierarchy(initCB);
        var tree = dojo.widget.manager.getWidgetById('tree');
        dojo.event.topic.subscribe("tree/titleClick", new TreeClickHandler(), 'handle');
        setErrorMessage();
    }
    
    var TreeClickHandler = function() {
        this.handle = function(message) {
            setErrorMessage();
            var widget = message.source;
            if (widget.isFolder) {
                selectedFolderNode = widget;
                $set("folderName", widget.object.name);
                show("folderEditDiv");
            }
            else
                hide("folderEditDiv");
        }
    }
    
    function initCB(rootFolder) {
        var tree = dojo.widget.manager.getWidgetById('tree');
        var i;
        
        for (i=0; i<rootFolder.subfolders.length; i++)
            addFolder(rootFolder.subfolders[i], tree);
        
        for (i=0; i<rootFolder.points.length; i++)
            addPoint(rootFolder.points[i], tree);
        
        hide("loadingImg");
        show("treeDiv");
    }
    
    function addFolder(folder, parent) {
        var i;
        var folderNode = dojo.widget.createWidget("TreeNode", {
                title: "<img src='images/folder_brick.png'/> "+ folder.name,
                isFolder: "true",
                object: folder
        });
        parent.addChild(folderNode);
        
        if (folder.subfolders) {
            for (i=0; i<folder.subfolders.length; i++)
                addFolder(folder.subfolders[i], folderNode);
        }
        
        if (folder.points) {
            for (i=0; i<folder.points.length; i++)
                addPoint(folder.points[i], folderNode);
        }
        
        folder.subfolders = null;
        folder.points = null;
    }
    
    function addPoint(point, parent) {
        var pointNode = dojo.widget.createWidget("TreeNode", {
                title: "<img src='images/icon_comp.png'/> "+ point.value,
                object: point
        });
        parent.addChild(pointNode);
    }
    
    function newFolder() {
        setErrorMessage();
        var folder = {
            id: <%= Common.NEW_ID %>,
            name: "New folder"
        };
        var tree = dojo.widget.manager.getWidgetById('tree');
        addFolder(folder, tree);
    }
    
    function save() {
        setErrorMessage();
        hide("folderEditDiv");
        var tree = dojo.widget.manager.getWidgetById('tree');
        var rootFolder = { id: 0, name: "root", subfolders: new Array(), points: new Array() };
        gatherTreeData(tree, rootFolder);
        PointHierarchyDwr.savePointHierarchy(rootFolder, saveCB);
    }
    
    function saveCB(rootFolder) {
        setErrorMessage("Point hierarchy has been saved");
        
        var tree = dojo.widget.manager.getWidgetById('tree');
        while (tree.children.length > 0)
            tree.removeNode(tree.children[0]);
        
        initCB(rootFolder);
    }
    
    function gatherTreeData(treeNode, folder) {
        for (var i=0; i<treeNode.children.length; i++) {
            if (treeNode.children[i].isFolder) {
                var subfolder = treeNode.children[i].object;
                folder.subfolders[folder.subfolders.length] = subfolder;
                subfolder.subfolders = new Array();
                subfolder.points = new Array();
                gatherTreeData(treeNode.children[i], subfolder);
            }
            else
                folder.points[folder.points.length] = treeNode.children[i].object;
        }
    }
    
    function deleteFolder() {
        setErrorMessage();
        if (selectedFolderNode.children.length > 0) {
            if (!confirm("All children will be reassigned to the parent folder. Is this ok?"))
                return;
        }
        
        while (selectedFolderNode.children.length > 0) {
            var child = selectedFolderNode.children[0];
            selectedFolderNode.removeNode(child);
            selectedFolderNode.parent.addChild(child);
        }
        
        selectedFolderNode.parent.removeNode(selectedFolderNode);
        hide("folderEditDiv");
    }
    
    function saveFolder() {
        setErrorMessage();
        var name = $get("folderName");
        if (!name || name == "")
            alert("Folder name cannot be empty");
        else {
          selectedFolderNode.object.name = name;
          selectedFolderNode.titleNode.innerHTML =
                  "<img src='images/folder_brick.png'/> "+ selectedFolderNode.object.name;
        }
    }
    
    function setErrorMessage(message) {
        if (!message)
            hide("errorMessage");
        else {
            $("errorMessage").innerHTML = message;
            show("errorMessage");
        }
    }
    </script>
  </mango:script>
</mango:header>

<table>
  <tr>
    <td valign="top">
      <div class="borderDivPadded">
        <table width="100%">
          <tr>
            <td>
              <span class="smallTitle">Point Hierarchy</span>
              <mango:help id="E4XwTQzkb5w5kmM24PtY"/>
            </td>
            <td align="right">
              <img src="images/folder_add.png" class="ptr" title="Add folder" onclick="newFolder()"/>
              <img src="images/save.png" class="ptr" title="Save" onclick="save()"/>
            </td>
          </tr>
          <tr><td class="formError" id="errorMessage"></td></tr>
        </table>
      
        <img src="images/hourglass.png" id="loadingImg"/>
        <div id="treeDiv" style="display:none;">
          <div dojoType="Tree" DNDMode="between" toggle="wipe" DNDAcceptTypes="tree" widgetId="tree"></div>
        </div>
      </div>
    </td>
    
    <td valign="top">
      <div id="folderEditDiv" class="borderDivPadded" style="display:none;">
        <table width="100%">
          <tr>
            <td class="smallTitle">Folder details</td>
            <td align="right">
              <img id="deleteImg" src="images/delete.png" title="Delete this folder" class="ptr"
                      onclick="deleteFolder();"/>
              <img id="saveImg" src="images/save.png" title="Save this folder" class="ptr" onclick="saveFolder();"/>
            </td>
          </tr>
        </table>
        
        <table>
          <tr>
            <td class="formLabelRequired">Name</td>
            <td class="formField"><input id="folderName" type="text"/></td>
          </tr>
        </table>
      </div>
    </td>
  </tr>
</table>

<mango:footer/>