<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.Common"%>
<%@page import="com.serotonin.mango.rt.event.AlarmLevels"%>
<%@page import="com.serotonin.mango.vo.event.ScheduledEventVO"%>
<%@page import="org.joda.time.DateTimeConstants"%>
<mango:header onload="init()">
  <mango:script src='dwr/interface/ScheduledEventsDwr.js'/>
  <mango:script>
    <script>
    var weekdays = new Array();
    var monthdays = new Array();
    var oncedays = new Array();
    
    this.OptionData = function(_text, _value) {
        this.text = _text;
        this.value = _value;
    }
    
    function init() {
        weekdays[weekdays.length] = new OptionData("Monday", <%= DateTimeConstants.MONDAY %>);
        weekdays[weekdays.length] = new OptionData("Tuesday", <%= DateTimeConstants.TUESDAY %>);
        weekdays[weekdays.length] = new OptionData("Wednesday", <%= DateTimeConstants.WEDNESDAY %>);
        weekdays[weekdays.length] = new OptionData("Thursday", <%= DateTimeConstants.THURSDAY %>);
        weekdays[weekdays.length] = new OptionData("Friday", <%= DateTimeConstants.FRIDAY %>);
        weekdays[weekdays.length] = new OptionData("Saturday", <%= DateTimeConstants.SATURDAY %>);
        weekdays[weekdays.length] = new OptionData("Sunday", <%= DateTimeConstants.SUNDAY %>);
        
        for (var i=1; i<29; i++)
            monthdays[monthdays.length] = new OptionData(i, i);
        monthdays[monthdays.length] = new OptionData("Third last day", -3);
        monthdays[monthdays.length] = new OptionData("Second last day", -2);
        monthdays[monthdays.length] = new OptionData("Last day", -1);
        
        for (var i=1; i<32; i++)
            oncedays[oncedays.length] = new OptionData(i, i);
        
        ScheduledEventsDwr.getScheduledEvents(initCB);
    }
    
    var editingScheduledEvent;
    function initCB(scheduledEvents) {
        for (var i=0; i<scheduledEvents.length; i++) {
            appendScheduledEvent(scheduledEvents[i].id);
            updateScheduledEvent(scheduledEvents[i]);
        }
        
        <c:if test="${!empty param.seid}">
          showScheduledEvent(${param.seid});
        </c:if>
    }
    
    function showScheduledEvent(seId) {
        if (editingScheduledEvent)
            stopImageFader($("se"+ editingScheduledEvent.id +"Img"));
        ScheduledEventsDwr.getScheduledEvent(seId, showScheduledEventCB);
        startImageFader($("se"+ seId +"Img"));
        
        if (seId == <%= Common.NEW_ID %>)
            hide($("deleteScheduledEventImg"));
        else
            show($("deleteScheduledEventImg"));
    }
    
    function showScheduledEventCB(se) {
        if (!editingScheduledEvent)
            show($("scheduledEventDetails"));
        editingScheduledEvent = se;
        
        $set("alarmLevel", se.alarmLevel);
        updateAlarmLevelImage();
        $set("type", se.scheduleType);
        $set("rtn", se.returnToNormal);
        $set("disabled", se.disabled);
        
        refreshDateTimeFields();
        $set("activeYear", se.activeYear);
        $set("activeMonth", se.activeMonth);
        $set("activeDay", se.activeDay);
        $set("activeHour", se.activeHour);
        $set("activeMinute", se.activeMinute);
        $set("activeSecond", se.activeSecond);
        $set("activeCron", se.activeCron);
        $set("inactiveYear", se.inactiveYear);
        $set("inactiveMonth", se.inactiveMonth);
        $set("inactiveDay", se.inactiveDay);
        $set("inactiveHour", se.inactiveHour);
        $set("inactiveMinute", se.inactiveMinute);
        $set("inactiveSecond", se.inactiveSecond);
        $set("inactiveCron", se.inactiveCron);
        
        setUserMessage();
    }
    
    function saveScheduledEvent() {
        setUserMessage();
        ScheduledEventsDwr.saveScheduledEvent(editingScheduledEvent.id, $get("alarmLevel"), $get("type"), $get("rtn"),
                $get("disabled"), $get("activeYear"), $get("activeMonth"), $get("activeDay"), $get("activeHour"), 
                $get("activeMinute"), $get("activeSecond"), $get("activeCron"), $get("inactiveYear"), 
                $get("inactiveMonth"), $get("inactiveDay"), $get("inactiveHour"), $get("inactiveMinute"), 
                $get("inactiveSecond"), $get("inactiveCron"), saveScheduledEventCB);
    }
    
    function saveScheduledEventCB(result) {
        if (result.errorMessage)
            setUserMessage(result.errorMessage);
        else {
            if (editingScheduledEvent.id == <%= Common.NEW_ID %>) {
                stopImageFader($("se"+ editingScheduledEvent.id +"Img"));
                editingScheduledEvent.id = result.seId;
                appendScheduledEvent(editingScheduledEvent.id);
                startImageFader($("se"+ editingScheduledEvent.id +"Img"));
                setUserMessage("Scheduled event added");
                show($("deleteScheduledEventImg"));
            }
            else
                setUserMessage("Scheduled event saved");
            ScheduledEventsDwr.getScheduledEvent(editingScheduledEvent.id, updateScheduledEvent)
        }
    }
    
    function setUserMessage(message) {
        if (message) {
            show($("userMessage"));
            $("userMessage").innerHTML = message;
        }
        else
            hide($("userMessage"));
    }
    
    function appendScheduledEvent(seId) {
        createFromTemplate("se_TEMPLATE_", seId, "scheduledEventsTable");
    }
    
    function updateScheduledEvent(se) {
        $("se"+ se.id +"Name").innerHTML = se.description;
        setScheduledEventImg(se.disabled, $("se"+ se.id +"Img"));
    }
    
    function deleteScheduledEvent() {
        ScheduledEventsDwr.deleteScheduledEvent(editingScheduledEvent.id, deleteScheduledEventCB);
    }
    
    function deleteScheduledEventCB() {
        stopImageFader($("se"+ editingScheduledEvent.id +"Img"));
        $("scheduledEventsTable").removeChild($("se"+ editingScheduledEvent.id));
        hide($("scheduledEventDetails"));
        editingScheduledEvent = null;
    }
    
    function updateAlarmLevelImage() {
        setAlarmLevelImg($get("alarmLevel"), $("alarmLevelImg"));
    }
    
    function refreshDateTimeFields() {
        var type = $get("type");
        var rtn = $get("rtn");
        
        display($("inactiveDateTimeRow"), rtn);
        
        if (type == <%= ScheduledEventVO.TYPE_HOURLY %>) {
            displayTables(false, true, false);
            displayHour(false);
        }
        else if (type == <%= ScheduledEventVO.TYPE_DAILY %>) {
            displayTables(false, true, false);
            displayHour(true);
        }
        else if (type == <%= ScheduledEventVO.TYPE_WEEKLY %>) {
            displayTables(true, true, false);
            displayYear(false);
            displayMonth(false);
            setDayOptions(weekdays);
            displayHour(true);
        }
        else if (type == <%= ScheduledEventVO.TYPE_MONTHLY %>) {
            displayTables(true, true, false);
            displayYear(false);
            displayMonth(false);
            setDayOptions(monthdays);
            displayHour(true);
        }
        else if (type == <%= ScheduledEventVO.TYPE_YEARLY %>) {
            displayTables(true, true, false);
            displayYear(false);
            displayMonth(true);
            setDayOptions(monthdays);
            displayHour(true);
        }
        else if (type == <%= ScheduledEventVO.TYPE_ONCE %>) {
            displayTables(true, true, false);
            displayYear(true);
            displayMonth(true);
            setDayOptions(oncedays);
            displayHour(true);
        }
        else if (type == <%= ScheduledEventVO.TYPE_CRON %>)
            displayTables(false, false, true);
    }
    
    function displayTables(showDate, showTime, showCron) {
        display($("activeDateTable"), showDate);
        display($("activeTimeTable"), showTime);
        display($("activeCronTable"), showCron);
        display($("inactiveDateTable"), showDate);
        display($("inactiveTimeTable"), showTime);
        display($("inactiveCronTable"), showCron);
    }
    
    function displayHour(showHour) {
        if (showHour) {
            show($("activeHourLabel"));
            show($("activeHourSpacer"));
            show($("activeHourData"));
            show($("activeHourColon"));
            show($("inactiveHourLabel"));
            show($("inactiveHourSpacer"));
            show($("inactiveHourData"));
            show($("inactiveHourColon"));
        }
        else {
            hide($("activeHourLabel"));
            hide($("activeHourSpacer"));
            hide($("activeHourData"));
            hide($("activeHourColon"));
            hide($("inactiveHourLabel"));
            hide($("inactiveHourSpacer"));
            hide($("inactiveHourData"));
            hide($("inactiveHourColon"));
        }
    }
    
    function displayYear(showYear) {
        if (showYear) {
            show($("activeYearLabel"));
            show($("activeYearSpacer"));
            show($("activeYearData"));
            show($("activeYearSlash"));
            show($("inactiveYearLabel"));
            show($("inactiveYearSpacer"));
            show($("inactiveYearData"));
            show($("inactiveYearSlash"));
        }
        else {
            hide($("activeYearLabel"));
            hide($("activeYearSpacer"));
            hide($("activeYearData"));
            hide($("activeYearSlash"));
            hide($("inactiveYearLabel"));
            hide($("inactiveYearSpacer"));
            hide($("inactiveYearData"));
            hide($("inactiveYearSlash"));
        }
    }
    
    function displayMonth(showMonth) {
        if (showMonth) {
            show($("activeMonthLabel"));
            show($("activeMonthSpacer"));
            show($("activeMonthData"));
            show($("activeMonthSlash"));
            show($("inactiveMonthLabel"));
            show($("inactiveMonthSpacer"));
            show($("inactiveMonthData"));
            show($("inactiveMonthSlash"));
        }
        else {
            hide($("activeMonthLabel"));
            hide($("activeMonthSpacer"));
            hide($("activeMonthData"));
            hide($("activeMonthSlash"));
            hide($("inactiveMonthLabel"));
            hide($("inactiveMonthSpacer"));
            hide($("inactiveMonthData"));
            hide($("inactiveMonthSlash"));
        }
    }
    
    function setDayOptions(options, node) {
        if (!node) {
            setDayOptions(options, "activeDay");
            setDayOptions(options, "inactiveDay");
        }
        else {
            dwr.util.removeAllOptions(node);
            dwr.util.addOptions(node, options, "value", "text");
        }
    }
    </script>
  </mango:script>
</mango:header>

<table>
  <tr>
    <td valign="top">
      <div class="borderDiv">
        <table width="100%">
          <tr>
            <td>
              <span class="smallTitle">Scheduled events</span>
              <mango:help id="81nRr0lxlc7rpCQI5w6o"/>
            </td>
            <td align="right"><img src="images/clock_add.png" class="ptr" title="Add scheduled event"
                    onclick="showScheduledEvent(<%= Common.NEW_ID %>)" id="se<%= Common.NEW_ID %>Img"/></td>
          </tr>
        </table>
        <table id="scheduledEventsTable">
          <tbody id="se_TEMPLATE_" onclick="showScheduledEvent(getMangoId(this))" class="ptr" style="display:none">
            <tr>
              <td><img id="se_TEMPLATE_Img" src="images/clock.png" title="Scheduled event" alt="Scheduled event"/></td>
              <td class="link" id="se_TEMPLATE_Name"></td>
            </tr>
          </tbody>
        </table>
      </div>
    </td>
    
    <td valign="top" style="display:none;" id="scheduledEventDetails">
      <div class="borderDiv">
        <table width="100%">
          <tr>
            <td><span class="smallTitle">Scheduled event details</span></td>
            <td align="right">
              <img src="images/save.png" onclick="saveScheduledEvent();" class="ptr" title="Save"/>
              <img id="deleteScheduledEventImg" src="images/delete.png" onclick="deleteScheduledEvent();"
                      class="ptr" title="Delete"/>
            </td>
          </tr>
        </table>
        <table>
          <tr>
            <td class="formLabelRequired">Alarm level</td>
            <td class="formField">
              <select id="alarmLevel" onchange="updateAlarmLevelImage()">
                <option value="<%= AlarmLevels.NONE %>"><%= AlarmLevels.NONE_DESCRIPTION %></option>
                <option value="<%= AlarmLevels.INFORMATION %>"><%= AlarmLevels.INFORMATION_DESCRIPTION %></option>
                <option value="<%= AlarmLevels.URGENT %>"><%= AlarmLevels.URGENT_DESCRIPTION %></option>
                <option value="<%= AlarmLevels.CRITICAL %>"><%= AlarmLevels.CRITICAL_DESCRIPTION %></option>
                <option value="<%= AlarmLevels.LIFE_SAFETY %>"><%= AlarmLevels.LIFE_SAFETY_DESCRIPTION %></option>
              </select>
              <img id="alarmLevelImg" src="images/flag_green.png" alt="None" title="None" style="display:none;"/>
            </td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Schedule type</td>
            <td class="formField">
              <select id="type" onchange="refreshDateTimeFields()">
                <option value="<%= ScheduledEventVO.TYPE_HOURLY %>">Hourly</option>
                <option value="<%= ScheduledEventVO.TYPE_DAILY %>">Daily</option>
                <option value="<%= ScheduledEventVO.TYPE_WEEKLY %>">Weekly</option>
                <option value="<%= ScheduledEventVO.TYPE_MONTHLY %>">Monthly</option>
                <option value="<%= ScheduledEventVO.TYPE_YEARLY %>">Yearly</option>
                <option value="<%= ScheduledEventVO.TYPE_ONCE %>">Once</option>
                <option value="<%= ScheduledEventVO.TYPE_CRON %>">Cron</option>
              </select>
            </td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Return to normal</td>
            <td class="formField"><input type="checkbox" id="rtn" onclick="refreshDateTimeFields()"/></td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Active time</td>
            <td>
              <table id="activeDateTable">
                <tr>
                  <td align="center" id="activeYearLabel">Year</td>
                  <td id="activeYearSpacer"></td>
                  <td align="center" id="activeMonthLabel">Month</td>
                  <td id="activeMonthSpacer"></td>
                  <td align="center">Day</td>
                </tr>
                
                <tr>
                  <td id="activeYearData"><input id="activeYear" type="text" class="formVeryShort"/></td>
                  <td id="activeYearSlash">/</td>
                  <td id="activeMonthData">
                    <select id="activeMonth">
                      <option value="<%= DateTimeConstants.JANUARY %>">Jan</option>
                      <option value="<%= DateTimeConstants.FEBRUARY %>">Feb</option>
                      <option value="<%= DateTimeConstants.MARCH %>">Mar</option>
                      <option value="<%= DateTimeConstants.APRIL %>">Apr</option>
                      <option value="<%= DateTimeConstants.MAY %>">May</option>
                      <option value="<%= DateTimeConstants.JUNE %>">Jun</option>
                      <option value="<%= DateTimeConstants.JULY %>">Jul</option>
                      <option value="<%= DateTimeConstants.AUGUST %>">Aug</option>
                      <option value="<%= DateTimeConstants.SEPTEMBER %>">Sep</option>
                      <option value="<%= DateTimeConstants.OCTOBER %>">Oct</option>
                      <option value="<%= DateTimeConstants.NOVEMBER %>">Nov</option>
                      <option value="<%= DateTimeConstants.DECEMBER %>">Dec</option>
                    </select>
                  </td>
                  <td id="activeMonthSlash">/</td>
                  <td><select id="activeDay"></select></td>
                </tr>
              </table>
              <table id="activeTimeTable">
                <tr>
                  <td align="center" id="activeHourLabel">Hour</td>
                  <td id="activeHourSpacer"></td>
                  <td align="center">Minute</td>
                  <td></td>
                  <td align="center">Second</td>
                </tr>
                <tr>
                  <td id="activeHourData">
                    <select id="activeHour">
                      <c:forEach begin="0" end="23" var="i">
                        <option>${mango:padZeros(i, 2)}</option>
                      </c:forEach>
                    </select>
                  </td>
                  <td id="activeHourColon">:</td>
                  <td>
                    <select id="activeMinute">
                      <c:forEach begin="0" end="59" var="i">
                        <option>${mango:padZeros(i, 2)}</option>
                      </c:forEach>
                    </select>
                  </td>
                  <td>:</td>
                  <td>
                    <select id="activeSecond">
                      <c:forEach begin="0" end="59" var="i">
                        <option>${mango:padZeros(i, 2)}</option>
                      </c:forEach>
                    </select>
                  </td>
                </tr>
              </table>
              <table id="activeCronTable">
                <tr><td align="center">Cron pattern</td></tr>
                <tr><td><input type="text" id="activeCron"/> <mango:help id="6qlxgdqxsqRmFoejL8Jx"/></td></tr>
              </table>
            </td>
          </tr>
          
          <tr id="inactiveDateTimeRow">
            <td class="formLabelRequired">Inactive time</td>
            <td>
              <table id="inactiveDateTable">
                <tr>
                  <td align="center" id="inactiveYearLabel">Year</td>
                  <td id="inactiveYearSpacer"></td>
                  <td align="center" id="inactiveMonthLabel">Month</td>
                  <td id="inactiveMonthSpacer"></td>
                  <td align="center">Day</td>
                </tr>
                <tr>
                  <td id="inactiveYearData"><input id="inactiveYear" type="text" class="formVeryShort"/></td>
                  <td id="inactiveYearSlash">/</td>
                  <td id="inactiveMonthData">
                    <select id="inactiveMonth">
                      <option value="<%= DateTimeConstants.JANUARY %>">Jan</option>
                      <option value="<%= DateTimeConstants.FEBRUARY %>">Feb</option>
                      <option value="<%= DateTimeConstants.MARCH %>">Mar</option>
                      <option value="<%= DateTimeConstants.APRIL %>">Apr</option>
                      <option value="<%= DateTimeConstants.MAY %>">May</option>
                      <option value="<%= DateTimeConstants.JUNE %>">Jun</option>
                      <option value="<%= DateTimeConstants.JULY %>">Jul</option>
                      <option value="<%= DateTimeConstants.AUGUST %>">Aug</option>
                      <option value="<%= DateTimeConstants.SEPTEMBER %>">Sep</option>
                      <option value="<%= DateTimeConstants.OCTOBER %>">Oct</option>
                      <option value="<%= DateTimeConstants.NOVEMBER %>">Nov</option>
                      <option value="<%= DateTimeConstants.DECEMBER %>">Dec</option>
                    </select>
                  </td>
                  <td id="inactiveMonthSlash">/</td>
                  <td><select id="inactiveDay"></select></td>
                </tr>
              </table>
              <table id="inactiveTimeTable">
                <tr>
                  <td align="center" id="inactiveHourLabel">Hour</td>
                  <td id="inactiveHourSpacer"></td>
                  <td align="center">Minute</td>
                  <td></td>
                  <td align="center">Second</td>
                </tr>
                <tr>
                  <td id="inactiveHourData">
                    <select id="inactiveHour">
                      <c:forEach begin="0" end="23" var="i">
                        <option>${mango:padZeros(i, 2)}</option>
                      </c:forEach>
                    </select>
                  </td>
                  <td id="inactiveHourColon">:</td>
                  <td>
                    <select id="inactiveMinute">
                      <c:forEach begin="0" end="59" var="i">
                        <option>${mango:padZeros(i, 2)}</option>
                      </c:forEach>
                    </select>
                  </td>
                  <td>:</td>
                  <td>
                    <select id="inactiveSecond">
                      <c:forEach begin="0" end="59" var="i">
                        <option>${mango:padZeros(i, 2)}</option>
                      </c:forEach>
                    </select>
                  </td>
                </tr>
              </table>
              <table id="inactiveCronTable">
                <tr><td align="center">Cron pattern</td></tr>
                <tr><td><input type="text" id="inactiveCron"/> <mango:help id="6qlxgdqxsqRmFoejL8Jx"/></td></tr>
              </table>
            </td>
          </tr>
          
          <tr>
            <td class="formLabelRequired">Disabled</td>
            <td class="formField"><input type="checkbox" id="disabled"/></td>
          </tr>
        </table>
        
        <table>
          <tr>
            <td colspan="2" id="userMessage" class="formError" style="display:none;"></td>
          </tr>
        </table>
      </div>
    </td>
  </tr>
</table>

<mango:footer/>