<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.db.dao.SystemSettingsDao"%>
<%@page import="com.serotonin.mango.Common"%>
<mango:header onload="init()">
  <mango:script src='dwr/interface/SystemSettingsDwr.js'/>
  <mango:script>
    <script>
    function init() {
        SystemSettingsDwr.getSettings(updateSettings);
    }
    
    function updateSettings(settings) {
        $set("<%= SystemSettingsDao.EMAIL_SMTP_HOST %>", settings.<%= SystemSettingsDao.EMAIL_SMTP_HOST %>);
        $set("<%= SystemSettingsDao.EMAIL_FROM_ADDRESS %>", settings.<%= SystemSettingsDao.EMAIL_FROM_ADDRESS %>);
        $set("<%= SystemSettingsDao.EMAIL_FROM_NAME %>", settings.<%= SystemSettingsDao.EMAIL_FROM_NAME %>);
        $set("<%= SystemSettingsDao.EMAIL_AUTHORIZATION %>", settings.<%= SystemSettingsDao.EMAIL_AUTHORIZATION %>);
        $set("<%= SystemSettingsDao.EMAIL_SMTP_USERNAME %>", settings.<%= SystemSettingsDao.EMAIL_SMTP_USERNAME %>);
        $set("<%= SystemSettingsDao.EMAIL_SMTP_PASSWORD %>", settings.<%= SystemSettingsDao.EMAIL_SMTP_PASSWORD %>);
        smtpAuthChange();
        
        $set("<%= SystemSettingsDao.HTTP_CLIENT_USE_PROXY %>", settings.<%= SystemSettingsDao.HTTP_CLIENT_USE_PROXY %>);
        $set("<%= SystemSettingsDao.HTTP_CLIENT_PROXY_SERVER %>", settings.<%= SystemSettingsDao.HTTP_CLIENT_PROXY_SERVER %>);
        $set("<%= SystemSettingsDao.HTTP_CLIENT_PROXY_PORT %>", settings.<%= SystemSettingsDao.HTTP_CLIENT_PROXY_PORT %>);
        $set("<%= SystemSettingsDao.HTTP_CLIENT_PROXY_USERNAME %>", settings.<%= SystemSettingsDao.HTTP_CLIENT_PROXY_USERNAME %>);
        $set("<%= SystemSettingsDao.HTTP_CLIENT_PROXY_PASSWORD %>", settings.<%= SystemSettingsDao.HTTP_CLIENT_PROXY_PASSWORD %>);
        httpUseProxyChange();
        
        $set("<%= SystemSettingsDao.EVENT_PURGE_PERIOD_TYPE %>", settings.<%= SystemSettingsDao.EVENT_PURGE_PERIOD_TYPE %>);
        $set("<%= SystemSettingsDao.EVENT_PURGE_PERIODS %>", settings.<%= SystemSettingsDao.EVENT_PURGE_PERIODS %>);
        $set("<%= SystemSettingsDao.REPORT_PURGE_PERIOD_TYPE %>", settings.<%= SystemSettingsDao.REPORT_PURGE_PERIOD_TYPE %>);
        $set("<%= SystemSettingsDao.REPORT_PURGE_PERIODS %>", settings.<%= SystemSettingsDao.REPORT_PURGE_PERIODS %>);
        
        $set("<%= SystemSettingsDao.MANGO_ID %>", settings.<%= SystemSettingsDao.MANGO_ID %>);
        $set("<%= SystemSettingsDao.NEW_VERSION_NOTIFICATION_LEVEL %>", settings.<%= SystemSettingsDao.NEW_VERSION_NOTIFICATION_LEVEL %>);
        
        dbSizeUpdateCB(settings);
    }
    
    function dbSizeUpdate() {
        SystemSettingsDwr.getDatabaseSize(dbSizeUpdateCB);
    }
    
    function dbSizeUpdateCB(data) {
        $set("databaseSize", data.databaseSize);
    }
    
    function saveEmailSettings() {
        SystemSettingsDwr.saveEmailSettings(
            $get("<%= SystemSettingsDao.EMAIL_SMTP_HOST %>"),
            $get("<%= SystemSettingsDao.EMAIL_FROM_ADDRESS %>"),
            $get("<%= SystemSettingsDao.EMAIL_FROM_NAME %>"),
            $get("<%= SystemSettingsDao.EMAIL_AUTHORIZATION %>"),
            $get("<%= SystemSettingsDao.EMAIL_SMTP_USERNAME %>"),
            $get("<%= SystemSettingsDao.EMAIL_SMTP_PASSWORD %>"),
            saveEmailSettingsCB);
        setUserMessage("emailMessage");
        startImageFader("saveEmailSettingsImg");
    }
    
    function saveEmailSettingsCB() {
        stopImageFader("saveEmailSettingsImg");
        setUserMessage("emailMessage", "Email settings have been saved");
    }
    
    function sendTestEmail() {
        SystemSettingsDwr.sendTestEmail(
                $get("<%= SystemSettingsDao.EMAIL_SMTP_HOST %>"),
                $get("<%= SystemSettingsDao.EMAIL_FROM_ADDRESS %>"),
                $get("<%= SystemSettingsDao.EMAIL_FROM_NAME %>"),
                $get("<%= SystemSettingsDao.EMAIL_AUTHORIZATION %>"),
                $get("<%= SystemSettingsDao.EMAIL_SMTP_USERNAME %>"),
                $get("<%= SystemSettingsDao.EMAIL_SMTP_PASSWORD %>"), sendTestEmailCB);
        setUserMessage("emailMessage");
        startImageFader("sendTestEmailImg");
    }
    
    function sendTestEmailCB(result) {
        stopImageFader("sendTestEmailImg");
        show("userMessage");
        if (result.exception)
            setUserMessage("emailMessage", result.exception);
        else
            setUserMessage("emailMessage", "Test email was sent to "+ result.emailAddress);
    }
    
    function smtpAuthChange() {
        var auth = $("<%= SystemSettingsDao.EMAIL_AUTHORIZATION %>").checked;
        setDisabled($("<%= SystemSettingsDao.EMAIL_SMTP_USERNAME %>"), !auth);
        setDisabled($("<%= SystemSettingsDao.EMAIL_SMTP_PASSWORD %>"), !auth);
    }
    
    function saveHttpSettings() {
        SystemSettingsDwr.saveHttpSettings(
                $get("<%= SystemSettingsDao.HTTP_CLIENT_USE_PROXY %>"),
                $get("<%= SystemSettingsDao.HTTP_CLIENT_PROXY_SERVER %>"),
                $get("<%= SystemSettingsDao.HTTP_CLIENT_PROXY_PORT %>"),
                $get("<%= SystemSettingsDao.HTTP_CLIENT_PROXY_USERNAME %>"),
                $get("<%= SystemSettingsDao.HTTP_CLIENT_PROXY_PASSWORD %>"),
                saveHttpSettingsCB);
        setUserMessage("httpMessage");
        startImageFader("saveHttpSettingsImg");
    }
    
    function saveHttpSettingsCB() {
        stopImageFader("saveHttpSettingsImg");
        setUserMessage("httpMessage", "Http settings have been saved");
    }
        
    function httpUseProxyChange() {
        var proxy = $("<%= SystemSettingsDao.HTTP_CLIENT_USE_PROXY %>").checked;
        setDisabled($("<%= SystemSettingsDao.HTTP_CLIENT_PROXY_SERVER %>"), !proxy);
        setDisabled($("<%= SystemSettingsDao.HTTP_CLIENT_PROXY_PORT %>"), !proxy);
        setDisabled($("<%= SystemSettingsDao.HTTP_CLIENT_PROXY_USERNAME %>"), !proxy);
        setDisabled($("<%= SystemSettingsDao.HTTP_CLIENT_PROXY_PASSWORD %>"), !proxy);
    }
    
    function saveMiscSettings() {
        SystemSettingsDwr.saveMiscSettings(
                $get("<%= SystemSettingsDao.EVENT_PURGE_PERIOD_TYPE %>"),
                $get("<%= SystemSettingsDao.EVENT_PURGE_PERIODS %>"),
                $get("<%= SystemSettingsDao.REPORT_PURGE_PERIOD_TYPE %>"),
                $get("<%= SystemSettingsDao.REPORT_PURGE_PERIODS %>"),
                saveMiscSettingsCB);
        setUserMessage("miscMessage");
        startImageFader("saveMiscSettingsImg");
    }
    
    function saveMiscSettingsCB() {
        stopImageFader("saveMiscSettingsImg");
        setUserMessage("miscMessage", "Settings have been saved");
    }
        
    function setUserMessage(type, msg) {
        if (msg)
            $(type).innerHTML = msg;
        else
            $(type).innerHTML = "";
    }
    
    function saveVersionSettings() {
        SystemSettingsDwr.saveVersionSettings(
                $get("<%= SystemSettingsDao.NEW_VERSION_NOTIFICATION_LEVEL %>"),
                saveVersionSettingsCB);
        setUserMessage("versionMessage");
        startImageFader("saveVersionSettingsImg");
    }
    
    function saveVersionSettingsCB() {
        stopImageFader("saveVersionSettingsImg");
        setUserMessage("versionMessage", "Version settings have been saved");
    }
    
    function newVersionCheck() {
        SystemSettingsDwr.newVersionCheck($get("<%= SystemSettingsDao.NEW_VERSION_NOTIFICATION_LEVEL %>"),
                newVersionCheckCB);
    }
    
    function newVersionCheckCB(result) {
        if (!result)
            result = "This instance of Mango is up to date";
        alert(result);
    }
    </script>
  </mango:script>
</mango:header>

<table cellpadding="0" cellspacing="0">
  <tr>
    <td valign="top">
      <div class="borderDiv marB marR">
        <table width="100%">
          <tr>
            <td>
              <span class="smallTitle">Email settings</span>
              <mango:help id="FBSA9AE0m87dZiP02QqB"/>
            </td>
            <td align="right">
              <img id="saveEmailSettingsImg" src="images/save.png" onclick="saveEmailSettings();" class="ptr" 
                      title="Save"/>
              <img id="sendTestEmailImg" src="images/email_go.png" onclick="sendTestEmail();" class="ptr" 
                      title="Send test email"/>
            </td>
          </tr>
        </table>
        <table>
          <tr>
            <td class="formLabelRequired">SMTP host</td>
            <td class="formField"><input id="<%= SystemSettingsDao.EMAIL_SMTP_HOST %>" type="text"/></td>
          </tr>
          <tr>
            <td class="formLabelRequired">'From' address</td>
            <td class="formField"><input id="<%= SystemSettingsDao.EMAIL_FROM_ADDRESS %>" type="text"/></td>
          </tr>
          <tr>
            <td class="formLabel">'From' name</td>
            <td class="formField"><input id="<%= SystemSettingsDao.EMAIL_FROM_NAME %>" type="text"/></td>
          </tr>
          <tr>
            <td class="formLabelRequired">Use authorization</td>
            <td class="formField">
              <input id="<%= SystemSettingsDao.EMAIL_AUTHORIZATION %>" type="checkbox" onclick="smtpAuthChange()"/>
            </td>
          </tr>
          <tr>
            <td class="formLabel">Username</td>
            <td class="formField"><input id="<%= SystemSettingsDao.EMAIL_SMTP_USERNAME %>" type="text"/></td>
          </tr>
          <tr>
            <td class="formLabel">Password</td>
            <td class="formField"><input id="<%= SystemSettingsDao.EMAIL_SMTP_PASSWORD %>" type="text"/></td>
          </tr>
          
          <tr>
            <td colspan="2" id="emailMessage" class="formError"></td>
          </tr>
        </table>
      </div>
      
      <div class="borderDiv marR">
        <table width="100%">
          <tr>
            <td>
              <span class="smallTitle">Other settings</span>
              <mango:help id="YtDxqemgHCtYJYIBgn4i"/>
            </td>
            <td align="right">
              <img id="saveMiscSettingsImg" src="images/save.png" onclick="saveMiscSettings();" class="ptr" 
                      title="Save"/>
            </td>
          </tr>
        </table>
        <table>
          <tr>
            <td class="formLabelRequired">Purge events older than</td>
            <td class="formField">
              <input id="<%= SystemSettingsDao.EVENT_PURGE_PERIODS %>" type="text" class="formShort"/>
              <select id="<%= SystemSettingsDao.EVENT_PURGE_PERIOD_TYPE %>">
                <option value="<%= Integer.toString(Common.TimePeriods.DAYS) %>">day(s)</option>
                <option value="<%= Integer.toString(Common.TimePeriods.WEEKS) %>">week(s)</option>
                <option value="<%= Integer.toString(Common.TimePeriods.MONTHS) %>">month(s)</option>
                <option value="<%= Integer.toString(Common.TimePeriods.YEARS) %>">year(s)</option>
              </select>
            </td>
          </tr>
          <tr>
            <td class="formLabelRequired">Purge report instances older than</td>
            <td class="formField">
              <input id="<%= SystemSettingsDao.REPORT_PURGE_PERIODS %>" type="text" class="formShort"/>
              <select id="<%= SystemSettingsDao.REPORT_PURGE_PERIOD_TYPE %>">
                <option value="<%= Integer.toString(Common.TimePeriods.DAYS) %>">day(s)</option>
                <option value="<%= Integer.toString(Common.TimePeriods.WEEKS) %>">week(s)</option>
                <option value="<%= Integer.toString(Common.TimePeriods.MONTHS) %>">month(s)</option>
                <option value="<%= Integer.toString(Common.TimePeriods.YEARS) %>">year(s)</option>
              </select>
            </td>
          </tr>
          <tr>
            <td colspan="2" id="miscMessage" class="formError"></td>
          </tr>
        </table>
      </div>
    </td>
    
    <td valign="top">
      <div class="borderDiv marB">
        <table width="100%">
          <tr>
            <td>
              <span class="smallTitle">Http settings</span>
              <mango:help id="ODmhmjyw1Cel3T32rWaq"/>
            </td>
            <td align="right">
              <img id="saveHttpSettingsImg" src="images/save.png" onclick="saveHttpSettings();" class="ptr" 
                      title="Save"/>
            </td>
          </tr>
        </table>
        <table>
          <tr>
            <td class="formLabelRequired">Use proxy</td>
            <td class="formField">
              <input id="<%= SystemSettingsDao.HTTP_CLIENT_USE_PROXY %>" type="checkbox"
                      onclick="httpUseProxyChange()"/>
            </td>
          </tr>
          <tr>
            <td class="formLabel">Proxy host</td>
            <td class="formField"><input id="<%= SystemSettingsDao.HTTP_CLIENT_PROXY_SERVER %>" type="text"/></td>
          </tr>
          <tr>
            <td class="formLabel">Proxy port</td>
            <td class="formField"><input id="<%= SystemSettingsDao.HTTP_CLIENT_PROXY_PORT %>" type="text"/></td>
          </tr>
          <tr>
            <td class="formLabel">Proxy username</td>
            <td class="formField"><input id="<%= SystemSettingsDao.HTTP_CLIENT_PROXY_USERNAME %>" type="text"/></td>
          </tr>
          <tr>
            <td class="formLabel">Proxy password</td>
            <td class="formField"><input id="<%= SystemSettingsDao.HTTP_CLIENT_PROXY_PASSWORD %>" type="text"/></td>
          </tr>
          <tr>
            <td colspan="2" id="httpMessage" class="formError"></td>
          </tr>
        </table>
      </div>
      
      <div class="borderDiv">
        <table width="100%">
          <tr>
            <td>
              <span class="smallTitle">System information</span>
              <mango:help id="YcdQDRJrmYGQ6oV9mVao"/>
            </td>
            <td align="right">
              <img id="saveVersionSettingsImg" src="images/save.png" onclick="saveVersionSettings();" class="ptr" 
                      title="Save"/>
              <img id="refreshImg" src="images/control_repeat_blue.png" onclick="dbSizeUpdate();" class="ptr" title="Refresh"/>
            </td>
          </tr>
        </table>
        <table>
          <tr>
            <td class="formLabelRequired">Instance ID</td>
            <td class="formField"></td>
          </tr>
          <tr><td colspan="2" class="formField" id="<%= SystemSettingsDao.MANGO_ID %>"></td></tr>
          <tr>
            <td class="formLabelRequired">This Mango version</td>
            <td class="formField"><%= Common.getVersion() %></td>
          </tr>
          <tr>
            <td class="formLabelRequired">
              Notify upon release of
            </td>
            <td class="formField" valign="top">
              <select id="newVersionNotificationLevel">
                <option value="<%= SystemSettingsDao.NOTIFICATION_LEVEL_STABLE %>">Stable versions only</option>
                <option value="<%= SystemSettingsDao.NOTIFICATION_LEVEL_RC %>">Release candidates or better</option>
                <option value="<%= SystemSettingsDao.NOTIFICATION_LEVEL_BETA %>">Beta or better</option>
              </select>
              <mango:img png="accept" title="Check now" onclick="newVersionCheck()"/>
            </td>
          </tr>
          <tr>
            <td class="formLabelRequired">Database size</td>
            <td class="formField" id="databaseSize"></td>
          </tr>
          <tr>
            <td colspan="2" id="versionMessage" class="formError"></td>
          </tr>
        </table>
      </div>
    </td>
  </tr>
</table>

<mango:footer/>