<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.Common"%>
<mango:header onload="init();">
  <mango:script src='dwr/interface/UsersDwr.js'/>
  <mango:script>
    <script>
    var userId = <%= Common.getUser((HttpServletRequest)pageContext.getRequest()).getId() %>;
    function init() {
        UsersDwr.getInitData(initCB);
    }
    
    var editingUserId;
    var dataSources;
    var adminUser;
    function initCB(data) {
        if (data.admin) {
            adminUser = true;
        
            show("userList");
            show("usernameRow");
            show("administrationRow");
            show("disabledRow");
            show("dataSources");
            show("sendTestEmailImg");
            
            var i, j;
            for (i=0; i<data.users.length; i++) {
                appendUser(data.users[i].id);
                updateUser(data.users[i]);
            }
            
            var dshtml = "", id, dp;
            dataSources = data.dataSources;
            for (i=0; i<dataSources.length; i++) {
                id = "ds"+ dataSources[i].id;
                dshtml += '<input type="checkbox" id="'+ id +'" onclick="dataSourceChange(this)">';
                dshtml += '<label for="'+ id +'"> '+ dataSources[i].name +'</label><br/>';
                dshtml += '<div style="margin-left:25px;" id="dsps'+ dataSources[i].id +'">';
                if (dataSources[i].points.length > 0) {
                    dshtml +=   '<table cellspacing="0" cellpadding="1">';
                    for (j=0; j<dataSources[i].points.length; j++) {
                        dp = dataSources[i].points[j];
                        dshtml += '<tr>';
                        dshtml +=   '<td class="formLabelRequired">'+ dp.name +'</td>';
                        dshtml +=   '<td>';
                        dshtml +=     '<input type="radio" name="dp'+ dp.id +'" id="dp'+ dp.id +'/0" value="0">';
                        dshtml +=             '<label for="dp'+ dp.id +'/0">None</label> ';
                        dshtml +=     '<input type="radio" name="dp'+ dp.id +'" id="dp'+ dp.id +'/1" value="1">';
                        dshtml +=             '<label for="dp'+ dp.id +'/1">Read</label> ';
                        if (dp.settable) {
                            dshtml +=     '<input type="radio" name="dp'+ dp.id +'" id="dp'+ dp.id +'/2" value="2">';
                            dshtml +=             '<label for="dp'+ dp.id +'/2">Set</label>';
                        }
                        dshtml +=   '</td>';
                        dshtml += '</tr>';
                    }
                    dshtml +=   '</table>';
                }
                dshtml += '</div>';
            }
            $("dataSourceList").innerHTML = dshtml;
        }
        else {
            // Not an admin user.
            adminUser = false;
            editingUserId = data.user.id;
            showUserCB(data.user);
        }
    }
    
    function showUser(userId) {
        if (editingUserId)
            stopImageFader($("u"+ editingUserId +"Img"));
        editingUserId = userId;
        UsersDwr.getUser(userId, showUserCB);
        startImageFader($("u"+ editingUserId +"Img"));
    }
    
    function showUserCB(user) {
        show($("userDetails"));
        $set("username", user.username);
        $set("password", user.password);
        $set("email", user.email);
        $set("phone", user.phone);
        $set("administrator", user.admin);
        $set("disabled", user.disabled);
        
        
        if (adminUser) {
            // Turn off all data sources and set all data points to 'none'.
            var i, j, dscb, dp;
            for (i=0; i<dataSources.length; i++) {
                dscb = $("ds"+ dataSources[i].id);
                dscb.checked = false;
                dataSourceChange(dscb);
                for (j=0; j<dataSources[i].points.length; j++)
                    $set("dp"+ dataSources[i].points[j].id, "0");
            }
            
            // Turn on the data sources to which the user has permission.
            for (i=0; i<user.dataSourcePermissions.length; i++) {
                dscb = $("ds"+ user.dataSourcePermissions[i]);
                dscb.checked = true;
                dataSourceChange(dscb);
            }
            
            // Update the data point permissions.
            for (i=0; i<user.dataPointPermissions.length; i++)
                $set("dp"+ user.dataPointPermissions[i].dataPointId, user.dataPointPermissions[i].permission);
        }
        
        setUserMessage();
        updateUserImg();
    }
    
    function saveUser() {
        setUserMessage();
        if (adminUser) {
            // Create the list of allowed data sources and data point permissions.
            var i, j;
            var dsPermis = new Array();
            var dpPermis = new Array();
            var dpval;
            for (i=0; i<dataSources.length; i++) {
                if ($("ds"+ dataSources[i].id).checked)
                    dsPermis[dsPermis.length] = dataSources[i].id;
                else {
                    for (j=0; j<dataSources[i].points.length; j++) {
                        dpval = $get("dp"+ dataSources[i].points[j].id);
                        if (dpval == "1" || dpval == "2")
                            dpPermis[dpPermis.length] = {dataPointId: dataSources[i].points[j].id, permission: dpval};
                    }
                }
            }
            
            UsersDwr.saveUserAdmin(editingUserId, $get("username"), $get("password"), $get("email"), $get("phone"), 
                    $get("administrator"), $get("disabled"), dsPermis, dpPermis, saveUserCB);
        }
        else
            UsersDwr.saveUser(editingUserId, $get("password"), $get("email"), $get("phone"), saveUserCB);
    }
    
    function saveUserCB(result) {
        if (result.errorMessage)
            setUserMessage(result.errorMessage);
        else if (!adminUser)
            setUserMessage("User data saved");
        else {
            if (editingUserId == <%= Common.NEW_ID %>) {
                stopImageFader($("u"+ editingUserId +"Img"));
                editingUserId = result.userId;
                appendUser(editingUserId);
                startImageFader($("u"+ editingUserId +"Img"));
                setUserMessage("User added");
            }
            else
                setUserMessage("User saved");
            UsersDwr.getUser(editingUserId, updateUser)
        }
    }
    
    function sendTestEmail() {
        UsersDwr.sendTestEmail($get("email"), $get("username"), sendTestEmailCB);
        startImageFader($("sendTestEmailImg"));
    }
    
    function sendTestEmailCB(result) {
        stopImageFader($("sendTestEmailImg"));
        if (result.exception)
            setUserMessage(result.exception);
        else
            setUserMessage("Test email was sent to "+ result.emailAddress);
    }
    
    function setUserMessage(message) {
        if (message) {
            show("userMessage");
            $("userMessage").innerHTML = message;
        }
        else
            hide("userMessage");
    }
    
    function appendUser(userId) {
        createFromTemplate("u_TEMPLATE_", userId, "usersTable");
    }
    
    function updateUser(user) {
        $("u"+ user.id +"Username").innerHTML = user.username;
        setUserImg(user.admin, user.disabled, $("u"+ user.id +"Img"));
    }
    
    function updateUserImg() {
        var admin = $get("administrator");
        if (adminUser) {
            if (admin)
                hide("dataSources");
            else
                show("dataSources");
        }
        setUserImg(admin, $get("disabled"), $("userImg"));
    }
    
    function dataSourceChange(dscb) {
        display("dsps"+ dscb.id.substring(2), !dscb.checked);
    }
    </script>
  </mango:script>
</mango:header>

<table>
  <tr>
    <td valign="top" id="userList" style="display:none;">
      <div class="borderDiv">
        <table width="100%">
          <tr>
            <td>
              <span class="smallTitle">Users</span>
              <mango:help id="cCVvQ8n3MqYLRoUTOicv"/>
            </td>
            <td align="right"><img src="images/user_add.png" class="ptr" onclick="showUser(<%= Common.NEW_ID %>)" 
                    id="u<%= Common.NEW_ID %>Img"/></td>
          </tr>
        </table>
        <table id="usersTable">
          <tbody id="u_TEMPLATE_" onclick="showUser(getMangoId(this))" class="ptr" style="display:none;"><tr>
            <td><img id="u_TEMPLATE_Img" src="images/user_green.png" title="User" alt="User"/></td>
            <td class="link" id="u_TEMPLATE_Username"></td>
          </tr></tbody>
        </table>
      </div>
    </td>
    
    <td valign="top" style="display:none;" id="userDetails">
      <div class="borderDiv">
        <table width="100%">
          <tr>
            <td>
              <span class="smallTitle"><img id="userImg" src="images/user_green.png" title="User" alt="User"/>
              User details</span>
            </td>
            <td align="right">
              <img src="images/save.png" onclick="saveUser();" class="ptr" title="Save"/>
              <img id="sendTestEmailImg" src="images/email_go.png" onclick="sendTestEmail();" title="Send test email"
                      class="ptr" style="display:none;"/>
            </td>
          </tr>
        </table>
        <table>
          <tr>
            <td colspan="2" id="userMessage" class="formError" style="display:none;"></td>
          </tr>
          <tr id="usernameRow" style="display:none;">
            <td class="formLabelRequired">Username</td>
            <td class="formField"><input id="username" type="text"/></td>
          </tr>
          <tr>
            <td class="formLabelRequired">New password</td>
            <td class="formField"><input id="password" type="text"/></td>
          </tr>
          <tr>
            <td class="formLabelRequired">Email</td>
            <td class="formField"><input id="email" type="text" class="formLong"/></td>
          </tr>
          <tr>
            <td class="formLabel">Phone</td>
            <td class="formField"><input id="phone" type="text"/></td>
          </tr>
          <tr id="administrationRow" style="display:none;">
            <td class="formLabelRequired">Administrator</td>
            <td class="formField"><input id="administrator" type="checkbox" onclick="updateUserImg();"/></td>
          </tr>
          <tr id="disabledRow" style="display:none;">
            <td class="formLabelRequired">Disabled</td>
            <td class="formField"><input id="disabled" type="checkbox" onclick="updateUserImg();"/></td>
          </tr>
          <tbody id="dataSources" style="display:none;">
            <tr><td class="horzSeparator" colspan="2"></td></tr>
            <tr id="dataSources">
              <td class="formLabelRequired">Data sources</td>
              <td class="formField" id="dataSourceList"></td>
            </tr>
          </tbody>
        </table>
      </div>
    </td>
  </tr>
</table>

<mango:footer/>