<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.view.View"%>
<mango:header onload="doOnload()">
  <mango:script src='dwr/interface/ViewDwr.js'/>
  <mango:script>
    <script>
    dojo.require("dojo.dnd.HtmlDragMove");
    dojo.require("dojo.event.*");
    
    dwr.engine.setErrorHandler(function(e) {
        alert(errorToString(e));
    });
    
    function scheduledGetData() {
        ViewDwr.getViewEditPointData(false, scheduledSetData);
    }
    
    function scheduledSetData(data) {
        setData(data);
        // Refresh data every ten seconds.
        setTimeout(scheduledGetData, 10000);
    }
    
    function getData() {
        ViewDwr.getViewEditPointData(true, setData);
    }
    
    function setData(stateArr) {
        var state;
        for (var i=0; i<stateArr.length; i++) {
            state = stateArr[i];
            
            // Check that the point exists. Ignore if it doesn't.
            if (!$("c"+ state.id))
                throw "Can't find point view c"+ state.id;
            
            if (state.content)
                $("c"+ state.id +"Content").innerHTML = state.content;
            
            $set("c"+ state.id +"Info", state.info);
        }
    }
    
    function addPoint() {
        var pointId = $("pointList").value;
        if (pointId > 0)
            ViewDwr.addPoint(pointId, addPointCB);
        return false;
    }
    
    function addPointCB(pointViewId) {
        var pointContent = $("c_TEMPLATE_").cloneNode(true);
        updateNodeIds(pointContent, pointViewId);
        $("viewContent").appendChild(pointContent);
        pointContent.pointViewId = pointViewId;
        show(pointContent);
        
        // Calculate the location for the new point. For now just put it in the center.
        var bkgd = $("viewBackground");
        var bkgdBox = dojo.html.getMarginBox(bkgd);
        var pointContentBox = dojo.html.getMarginBox(pointContent);
        
        pointContent.style.left = parseInt((bkgdBox.width - pointContentBox.width) / 2) + "px";
        pointContent.style.top = parseInt((bkgdBox.height - pointContentBox.height) / 2) + "px";
        
        addDnD("c"+ pointViewId);
        updatePointViewLocation(pointContent.id);
        updateAvailablePoints();
        getData();
    }
    
    function updateNodeIds(elem, id) {
        var i;
        for (i=0; i<elem.attributes.length; i++) {
            if (elem.attributes[i].value && elem.attributes[i].value.indexOf("_TEMPLATE_") != -1)
                elem.attributes[i].value = elem.attributes[i].value.replace(/_TEMPLATE_/, id);
        }
        for (var i=0; i<elem.childNodes.length; i++) {
            if (elem.childNodes[i].attributes)
                updateNodeIds(elem.childNodes[i], id);
        }
    }
    
    function doOnload() {
        <c:forEach items="${form.view.pointViews}" var="pv">
          addDnD("c${pv.id}");
        </c:forEach>
        updateAvailablePoints();
        ViewDwr.getViewEditPointData(true, scheduledSetData);
    }
    
    function updateAvailablePoints() {
        var showDups = $get("showDuplicates");
        var showDisabled = $get("showDisabled");
        ViewDwr.getAvailablePoints($get("dataSourceList"), showDups, showDisabled, setAvailablePoints);
    }
    
    function setAvailablePoints(data) {
        dwr.util.removeAllOptions($("pointList"));
        dwr.util.addOptions($("pointList"), data, "key", "value");
    }
    
    function openSettingsEditor(cid) {
        closeEditors();
        settingsEditor.open(cid);
    }
    
    function openGraphicRendererEditor(cid) {
        closeEditors();
        graphicRendererEditor.open(cid);
    }
    
    function updatePointViewLocation(divId) {
        var div = $(divId);
        var lt = div.style.left;
        var tp = div.style.top;
        
        // Remove the 'px's from the positions.
        lt = lt.substring(0, lt.length-2);
        tp = tp.substring(0, tp.length-2);
        
        // Save the new location.
        ViewDwr.setPointViewLocation(divId.substring(1), lt, tp);
    }
    
    function addDnD(divId) {
        var div = $(divId)
        var dragSource = new dojo.dnd.HtmlDragMoveSource(div);
        dragSource.constrainTo($("viewBackground"));
        
        // Save the drag source in the div in case it gets deleted. See below.
        div.dragSource = dragSource;
        // Also, create a function to call on drag end to update the point view's location.
        div.onDragEnd = function() {updatePointViewLocation(divId)};
        
        dojo.event.connect(dragSource, "onDragEnd", div.onDragEnd);
    }
    
    function deletePointView(pointViewId) {
        closeEditors();
        ViewDwr.deletePointView(pointViewId);
        
        var div = $("c"+ pointViewId);
        
        // Unregister the drag source from the DnD manager.
        div.dragSource.unregister();
        // Disconnect the event handling for drag ends on this guy.
        $("viewContent").removeChild(div);
        
        // Add this data point back into the available points list.
        updateAvailablePoints();
        return false;
    }
    
    function closeEditors() {
        settingsEditor.close();
        graphicRendererEditor.close();
    }
    
    function getPointViewId(node) {
        while (!(node.pointViewId))
            node = node.parentNode;
        return node.pointViewId;
    }
    </script>
  </mango:script>
</mango:header>

<form name="view" action="" method="post" enctype="multipart/form-data">
  <table class="borderDiv">
    <tr>
      <td colspan="3">
        <img src="images/icon_view.png" width="16" height="16" border="0" alt="Edit view" title="Edit view"/>
        <span class="smallTitle">View properties</span>
        <mango:help id="DKdnM7tbRe69H22pfkLa"/>
      </td>
    </tr>
  
    <spring:bind path="form.view.name">
      <tr>
        <td class="formLabelRequired" width="150">Name</td>
        <td class="formField" width="250">
          <input type="text" name="view.name" value="${status.value}"/>
        </td>
        <td class="formError">${status.errorMessage}</td>
      </tr>
    </spring:bind>
    <spring:bind path="form.backgroundImageMP">
      <tr>
        <td class="formLabelRequired">Background image</td>
        <td class="formField">
          <input type="file" name="backgroundImageMP"/>
        </td>
        <td class="formError">${status.errorMessage}</td>
      </tr>
    </spring:bind>
    <tr>
      <td colspan="2" align="center">
        <input type="submit" name="upload" value="Upload image"/>
      </td>
      <td></td>
    </tr>
    <spring:bind path="form.view.anonymousAccess">
      <tr>
        <td class="formLabelRequired" width="150">Anonymous access</td>
        <td class="formField" width="250">
          <sst:select name="view.anonymousAccess" value="${status.value}">
            <sst:option value="<%= Integer.toString(View.ANON_NONE) %>">None</sst:option>
            <sst:option value="<%= Integer.toString(View.ANON_READ) %>">Read</sst:option>
            <sst:option value="<%= Integer.toString(View.ANON_SET) %>">Set</sst:option>
          </sst:select>
        </td>
        <td class="formError">${status.errorMessage}</td>
      </tr>
    </spring:bind>
  </table>
  <br/>
  
  <table>
    <tr>
      <td>
        Points:
        <select id="pointList"></select>
        <a href="#" onclick="return addPoint();"><img src="images/plugin_add.png" width="16" height="16" 
                alt="Add point to view" title="Add point to view" border="0"/></a>
      </td>
      <td><img src="images/menu_separator.png"/></td>
      <td onmouseover="showMenu('filters', 0, 0)">
        Filters
        <div id="filters" style="visibility:hidden;left:0px;top:12px;z-index:10;" class="labelDiv"
                onmouseout="hideLayer(this)">
          <table cellpadding="0" cellspacing="0">
            <tr><td>
              <input id="showDuplicates" type="checkbox" onclick="updateAvailablePoints()" align="bottom"/>
              <label for="showDuplicates">Show duplicates</label>
            </td></tr>
            <tr><td>
              <input id="showDisabled" type="checkbox" onclick="updateAvailablePoints()"/>
              <label for="showDisabled">Show disabled</label><br/>
            </td></tr>
            <tr><td class="horzSeparator"></td></tr>
            <tr><td>
              <input type="radio" id="dsl0" name="dataSourceList" value="0" onchange="updateAvailablePoints()"
                      checked="checked"/>
              <label for="dsl0">All data sources</label><br/>
            </td></tr>
            <c:forEach items="${dataSources}" var="dataSource">
              <tr><td>
                <input type="radio" id="dsl${dataSource.id}" name="dataSourceList" value="${dataSource.id}"
                        onchange="updateAvailablePoints()"/>
                <label for="dsl${dataSource.id}">${dataSource.name}</label><br/>
              </td></tr>
            </c:forEach>
          </table>
        </div>
      </td>
    </tr>
  </table>

  <table width="100%" cellspacing="0" cellpadding="0">
    <tr>
      <td>
        <table cellspacing="0" cellpadding="0">
          <tr>
            <td colspan="3">
              <div id="viewContent" class="borderDiv" style="left:0px;top:0px;float:left;
                      padding-right:1px;padding-bottom:1px;">
                <c:choose>
                  <c:when test="${empty form.view.backgroundFilename}">
                    <img id="viewBackground" src="images/spacer.gif" alt="" width="740" height="400"
                            style="top:1px;left:1px;"/>
                  </c:when>
                  <c:otherwise>
                    <img id="viewBackground" src="${form.view.backgroundFilename}" alt=""
                            style="top:1px;left:1px;"/>
                  </c:otherwise>
                </c:choose>
                
                <c:forEach items="${form.view.pointViews}" var="pv">
                  <div id="c${pv.id}" onmouseover="showLayer('c${pv.id}Controls');"
                          onmouseout="hideLayer('c${pv.id}Controls');"
                          style="position:absolute;left:${pv.x}px;top:${pv.y}px;">
                    <div id="c${pv.id}Content"><img src="images/icon_comp.png" alt=""/></div>
                    <div id="c${pv.id}Controls" class="controlsDiv">
                      <table cellpadding="0" cellspacing="1">
                        <tr onmouseover="showMenu('c${pv.id}Info', 16, 0);" onmouseout="hideLayer('c${pv.id}Info');">
                          <td>
                            <img src="images/information.png" alt=""/>
                            <div id="c${pv.id}Info" onmouseout="hideLayer(this);">
                              <img src="images/hourglass.png" alt="Getting data..."/>
                            </div>
                          </td>
                        </tr>
                        <tr><td><img src="images/plugin_edit.png" onclick="openSettingsEditor(${pv.id})"
                                class="ptr" alt="" title="Edit point view settings"/></td></tr>
                        <tr><td><img src="images/graphic.png" onclick="openGraphicRendererEditor(${pv.id})" 
                                class="ptr" alt="" title="Edit graphical renderer"/></td></tr>
                        <tr><td><img src="images/plugin_delete.png" onclick="deletePointView(${pv.id})" 
                                class="ptr" alt="" title="Delete point from view"/></td></tr>
                      </table>
                    </div>
                  </div>
                </c:forEach>
                
                <%@ include file="/WEB-INF/jsp/include/settingsEditor.jsp" %>
                <%@ include file="/WEB-INF/jsp/include/graphicRendererEditor.jsp" %>
              </div>
            </td>
          </tr>
          
          <tr><td colspan="3">&nbsp;</td></tr>
          
          <tr>
            <td colspan="2" align="center">
              <input type="submit" name="save" value="Save"/>
              <input type="submit" name="delete" value="Delete"/>
              <input type="submit" name="cancel" value="Cancel"/>
            </td>
            <td></td>
          </tr>
        </table>
      
        <div id="c_TEMPLATE_" onmouseover="showLayer('c'+ getPointViewId(this) +'Controls');"
                onmouseout="hideLayer('c'+ getPointViewId(this) +'Controls');"
                style="position:absolute;left:0px;top:0px;display:none;">
          <div id="c_TEMPLATE_Content"><img src="images/icon_comp.png" alt=""/></div>
          <div id="c_TEMPLATE_Controls" class="controlsDiv">
            <table cellpadding="0" cellspacing="1">
              <tr onmouseover="showMenu('c'+ getPointViewId(this) +'Info', 16, 0);"
                      onmouseout="hideLayer('c'+ getPointViewId(this) +'Info');">
                <td>
                  <img src="images/information.png" alt=""/>
                  <div id="c_TEMPLATE_Info" onmouseout="hideLayer(this);">
                    <img src="images/hourglass.png" alt="Getting data..."/>
                  </div>
                </td>
              </tr>
              <tr><td><img src="images/plugin_edit.png" onclick="openSettingsEditor(getPointViewId(this))"
                      class="ptr" alt="" title="Edit point view settings"/></td></tr>
              <tr><td><img src="images/graphic.png" onclick="openGraphicRendererEditor(getPointViewId(this))"
                      class="ptr" alt="" title="Edit graphical renderer"/></td></tr>
              <tr><td><img src="images/plugin_delete.png" onclick="deletePointView(getPointViewId(this))"
                      class="ptr" alt="" title="Delete point from view"/></td></tr>
            </table>
          </div>
        </div>
      </td>
    </tr>
  </table>
</form>

<mango:footer/>