<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<mango:header>
  <mango:script src='resources/view.js'/>
  <mango:script src='dwr/interface/ViewDwr.js'/>
</mango:header>

<table class="borderDiv">
  <tr>
    <td class="smallTitle">Graphic views <mango:help id="zJnmiBjwSxrHSlAG9DSc"/></td>
    <td width="50"></td>
    <td align="right">
      <sst:select value="${currentView.id}" onchange="window.location='?viewId='+ this.value;">
        <c:forEach items="${views}" var="aView">
          <sst:option value="${aView.id}">${aView.name}</sst:option>
        </c:forEach>
      </sst:select>
      <c:if test="${!empty currentView}">
        <a href="view_edit.shtm?viewId=${currentView.id}"><img src="images/icon_view_edit.png" border="0"
                alt="Edit view" title="Edit view"/></a>
      </c:if>
      <a href="view_edit.shtm"><img src="images/icon_view_new.png" border="0" alt="New view" title="New view"/></a>
    </td>
  </tr>
</table>
  
<div id="viewContent">
  <c:choose>
    <c:when test="${empty currentView}">
      You have not created any graphical views. Create one <a href="view_edit.shtm">now</a>.
    </c:when>
    <c:when test="${empty currentView.backgroundFilename}">
      <img id="viewBackground" src="images/spacer.gif" alt="" width="740" height="400"/>
    </c:when>
    <c:otherwise>
      <img id="viewBackground" src="${currentView.backgroundFilename}" alt=""/>
    </c:otherwise>
  </c:choose>
  
  <c:forEach items="${currentView.pointViews}" var="pv">
    <div id="c${pv.id}" onmouseover="showLayer('c${pv.id}Controls');" onmouseout="hideLayer('c${pv.id}Controls');"
            style="position:absolute;left:${pv.x}px;top:${pv.y}px;">
      <div id="c${pv.id}Content"><img src="images/icon_comp.png" alt=""/></div>
      <div id="c${pv.id}Controls" class="controlsDiv">
        <table cellpadding="0" cellspacing="1">
          <tr onmouseover="showMenu('c${pv.id}Info', 16, 0);" onmouseout="hideLayer('c${pv.id}Info');"><td>
            <img src="images/information.png" alt=""/>
            <div id="c${pv.id}Info" onmouseout="hideLayer(this);">
              <img src="images/hourglass.png" alt="Getting data..."/>
            </div>
          </td></tr>
          <tr id="c${pv.id}ChangeMin" style="display:none;" 
                  onmouseover="mango.view.showChange('c${pv.id}Change', 16, 0);" 
                  onmouseout="mango.view.hideChange('c${pv.id}Change');"><td>
            <img src="images/icon_edit.png" alt=""/>
            <div id="c${pv.id}Change" onmouseout="hideLayer(this);">
              <img src="images/hourglass.png" alt="Getting data..."/>
            </div>
          </td></tr>
          <c:if test="${!empty pv.dataPoint.chartRenderer}">
            <tr onmouseover="showMenu('c${pv.id}Chart', 16, 0);" onmouseout="hideLayer('c${pv.id}Chart');"><td>
              <img src="images/icon_chart.png" alt=""/>
              <div id="c${pv.id}Chart" onmouseout="hideLayer(this);">
                <img src="images/hourglass.png" alt="Getting data..."/>
              </div>
            </td></tr>
          </c:if>
        </table>
      </div>
      <div style="position:absolute;left:-16px;top:0px;z-index:1;">
        <div id="c${pv.id}Warning" style="display:none;"><img src="images/warn.png" alt="Warning"/><br/></div>
        <div id="c${pv.id}Changing" style="display:none;"><img src="images/icon_edit.png"
                alt="Setting value..."/><br/></div>
      </div>
    </div>
  </c:forEach>
</div>

<c:if test="${!empty currentView}">
  <script type="text/javascript">mango.view.startNormalView();</script>
</c:if>

<mango:footer/>