<%--
  Copyright (C) 2006-2007 Serotonin Software Technologies Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

  @author Matthew Lohbihler
--%>
<%@ include file="/WEB-INF/jsp/include/tech.jsp" %>
<%@page import="com.serotonin.mango.Common"%>
<mango:header onload="init()">
  <mango:style>
    <style>
    html > body .dojoTreeNodeLabelSelected {
        background-color: inherit;
        color: inherit;
    }
    .watchListAttr {
        min-width:600px;
    }
    .rowIcons img {
        padding-right: 3px;
    }
    html > body .dojoSplitContainerSizerH {
        border: 1px solid #FFFFFF;
        background-color: #F07800;
        margin-top:4px;
        margin-bottom:4px;
    }
    .wlComponentMin {
        top:0px;
        left:0px;
        position:relative;
        margin:0px;
        padding:0px;
        width:16px;
        height:16px;
    }
    </style>
  </mango:style>
  <mango:script src='dwr/interface/WatchListDwr.js'/>
  <mango:script src='resources/view.js'/>
  <mango:script>
    <script>
    dojo.require("dojo.widget.SplitContainer");
    dojo.require("dojo.widget.ContentPane");
    
    function init() {
        WatchListDwr.init(initCB);
        dojo.event.topic.subscribe("tree/titleClick", new TreeClickHandler(), 'handle');
    }
    
    function initCB(data) {
        // Create the point tree.
        var rootFolder = data.pointFolder;
        var tree = dojo.widget.manager.getWidgetById('tree');
        var i;
        
        for (i=0; i<rootFolder.subfolders.length; i++)
            addFolder(rootFolder.subfolders[i], tree);
        
        for (i=0; i<rootFolder.points.length; i++)
            addPoint(rootFolder.points[i], tree);
        
        hide("loadingImg");
        show("treeDiv");
        mango.view.initWatchlist(2000);
        
        // Add default points.
        displayWatchList(data.selectedWatchList);
        maybeDisplayDeleteImg();
    }
    
    function addFolder(folder, parent) {
        var folderNode = dojo.widget.createWidget("TreeNode", {
                title: "<img src='images/folder_brick.png'/> "+ folder.name, isFolder: "true" });
        parent.addChild(folderNode);
        
        var i;
        for (i=0; i<folder.subfolders.length; i++)
            addFolder(folder.subfolders[i], folderNode);
        
        for (i=0; i<folder.points.length; i++)
            addPoint(folder.points[i], folderNode);
    }
    
    function addPoint(point, parent) {
        var pointNode = dojo.widget.createWidget("TreeNode", {
                title: "<img src='images/icon_comp.png'/> <span id='ph"+ point.key +"Name'>"+ point.value +"</span> "+
                       "<img src='images/bullet_go.png' id='ph"+ point.key +"Image' title='Add to watch list'/>",
                object: point });
        parent.addChild(pointNode);
    }
    
    var TreeClickHandler = function() {
        this.handle = function(message) {
            var widget = message.source;
            if (!widget.isFolder)
                addToWatchList(widget.object.key);
        }
    }
    
    function displayWatchList(points) {
        // Add the new rows.
        for (var i=0; i<points.length; i++)
            addToWatchListImpl(points[i]);
        
        fixRowFormatting();
        mango.view.watchList.start();
        
        var select = $("watchListSelect");
        var txt = $("newWatchListName");
        $set(txt, select.options[select.selectedIndex].text);
    }
    
    function showWatchListEdit() {
        var wlEditDiv = $("wlEdit");
        var divBounds = getNodeBounds(wlEditDiv);
        var ancBounds = getNodeBounds(findRelativeAncestor(wlEditDiv));
        wlEditDiv.style.left = (ancBounds.w - divBounds.w - 30) +"px";
        dojo.html.setVisibility(wlEditDiv, true);
        $("newWatchListName").select();
    }

    function saveWatchListName() {
        var name = $get("newWatchListName");
        var select = $("watchListSelect");
        select.options[select.selectedIndex].text = name;
        WatchListDwr.updateWatchListName(name);
        hideLayer("wlEdit");
    }
    
    function watchListChanged() {
        mango.view.watchList.stop();
        
        // Clear the list.
        var rows = getElementsByMangoName($("watchListTable"), "watchListRow");
        for (var i=0; i<rows.length; i++)
            removeFromWatchListImpl(rows[i].id.substring(1));
        
        WatchListDwr.setSelectedWatchList($get("watchListSelect"), displayWatchList);
    }
    
    function addWatchList() {
        WatchListDwr.addNewWatchList(addWatchListCB);
    }
    
    function addWatchListCB(watchListData) {
        var wlselect = $("watchListSelect");
        wlselect.options[wlselect.options.length] = new Option(watchListData.value, watchListData.key);
        $set(wlselect, watchListData.key);
        watchListChanged();
        maybeDisplayDeleteImg();
    }
    
    function deleteWatchList() {
        var wlselect = $("watchListSelect");
        var deleteId = $get(wlselect);
        wlselect.options[wlselect.selectedIndex] = null;
        
        watchListChanged();
        WatchListDwr.deleteWatchList(deleteId);
        maybeDisplayDeleteImg();
    }
    
    function maybeDisplayDeleteImg() {
        var wlselect = $("watchListSelect");
        display("watchListDeleteImg", wlselect.options.length > 1);
    }
    
    
    //
    // Watch list membership
    //
    function addToWatchList(pointId) {
        // Check if this point is already in the watch list.
        if ($("p"+ pointId))
            return;
        addToWatchListImpl(pointId);
        WatchListDwr.addToWatchList(pointId, mango.view.watchList.setDataImpl);
        fixRowFormatting();
    }
    
    var watchListCount = 0;
    function addToWatchListImpl(pointId) {
        watchListCount++;
    
        // Add a row for the point by cloning the template row.
        var pointContent = createFromTemplate("p_TEMPLATE_", pointId, "watchListTable");
        pointContent.mangoName = "watchListRow";
        
        $("p"+ pointId +"Name").innerHTML = $("ph"+ pointId +"Name").innerHTML;
        
        // Disable the element in the point list.
        dojo.html.setOpacity($("ph"+ pointId +"Image"), 0.2);
    }
    
    function removeFromWatchList(pointId) {
        removeFromWatchListImpl(pointId);
        fixRowFormatting();
        WatchListDwr.removeFromWatchList(pointId);
    }
    
    function removeFromWatchListImpl(pointId) {
        watchListCount--;
        var pointContent = $("p"+ pointId);
        var watchListTable = $("watchListTable");
        watchListTable.removeChild(pointContent);
        
        // Enable the element in the point list.
        dojo.html.setOpacity($("ph"+ pointId +"Image"), 1);
    }
    
    //
    // List state updating
    //
    function moveRowDown(pointId) {
        var watchListTable = $("watchListTable");
        var rows = getElementsByMangoName(watchListTable, "watchListRow");
        var i=0;
        for (; i<rows.length; i++) {
            if (rows[i].id == pointId)
                break;
        }
        if (i < rows.length - 1) {
            if (i == rows.length - 1)
                watchListTable.append(rows[i]);
            else
                watchListTable.insertBefore(rows[i], rows[i+2]);
            WatchListDwr.moveDown(pointId.substring(1));
            fixRowFormatting();
        }
    }
    
    function moveRowUp(pointId) {
        var watchListTable = $("watchListTable");
        var rows = getElementsByMangoName(watchListTable, "watchListRow");
        var i=0;
        for (; i<rows.length; i++) {
            if (rows[i].id == pointId)
                break;
        }
        if (i != 0) {
            watchListTable.insertBefore(rows[i], rows[i-1]);
            WatchListDwr.moveUp(pointId.substring(1));
            fixRowFormatting();
        }
    }
    
    function fixRowFormatting() {
        var rows = getElementsByMangoName($("watchListTable"), "watchListRow");
        if (rows.length == 0) {
            dojo.html.show($("emptyListMessage"));
        }
        else {
            dojo.html.hide($("emptyListMessage"));
            for (var i=0; i<rows.length; i++) {
                if (i == 0) {
                    dojo.html.hide($(rows[i].id +"BreakRow"));
                    dojo.html.hide($(rows[i].id +"MoveUp"));
                }
                else {
                    dojo.html.show($(rows[i].id +"BreakRow"));
                    dojo.html.show($(rows[i].id +"MoveUp"));
                }
                    
                if (i == rows.length - 1)
                    dojo.html.hide($(rows[i].id +"MoveDown"));
                else
                    dojo.html.show($(rows[i].id +"MoveDown"));
            }
        }
    }
    
    
    //
    // Image chart
    //
    function getImageChart() {
        var period = parseInt($get("imageChartDuration"));
        var periodType = parseInt($get("imageChartDurationType"));
        var width = dojo.html.getContentBox($("imageChartDiv")).width - 20;
        
        if (isNaN(period))
            alert("Time period must be a number");
        else {
            WatchListDwr.getImageChartData(periodType, period, width, 200, getImageChartCB);
            startImageFader($("imageChartImg"));
        }
    }
    
    function getImageChartCB(data) {
        $("imageChartDiv").innerHTML = data;
        stopImageFader($("imageChartImg"));
        
        // Make sure the length of the chart doesn't mess up the watch list display. Do async to
        // make sure the rendering gets done.
        setTimeout('dojo.widget.manager.getWidgetById("splitContainer").onResized()', 2000);
    }
    </script>
  </mango:script>
</mango:header>

<table width="100%">
<tr><td>
  <div dojoType="SplitContainer" orientation="horizontal" sizerWidth="3" activeSizing="true" class="borderDiv"
          widgetId="splitContainer" style="width: 100%; height: 500px;">
    <div dojoType="ContentPane" sizeMin="20" sizeShare="20" style="overflow:auto;padding:2px;">
      <span class="smallTitle">Points</span> <mango:help id="VbifCme0Z1N5ymiEznBY"/><br/>
      <img src="images/hourglass.png" id="loadingImg"/>
      <div id="treeDiv" style="display:none;"><div dojoType="Tree" toggle="wipe" widgetId="tree"></div></div>
    </div>
    <div dojoType="ContentPane" sizeMin="50" sizeShare="50" style="overflow:auto; padding:2px 10px 2px 2px;">
      <table cellpadding="0" cellspacing="0" width="100%">
        <tr>
          <td class="smallTitle">Watch list <mango:help id="iXZb69eSrzO6WfsX9QnR"/></td>
          <td align="right">
            <sst:select id="watchListSelect" value="${selectedWatchList}" onchange="watchListChanged()">
              <c:forEach items="${watchLists}" var="wl">
                <sst:option value="${wl.key}">${wl.value}</sst:option>
              </c:forEach>
            </sst:select>
            <div style="display:inline;" onmouseover="showWatchListEdit()">
              <mango:img id="wlEditImg" png="pencil" title="Edit watch list name"/>
              <div id="wlEdit" style="visibility:hidden;left:0px;top:15px;" class="labelDiv"
                      onmouseout="hideLayer(this)">
                Enter the watch list's new name<br/>
                <input type="text" id="newWatchListName"
                        onkeypress="if (event.keyCode==13) $('saveWatchListNameLink').onclick();"/>
                <a class="ptr" id="saveWatchListNameLink" onclick="saveWatchListName()">Save</a>
              </div>
            </div>
            <mango:img png="add" onclick="addWatchList()" title="Add new watch list"/>
            <mango:img png="delete" id="watchListDeleteImg" onclick="deleteWatchList()" title="Delete this watch list"
                    style="display:none;"/>
          </td>
        </tr>
      </table>
      <div id="watchListDiv" class="watchListAttr">
        <table style="display:none;">
          <tbody id="p_TEMPLATE_">
            <tr id="p_TEMPLATE_BreakRow"><td class="horzSeparator" colspan="5"></td></tr>
            <tr>
              <td width="1">
                <table cellpadding="0" cellspacing="0" class="rowIcons">
                  <tr>
                    <td onmouseover="mango.view.showChange('p'+ getMangoId(this) +'Change', 4, 12);"
                            onmouseout="mango.view.hideChange('p'+ getMangoId(this) +'Change');"
                            id="p_TEMPLATE_ChangeMin" style="display:none;"><img alt="" id="p_TEMPLATE_Changing" 
                            src="images/icon_edit.png"/><div id="p_TEMPLATE_Change" class="labelDiv" 
                            style="visibility:hidden;top:10px;left:1px;" onmouseout="hideLayer(this);">
                      <img src="images/hourglass.png" alt="Getting data..."/>
                    </div></td>
                    <td onmouseover="showMenu('p'+ getMangoId(this) +'Chart', 4, 12);"
                            onmouseout="hideLayer('p'+ getMangoId(this) +'Chart');" id="p_TEMPLATE_ChartMin" 
                            style="display:none;"><img alt="" src="images/icon_chart.png"/><div id="p_TEMPLATE_Chart" 
                            class="labelDiv" style="visibility:hidden;top:0;left:0;" onmouseout="hideLayer(this);">
                      <img src="images/hourglass.png" alt="Getting data..."/>
                    </div></td>
                  </tr>
                </table>
              </td>
              <td id="p_TEMPLATE_Name" style="font-weight:bold"></td>
              <td id="p_TEMPLATE_Value" align="center"><img src="images/hourglass.png"/></td>
              <td id="p_TEMPLATE_Time" align="center"></td>
              <td width="54">
                <img src="images/icon_comp.png" class="ptr" alt="" title="Point details"
                        onclick="window.location='data_point_details.shtm?dpid='+ getMangoId(this)"/>
                <img src="images/arrow_up_thin.png" id="p_TEMPLATE_MoveUp" alt="" title="Move up" 
                        class="ptr" onclick="moveRowUp('p'+ getMangoId(this));"/><img 
                        src="images/arrow_down_thin.png" id="p_TEMPLATE_MoveDown" alt="" title="Move down" 
                        class="ptr" onclick="moveRowDown('p'+ getMangoId(this));"/>
                <img src="images/bullet_delete.png" class="ptr" alt="" title="Delete from watch list"
                        onclick="removeFromWatchList(getMangoId(this))"/>
              </td>
            </tr>
            <tr><td colspan="5" style="padding-left:16px;">
              <div id="p_TEMPLATE_Disabled" style="display:none">
                <img src="images/warn.png" alt="Warning" title="Warning"/>
                The point or its data source may be disabled.
              </div>
              <div id="p_TEMPLATE_Events"></div>
            </td></tr>
          </tbody>
        </table>
        <table id="watchListTable" width="100%"></table>
        <div id="emptyListMessage" style="color:#888888;padding:10px;text-align:center;">
          Click on points to add them to the watch list.
        </div>
      </div>
    </div>
  </div>
</td></tr>

<tr><td>
  <div class="borderDiv" style="width: 100%;">
    <table width="100%">
      <tr>
        <td class="smallTitle">Chart <mango:help id="HyQoCVy96Qx71hGb32FG"/></td>
        <td align="right">
          Time period:
          <input id="imageChartDuration" style="text-align:right;" type="text" value="1" class="formVeryShort"/>
          <select id="imageChartDurationType">
            <option value="<%= Integer.toString(Common.TimePeriods.MINUTES) %>">Minute(s)</option>
            <option value="<%= Integer.toString(Common.TimePeriods.HOURS) %>" selected="selected">Hour(s)</option>
            <option value="<%= Integer.toString(Common.TimePeriods.DAYS) %>">Day(s)</option>
          </select>
          <img id="imageChartImg" src="images/control_play_blue.png" title="Get chart" alt="" class="ptr" 
                  onclick="getImageChart()"/>
        </td>
      </tr>
      <tr><td colspan="2" id="imageChartDiv"></td></tr>
    </table>
  </div>
</td></tr>

</table>

<mango:footer/>