dojo.require("dojo.widget.*");
dojo.require("dojo.widget.FloatingPane");

//
// Error handling
window.onerror = function mangoHandler(desc, page, line)  {
    BrowserDetect.init();
    if (checkCombo(BrowserDetect.browser, BrowserDetect.version, BrowserDetect.OS)) {
        MiscDwr.jsError(desc, page, line, BrowserDetect.browser, BrowserDetect.version, BrowserDetect.OS,
                window.location.href);
    }
    return false;
}

function dwrErrorHandler(message, ex) {
    if (ex.javaClassName == 'com.serotonin.mango.vo.permission.PermissionException')
        alert(ex.message);
    else
        dwr.engine.defaultErrorHandler(message, ex);
}

//
// Alarms
mango.alarmLevel = 0;
function __header__evtCheck() {
    MiscDwr.getHighestActiveAlarmLevel(__header__evtCheckCB);
}

function __header__evtCheckCB(level) {
    if (level != mango.alarmLevel) {
        mango.alarmLevel = level;
        if (level > 0) {
            setAlarmLevelImg(level, $("__header__alarmLevelImg"));
            setAlarmLevelText(level, $("__header__alarmLevelText"));
            if (!__header__evtVisualizer.started)
                __header__evtVisualizer.start();
            dojo.html.show($("__header__alarmLevelDiv"));
            mango.soundPlayer.play("level"+ level);
        }
        else {
            dojo.html.hide($("__header__alarmLevelDiv"));
            __header__evtVisualizer.stop();
            mango.soundPlayer.stop();
        }
    }
    setTimeout(__header__evtCheck, 2000); // Check again every 3 seconds.
}

function hMD(desc, source) {
    var c = $("headerMenuDescription");
    if (desc) {
        var bounds = getAbsoluteNodeBounds(source);
        c.innerHTML = desc;
        c.style.left = (bounds.x + 16) +"px";
        c.style.top = (bounds.y - 10) +"px";
        show(c);
    }
    else
        hide(c);
}

//
// Help
function help(documentId, source) {
    var widgetId = "documentationPane";
    var widget = dojo.widget.manager.getWidgetById(widgetId);
    if (widget)
        widget.closeWindow();

    var div = document.createElement("div");
    div.style.position = "absolute";
    div.style.width = "400px";
    div.style.height = "300px";
    if (source) {
        var bounds = getAbsoluteNodeBounds(source);
        div.style.left = (bounds.x + bounds.w) +"px";
        div.style.top = (bounds.y + bounds.h) +"px";
    }
    else {
        div.style.left = "10px";
        div.style.top = "10px";
    }
    
    document.body.appendChild(div);
    
    var params = {
            widgetId: widgetId, title: "Loading...", constrainToContainer: false, displayCloseAction: true, 
            displayMinimizeAction: false, displayMaximizeAction: false, resizable: true, hasShadow: true,
            iconSrc: "images/help_doc.png"};
    
    dojo.widget.createWidget("FloatingPane", params, div);
    helpImpl(documentId);
}

function helpImpl(documentId) {
    MiscDwr.getDocumentationItem(documentId, helpCB);
}

function helpCB(result) {
    var widgetId = "documentationPane";
    var widget = dojo.widget.manager.getWidgetById(widgetId);
    
    if (result.error) {
        widget.titleBarText.innerHTML = "Error";
        $("documentationPane_container").innerHTML = result.error;
    }
    else {
        widget.titleBarText.innerHTML = result.title;
        var content = result.content;
        if (result.relatedList && result.relatedList.length > 0) {
            content += "<p><b>Related items</b><br/>";
            for (var i=0; i<result.relatedList.length; i++)
                content += "<a class='ptr' onclick='helpImpl(\""+ result.relatedList[i].id +"\");'>"+
                        result.relatedList[i].title +"</a><br/>";
            content += "</p>";
        }
        if (result.lastUpdated)
            content += "<p>Last updated: "+ result.lastUpdated +"</p>";
        $("documentationPane_container").innerHTML = content;
    }
}

//
// Sound related stuff
soundManager.debugMode = false;
soundManager.onloadFinished = false;
soundManager.onload = function() {
    soundManager.createSound({ id:'level1', url:'audio/information.mp3' });
    soundManager.createSound({ id:'level2', url:'audio/urgent.mp3' });
    soundManager.createSound({ id:'level3', url:'audio/critical.mp3' });
    soundManager.createSound({ id:'level4', url:'audio/lifesafety.mp3' });
    soundManager.onloadFinished = true;
}

function SoundPlayer() {
    this.soundId;
    var self = this;
    
    this.play = function(soundId) {
        this.stop();
        this.soundId = soundId;
        this._repeat();
    };
    
    this.stop = function() {
        if (this.soundId) {
            var sid = this.soundId;
            this.soundId = null;
            soundManager.stop(sid);
        }
    };
    
    this._repeat = function() {
        if (soundManager.onloadFinished) {
            if (self.soundId)
                soundManager.play(self.soundId, { onfinish: self._repeatDelay } );
        }
        else
            // Wait for the sound manager to load.
            setTimeout(self._repeat, 500);
    };
    
    this._repeatDelay = function() {
        if (self.soundId)
            setTimeout(self._repeat, 10000);
    }
};
mango.soundPlayer = new SoundPlayer();

//
// Browser detection
var BrowserDetect = {
    init: function () {
        this.browser = this.searchString(this.dataBrowser) || "An unknown browser";
        this.version = this.searchVersion(navigator.userAgent)
            || this.searchVersion(navigator.appVersion)
            || "an unknown version";
        this.OS = this.searchString(this.dataOS) || "an unknown OS";
    },
    searchString: function (data) {
        for (var i=0;i<data.length;i++) {
            var dataString = data[i].string;
            var dataProp = data[i].prop;
            this.versionSearchString = data[i].versionSearch || data[i].identity;
            if (dataString) {
                if (dataString.indexOf(data[i].subString) != -1)
                    return data[i].identity;
            }
            else if (dataProp)
                return data[i].identity;
        }
    },
    searchVersion: function (dataString) {
        var index = dataString.indexOf(this.versionSearchString);
        if (index == -1) return;
        return parseFloat(dataString.substring(index+this.versionSearchString.length+1));
    },
    dataBrowser: [
        {   string: navigator.userAgent,
            subString: "OmniWeb",
            versionSearch: "OmniWeb/",
            identity: "OmniWeb"
        },
        {
            string: navigator.vendor,
            subString: "Apple",
            identity: "Safari"
        },
        {
            prop: window.opera,
            identity: "Opera"
        },
        {
            string: navigator.vendor,
            subString: "iCab",
            identity: "iCab"
        },
        {
            string: navigator.vendor,
            subString: "KDE",
            identity: "Konqueror"
        },
        {
            string: navigator.userAgent,
            subString: "Firefox",
            identity: "Firefox"
        },
        {
            string: navigator.vendor,
            subString: "Camino",
            identity: "Camino"
        },
        {       // for newer Netscapes (6+)
            string: navigator.userAgent,
            subString: "Netscape",
            identity: "Netscape"
        },
        {
            string: navigator.userAgent,
            subString: "MSIE",
            identity: "Explorer",
            versionSearch: "MSIE"
        },
        {
            string: navigator.userAgent,
            subString: "Gecko",
            identity: "Mozilla",
            versionSearch: "rv"
        },
        {       // for older Netscapes (4-)
            string: navigator.userAgent,
            subString: "Mozilla",
            identity: "Netscape",
            versionSearch: "Mozilla"
        }
    ],
    dataOS : [
        {
            string: navigator.platform,
            subString: "Win",
            identity: "Windows"
        },
        {
            string: navigator.platform,
            subString: "Mac",
            identity: "Mac"
        },
        {
            string: navigator.platform,
            subString: "Linux",
            identity: "Linux"
        }
    ]

};

function checkCombo(browser, version, os) {
    if (browser == "Firefox" && version == "2" && os == "Windows")
        return true;
    if (browser == "Explorer" && version == "7" && os == "Windows")
        return true;
    return false;
}