mango.view = {};

mango.view.rate; 
mango.view.setEditing = false;

mango.view.setData = function(stateArr) {
    var state;
    for (var i=0; i<stateArr.length; i++) {
        state = stateArr[i];
        
        // Check that the point exists. Ignore if it doesn't.
        if (!document.getElementById("c"+ state.id))
            throw "Can't find point view c"+ state.id;
        
        if (state.content)
            $("c"+ state.id +"Content").innerHTML = state.content;
        $set("c"+ state.id +"Info", state.info);
        if (state.change && !mango.view.setEditing) {
            show("c"+ state.id +"ChangeMin");
            $set("c"+ state.id +"Change", state.change);
        }
        if (state.chart)
            $set("c"+ state.id +"Chart", state.chart);
        if (state.disabled || state.maxAlarmLevel > -1)
            show($("c"+ state.id +"Warning"));
        else
            hide($("c"+ state.id +"Warning"));
    }
}

mango.view.showChange = function(divId, xoffset, yoffset) {
    mango.view.setEditing = true;
    var theDiv = $(divId);
    showMenu(theDiv, xoffset, yoffset);
    
    // Automatically select the text in text boxes
    var inputElems = theDiv.getElementsByTagName("input");
    for (var i=0; i<inputElems.length; i++) {
        if (inputElems[i].id.startsWith("txtChange")) {
            var temp = inputElems[i].value;
            inputElems[i].value += " ";
            inputElems[i].value = temp;
            inputElems[i].select();
        }
    }
}

mango.view.hideChange = function(divId) {
    hideLayer($(divId));
    mango.view.setEditing = false;
}

mango.view.setRate = function(rate) {
    if (!rate)
        rate = 2000;
    if (rate < 1000)
        rate = 1000; 
    mango.view.rate = rate;
}


//
// Anonymous views
mango.view.startAnonymousView = function(viewId, rate) {
    mango.view.anon.viewId = viewId;
    mango.view.setRate(rate);
    mango.view.setPoint = mango.view.anon.setPoint;
    mango.view.anon.scheduledGetData();
}

mango.view.anon = {};
mango.view.anon.scheduledGetData = function() {
    ViewDwr.getViewPointDataAnon(mango.view.anon.viewId, mango.view.anon.scheduledSetData);
}

mango.view.anon.scheduledSetData = function(stateArr) {
    mango.view.setData(stateArr);
    setTimeout(mango.view.anon.scheduledGetData, mango.view.rate);
}

mango.view.anon.getData = function() {
    ViewDwr.getViewPointDataAnon(mango.view.anon.viewId, mango.view.setData);
}

mango.view.anon.setPoint = function(pointId, pointViewId, value) {
    show("c"+ pointViewId +"Changing");
    mango.view.hideChange("c"+ pointViewId +"Change");
    ViewDwr.setViewPointAnon(mango.view.anon.viewId, pointViewId, value, mango.view.anon.setPointCB);
}

mango.view.anon.setPointCB = function(pointViewId) {
    hide("c"+ pointViewId +"Changing");
    mango.view.anon.getData();
}


//
// Normal views
mango.view.startNormalView = function(rate) {
    mango.view.setRate(rate);
    mango.view.setPoint = mango.view.norm.setPoint;
    mango.view.norm.scheduledGetData();
}

mango.view.norm = {};
mango.view.norm.scheduledGetData = function() {
    ViewDwr.getViewPointData(mango.view.norm.scheduledSetData);
}

mango.view.norm.scheduledSetData = function(stateArr) {
    mango.view.setData(stateArr);
    setTimeout(mango.view.norm.scheduledGetData, mango.view.rate);
}

mango.view.norm.getData = function() {
    ViewDwr.getViewPointData(mango.view.setData);
}

mango.view.norm.setPoint = function(pointId, pointViewId, value) {
    show("c"+ pointViewId +"Changing");
    mango.view.hideChange("c"+ pointViewId +"Change");
    ViewDwr.setViewPoint(pointViewId, value, mango.view.norm.setPointCB);
}

mango.view.norm.setPointCB = function(pointViewId) {
    hide("c"+ pointViewId +"Changing");
    mango.view.norm.getData();
}


//
// Watchlist
mango.view.initWatchlist = function(rate) {
    mango.view.setRate(rate);
    mango.view.setPoint = mango.view.watchList.setPoint;
}

mango.view.watchList = {};
mango.view.watchList.start = function() {
    WatchListDwr.getPointData(mango.view.watchList.scheduledSetData);
}

mango.view.watchList.stop = function() {
    if (mango.view.watchList.timeoutName)
        clearTimeout(mango.view.watchList.timeoutName);
}

mango.view.watchList.scheduledSetData = function(stateArr) {
    mango.view.watchList.setData(stateArr);
    mango.view.watchList.timeoutName = setTimeout(mango.view.watchList.start, mango.view.rate);
}

mango.view.watchList.getData = function() {
    WatchListDwr.getPointData(mango.view.watchList.setData);
}

mango.view.watchList.setPoint = function(pointId, componentId, value) {
    startImageFader("p"+ pointId +"Changing");
    mango.view.hideChange("p"+ pointId +"Change");
    WatchListDwr.setPoint(pointId, componentId, value, mango.view.watchList.setPointCB);
}

mango.view.watchList.setPointCB = function(pointId) {
    stopImageFader("p"+ pointId +"Changing");
    mango.view.watchList.getData();
}

mango.view.watchList.setData = function(stateArr) {
    for (var i=0; i<stateArr.length; i++)
        mango.view.watchList.setDataImpl(stateArr[i]);
}
    
mango.view.watchList.setDataImpl = function(state) {
    // Check that the point exists. Ignore if it doesn't.
    if (state && $("p"+ state.id)) {
        var node = $("p"+ state.id +"Value");
        if (state.value != null && state.value != node.innerHTML) {
            node.innerHTML = state.value;
            dojo.html.addClass(node, "viewChangeBkgd");
        }
        else
            dojo.html.removeClass(node, "viewChangeBkgd");
        
        var node = $("p"+ state.id +"Time");
        if (state.time) {
            $("p"+ state.id +"Time").innerHTML = state.time;
            dojo.html.addClass(node, "viewChangeBkgd");
        }
        else
            dojo.html.removeClass(node, "viewChangeBkgd");
        
        if (state.change) {
            dojo.html.show($("p"+ state.id +"ChangeMin"));
            if (!mango.view.setEditing)
                $set("p"+ state.id +"Change", state.change);
        }
        
        if (state.chart) {
            dojo.html.show($("p"+ state.id +"ChartMin"));
            $set("p"+ state.id +"Chart", state.chart);
        }
        
        if (state.disabled)
            dojo.html.show($("p"+ state.id +"Disabled"));
        else
            dojo.html.hide($("p"+ state.id +"Disabled"));
        
        if (state.messages)
            $("p"+ state.id +"Events").innerHTML = state.messages;
        else
            $("p"+ state.id +"Events").innerHTML = "";
    }
}


//
// Point details
mango.view.startPointDetails = function(rate) {
    mango.view.setRate(rate);
    mango.view.setPoint = mango.view.pointDetails.setPoint;
    mango.view.pointDetails.scheduledGetData();
}

mango.view.pointDetails = {};
mango.view.pointDetails.scheduledGetData = function() {
    DataPointDetailsDwr.getPointData(mango.view.pointDetails.scheduledSetData);
}

mango.view.pointDetails.scheduledSetData = function(state) {
    mango.view.pointDetails.setDataImpl(state);
    setTimeout(mango.view.pointDetails.scheduledGetData, mango.view.rate);
}

mango.view.pointDetails.getData = function() {
    DataPointDetailsDwr.getPointData(mango.view.pointDetails.setDataImpl);
}

mango.view.pointDetails.setPoint = function(pointId, componentId, value) {
    startImageFader("pointChanging");
    DataPointDetailsDwr.setPoint(pointId, componentId, value, mango.view.pointDetails.setPointCB);
}

mango.view.pointDetails.setPointCB = function(componentId) {
    stopImageFader("pointChanging");
    mango.view.pointDetails.getData();
}

mango.view.pointDetails.setDataImpl = function(state) {
    if (state.value)
        $("pointValue").innerHTML = state.value;
    
    if (state.time)
        $("pointValueTime").innerHTML = state.time;
    
    if (state.change) {
        dojo.html.show($("pointChangeNode"));
        $set("pointChange", state.change);
    }
    
    if (state.disabled)
        dojo.html.show($("pointDisabled"));
    else
        dojo.html.hide($("pointDisabled"));
}
